'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: October 18, 2003
'=============================================

Public Class LBImages
    Public Class TilesetItem
        Public FileName As String
        Public Image As Bitmap
    End Class

    Private mobjLB As ListBox
    Private mobjThumbSize As Size = New Size(64, 64)


    Public Sub Add(ByVal ImageFileName As String)
        Dim objItem As TilesetItem

        objItem = New TilesetItem()
        objItem.FileName = ImageFileName
        objItem.Image = New Bitmap(objItem.FileName)
        mobjLB.Items.Add(objItem)
    End Sub

    Default Public ReadOnly Property Items(ByVal Index As Integer) As TilesetItem
        Get
            Return CType(mobjLB.Items.Item(Index), TilesetItem)
        End Get
    End Property

    Public Sub New(ByVal LB As ListBox)
        MyBase.new()
        mobjLB = LB
        AddHandler mobjLB.DrawItem, AddressOf Me.DrawItem
        AddHandler mobjLB.MeasureItem, AddressOf Me.MeasureItem
    End Sub

    Public Sub New(ByVal LB As ListBox, ByVal ThimbSize As Size)
        MyBase.new()
        mobjLB = LB
        mobjThumbSize = ThumbnailSize
        AddHandler mobjLB.DrawItem, AddressOf Me.DrawItem
        AddHandler mobjLB.MeasureItem, AddressOf Me.MeasureItem
    End Sub

    Private Sub MeasureItem(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MeasureItemEventArgs)
        Dim strTmp As String
        Dim objItem As TilesetItem

        If e.Index = -1 Then Exit Sub

        objItem = CType(mobjLB.Items.Item(e.Index), TilesetItem)
        strTmp = IO.Path.GetFileName(objItem.FileName) & " - " & objItem.FileName
        e.ItemWidth = CInt(e.Graphics.MeasureString(strTmp, mobjLB.Font).Width)
        If mobjThumbSize.Width > e.ItemWidth Then e.ItemWidth = mobjThumbSize.Width
        mobjLB.HorizontalExtent = e.ItemWidth
        e.ItemHeight = mobjThumbSize.Height + 4 + mobjLB.Font.Height + 4
    End Sub

    Private Sub DrawItem(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DrawItemEventArgs)
        Dim strText As String
        Dim objItem As TilesetItem


        If e.Index = -1 Then Exit Sub

        objItem = CType(mobjLB.Items.Item(e.Index), TilesetItem)

        strText = IO.Path.GetFileName(objItem.FileName) & " - " & objItem.FileName
        e.DrawBackground()

        ' Draw image
        e.Graphics.DrawImage(objItem.Image, New Rectangle(e.Bounds.Location, mobjThumbSize), _
                            New Rectangle(New Point(0, 0), objItem.Image.Size), GraphicsUnit.Pixel)

        ' draw text
        e.Graphics.DrawString(strText, e.Font, New SolidBrush(mobjLB.ForeColor), 0, e.Bounds.Top + mobjThumbSize.Height + 4)

        ''draw check mark is selected
        'If e.State = DrawItemState.Selected Then
        '    e.Graphics.DrawImage(imlPics.Images(0), New Rectangle(e.Bounds.Location, imlPics.Images(0).Size))
        'End If

        'draw focus
        If e.State = DrawItemState.Focus Then e.DrawFocusRectangle()
    End Sub

    Public Property ThumbnailSize() As Size
        Get
            Return mobjThumbSize
        End Get
        Set(ByVal Value As Size)
            mobjThumbSize = Value
        End Set
    End Property

    Protected Overrides Sub Finalize()
        MyBase.Finalize()
        RemoveHandler mobjLB.DrawItem, AddressOf Me.DrawItem
        RemoveHandler mobjLB.MeasureItem, AddressOf Me.MeasureItem
        mobjLB = Nothing
    End Sub
End Class