Namespace Helpers
    Public Class Conversion
        Public Shared Function Vector2ToPoint(ByVal V As Vector2) As Point
            Return New Point(CInt(V.X), CInt(V.Y))
        End Function
    End Class

    Public Structure SpriteStruct
        Implements Interfaces.ISprite

        Private mintTextureIndex, mintLayer As Integer
        Private mobjScaling, mobjRotationCenter, mobjTranslation As Vector2
        Private mobjSourceRectangle As Rectangle
        Private msngRotation As Single
        Private mobjColor As Color
        Private mobjSector As SectorIndex

        Public Property Color() As System.Drawing.Color Implements CBX.Games.Spritz3DR1.Interfaces.ISprite.Color
            Get
                Return mobjColor
            End Get
            Set(ByVal Value As System.Drawing.Color)
                mobjColor = Value
            End Set
        End Property

        Public Property Layer() As Integer Implements CBX.Games.Spritz3DR1.Interfaces.ISprite.Layer
            Get
                Return mintLayer
            End Get
            Set(ByVal Value As Integer)
                mintLayer = Value
            End Set
        End Property

        Public Property Rotation() As Single Implements CBX.Games.Spritz3DR1.Interfaces.ISprite.Rotation
            Get
                Return msngRotation
            End Get
            Set(ByVal Value As Single)
                msngRotation = Value
            End Set
        End Property

        Public Property RotationCenter() As Microsoft.DirectX.Vector2 Implements CBX.Games.Spritz3DR1.Interfaces.ISprite.RotationCenter
            Get
                Return mobjRotationCenter
            End Get
            Set(ByVal Value As Microsoft.DirectX.Vector2)
                mobjRotationCenter = Value
            End Set
        End Property

        Public Property Scaling() As Microsoft.DirectX.Vector2 Implements CBX.Games.Spritz3DR1.Interfaces.ISprite.Scaling
            Get
                Return mobjScaling
            End Get
            Set(ByVal Value As Microsoft.DirectX.Vector2)
                mobjScaling = Value
            End Set
        End Property

        Public Property Sector() As CBX.Games.Spritz3DR1.SectorIndex Implements CBX.Games.Spritz3DR1.Interfaces.ISprite.Sector
            Get
                Return mobjSector
            End Get
            Set(ByVal Value As CBX.Games.Spritz3DR1.SectorIndex)
                mobjSector = Value
            End Set
        End Property

        Public Property SourceRectangle() As System.Drawing.Rectangle Implements CBX.Games.Spritz3DR1.Interfaces.ISprite.SourceRectangle
            Get
                Return mobjSourceRectangle
            End Get
            Set(ByVal Value As System.Drawing.Rectangle)
                mobjSourceRectangle = Value
            End Set
        End Property

        Public Property TextureIndex() As Integer Implements CBX.Games.Spritz3DR1.Interfaces.ISprite.TextureIndex
            Get
                Return mintTextureIndex
            End Get
            Set(ByVal Value As Integer)
                mintTextureIndex = Value
            End Set
        End Property

        Public Property Translation() As Microsoft.DirectX.Vector2 Implements CBX.Games.Spritz3DR1.Interfaces.ISprite.Translation
            Get
                Return mobjTranslation
            End Get
            Set(ByVal Value As Microsoft.DirectX.Vector2)
                mobjTranslation = Value
            End Set
        End Property
    End Structure

    Public Class SpriteObject
        Implements Interfaces.ISprite

        Private mintTextureIndex, mintLayer As Integer
        Private mobjScaling, mobjRotationCenter, mobjTranslation As Vector2
        Private mobjSourceRectangle As Rectangle
        Private msngRotation As Single
        Private mobjColor As Color
        Private mobjSector As SectorIndex

        Public Property Color() As System.Drawing.Color Implements CBX.Games.Spritz3DR1.Interfaces.ISprite.Color
            Get
                Return mobjColor
            End Get
            Set(ByVal Value As System.Drawing.Color)
                mobjColor = Value
            End Set
        End Property

        Public Property Layer() As Integer Implements CBX.Games.Spritz3DR1.Interfaces.ISprite.Layer
            Get
                Return mintLayer
            End Get
            Set(ByVal Value As Integer)
                mintLayer = Value
            End Set
        End Property

        Public Property Rotation() As Single Implements CBX.Games.Spritz3DR1.Interfaces.ISprite.Rotation
            Get
                Return msngRotation
            End Get
            Set(ByVal Value As Single)
                msngRotation = Value
            End Set
        End Property

        Public Property RotationCenter() As Microsoft.DirectX.Vector2 Implements CBX.Games.Spritz3DR1.Interfaces.ISprite.RotationCenter
            Get
                Return mobjRotationCenter
            End Get
            Set(ByVal Value As Microsoft.DirectX.Vector2)
                mobjRotationCenter = Value
            End Set
        End Property

        Public Property Scaling() As Microsoft.DirectX.Vector2 Implements CBX.Games.Spritz3DR1.Interfaces.ISprite.Scaling
            Get
                Return mobjScaling
            End Get
            Set(ByVal Value As Microsoft.DirectX.Vector2)
                mobjScaling = Value
            End Set
        End Property

        Public Property Sector() As CBX.Games.Spritz3DR1.SectorIndex Implements CBX.Games.Spritz3DR1.Interfaces.ISprite.Sector
            Get
                Return mobjSector
            End Get
            Set(ByVal Value As CBX.Games.Spritz3DR1.SectorIndex)
                mobjSector = Value
            End Set
        End Property

        Public Property SourceRectangle() As System.Drawing.Rectangle Implements CBX.Games.Spritz3DR1.Interfaces.ISprite.SourceRectangle
            Get
                Return mobjSourceRectangle
            End Get
            Set(ByVal Value As System.Drawing.Rectangle)
                mobjSourceRectangle = Value
            End Set
        End Property

        Public Property TextureIndex() As Integer Implements CBX.Games.Spritz3DR1.Interfaces.ISprite.TextureIndex
            Get
                Return mintTextureIndex
            End Get
            Set(ByVal Value As Integer)
                mintTextureIndex = Value
            End Set
        End Property

        Public Property Translation() As Microsoft.DirectX.Vector2 Implements CBX.Games.Spritz3DR1.Interfaces.ISprite.Translation
            Get
                Return mobjTranslation
            End Get
            Set(ByVal Value As Microsoft.DirectX.Vector2)
                mobjTranslation = Value
            End Set
        End Property
    End Class
End Namespace