Public Class ColorSelect
    Inherits System.Windows.Forms.Control
    Private menuTextAlign As ContentAlignment = ContentAlignment.MiddleLeft
    Private menuColorAlign As ContentAlignment = ContentAlignment.MiddleRight

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'UserControl overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents dlgColor As System.Windows.Forms.ColorDialog
    Friend WithEvents lblCaption As System.Windows.Forms.Label
    Friend WithEvents pbColor As System.Windows.Forms.PictureBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.dlgColor = New System.Windows.Forms.ColorDialog()
        Me.lblCaption = New System.Windows.Forms.Label()
        Me.pbColor = New System.Windows.Forms.PictureBox()
        Me.SuspendLayout()
        '
        'lblCaption
        '
        Me.lblCaption.AutoSize = True
        Me.lblCaption.Location = New System.Drawing.Point(8, 6)
        Me.lblCaption.Name = "lblCaption"
        Me.lblCaption.Size = New System.Drawing.Size(63, 13)
        Me.lblCaption.TabIndex = 0
        Me.lblCaption.Text = "ColorSelect"
        Me.lblCaption.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'pbColor
        '
        Me.pbColor.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.pbColor.Location = New System.Drawing.Point(80, 0)
        Me.pbColor.Name = "pbColor"
        Me.pbColor.Size = New System.Drawing.Size(32, 24)
        Me.pbColor.TabIndex = 1
        Me.pbColor.TabStop = False
        '
        'ColorSelect
        '
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.pbColor, Me.lblCaption})
        Me.Size = New System.Drawing.Size(112, 24)
        Me.ResumeLayout(False)

    End Sub

#End Region

    Public ReadOnly Property LabelControl() As Label
        Get
            Return lblCaption
        End Get
    End Property

    Public ReadOnly Property PictureBoxControl() As PictureBox
        Get
            Return pbColor
        End Get
    End Property

    Property Color() As Color
        Get
            Return pbColor.BackColor
        End Get
        Set(ByVal Value As Color)
            pbColor.BackColor = Value
        End Set
    End Property

    <Category("Appearence")> _
    Public Property TextAlignment() As ContentAlignment
        Get
            Return menuTextAlign
        End Get
        Set(ByVal Value As ContentAlignment)
            menuTextAlign = Value
            PositionControl(Value, lblCaption)
        End Set
    End Property

    <Category("Appearence")> _
    Public Property ColorAlignment() As ContentAlignment
        Get
            Return menuColorAlign
        End Get
        Set(ByVal Value As ContentAlignment)
            menuColorAlign = Value
            PositionControl(Value, pbColor)
        End Set
    End Property

    Private Sub PositionControl(ByVal Align As ContentAlignment, ByVal Ctrl As Control)
        Select Case Align
            Case ContentAlignment.BottomCenter
                Ctrl.Location = New Point((Me.Width \ 2) - (Ctrl.Width \ 2), Me.Height - Ctrl.Height)

            Case ContentAlignment.BottomLeft
                Ctrl.Location = New Point(0, Me.Height - Ctrl.Height)

            Case ContentAlignment.BottomRight
                Ctrl.Location = New Point(Me.Width - Ctrl.Width, Me.Height - Ctrl.Height)

            Case ContentAlignment.MiddleCenter
                Ctrl.Location = New Point((Me.Width \ 2) - (Ctrl.Width \ 2), (Me.Height \ 2) - (Ctrl.Height \ 2))

            Case ContentAlignment.MiddleLeft
                Ctrl.Location = New Point(0, (Me.Height \ 2) - (Ctrl.Height \ 2))

            Case ContentAlignment.MiddleRight
                Ctrl.Location = New Point(Me.Width - Ctrl.Width, (Me.Height \ 2) - (Ctrl.Height \ 2))

            Case ContentAlignment.TopCenter
                Ctrl.Location = New Point((Me.Width \ 2) - (Ctrl.Width \ 2), 0)

            Case ContentAlignment.TopLeft
                Ctrl.Location = New Point(0, 0)

            Case ContentAlignment.TopRight
                Ctrl.Location = New Point(Me.Width - Ctrl.Width, 0)

        End Select
    End Sub

    Private Sub ArrangeControls(ByVal sender As Object, ByVal e As System.EventArgs) Handles lblCaption.Resize, MyBase.Resize
        PositionControl(menuColorAlign, pbColor)
        PositionControl(menuTextAlign, lblCaption)
    End Sub

    Private Sub pbColor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pbColor.Click
        With dlgColor
            .Color = pbColor.BackColor
            Select Case .ShowDialog(Me)
                Case DialogResult.OK
                    pbColor.BackColor = .Color
                Case DialogResult.Cancel
            End Select
        End With
    End Sub

    'Private Sub ColorSelect_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint
    '    Dim R As RectangleF

    '    R = New RectangleF(CSng(lblCaption.Left), CSng(lblCaption.Top), CSng(lblCaption.Width), CSng(lblCaption.Height))
    '    e.Graphics.DrawString(Me.Text, Me.Font, New SolidBrush(Me.ForeColor), R)
    'End Sub

    Public Overrides Property Text() As String
        Get
            Return lblCaption.Text
        End Get
        Set(ByVal Value As String)
            lblCaption.Text = Value
        End Set
    End Property

    Public Sub DoSetColor()
        pbColor_Click(Nothing, Nothing)
    End Sub
End Class