Public Class FolderTreeView
    Inherits System.Windows.Forms.UserControl

    Private mstrRootPath As String
    Private menuAttributes As IO.FileAttributes = IO.FileAttributes.Directory
    Public Event NodeClick(ByVal Node As TreeNode)
#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
    End Sub

    'UserControl overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents tvFolders As System.Windows.Forms.TreeView
    Friend WithEvents imlImages As System.Windows.Forms.ImageList
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(FolderTreeView))
        Me.tvFolders = New System.Windows.Forms.TreeView()
        Me.imlImages = New System.Windows.Forms.ImageList(Me.components)
        Me.SuspendLayout()
        '
        'tvFolders
        '
        Me.tvFolders.Dock = System.Windows.Forms.DockStyle.Fill
        Me.tvFolders.HideSelection = False
        Me.tvFolders.ImageList = Me.imlImages
        Me.tvFolders.Name = "tvFolders"
        Me.tvFolders.ShowPlusMinus = False
        Me.tvFolders.Size = New System.Drawing.Size(184, 248)
        Me.tvFolders.Sorted = True
        Me.tvFolders.TabIndex = 0
        '
        'imlImages
        '
        Me.imlImages.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit
        Me.imlImages.ImageSize = New System.Drawing.Size(16, 16)
        Me.imlImages.ImageStream = CType(resources.GetObject("imlImages.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.imlImages.TransparentColor = System.Drawing.Color.Transparent
        '
        'FolderTreeView
        '
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.tvFolders})
        Me.Name = "FolderTreeView"
        Me.Size = New System.Drawing.Size(184, 248)
        Me.ResumeLayout(False)

    End Sub

#End Region


    Public Sub SetPath(ByVal Path As String)
        Dim FolderName As String
        Dim objInfo, FolderInfo As IO.DirectoryInfo

        Try
            objInfo = New IO.DirectoryInfo(Path)
        Catch ex As ArgumentNullException
            'errwin.ShowError  MsgBoxStyle.Critical or MsgBoxStyle.OKOnly 
        Catch ex As IO.DirectoryNotFoundException
        Catch ex As Security.SecurityException
        Catch ex As ArgumentException
        Catch ex As IO.PathTooLongException

        Catch ex As Exception
            'TODO: handle error
        End Try

        With objInfo.GetDirectories.GetEnumerator
            .Reset()
            tvFolders.Nodes.Clear()
            While .MoveNext
                FolderInfo = CType(.Current, IO.DirectoryInfo)
                If FolderInfo.Attributes = menuAttributes Then
                    tvFolders.Nodes.Add(New TreeNode(FolderInfo.Name, 0, 1))
                End If
            End While
        End With

        mstrRootPath = objInfo.FullName
        objInfo = Nothing
        FolderInfo = Nothing
    End Sub

    Private Sub tvFolders_BeforeSelect(ByVal sender As Object, ByVal e As System.Windows.Forms.TreeViewCancelEventArgs) Handles tvFolders.BeforeSelect
        Dim objInfo, FolderInfo As IO.DirectoryInfo


        '        If tvFolders.SelectedNode Is Nothing Then Exit Sub
        If e.Action = TreeViewAction.Unknown Then Exit Sub

        Try
            objInfo = New IO.DirectoryInfo(mstrRootPath & e.Node.FullPath)

        Catch ex As ArgumentNullException
            'errwin.ShowError  MsgBoxStyle.Critical or MsgBoxStyle.OKOnly 
        Catch ex As IO.DirectoryNotFoundException
        Catch ex As Security.SecurityException
        Catch ex As ArgumentException
        Catch ex As IO.PathTooLongException

        Catch ex As Exception
            'TODO: handle error
        End Try

        With objInfo.GetDirectories.GetEnumerator
            .Reset()
            e.Node.Nodes.Clear()
            While .MoveNext
                FolderInfo = CType(.Current, IO.DirectoryInfo)
                e.Node.Nodes.Add(New TreeNode(FolderInfo.Name, 0, 1))
            End While
        End With

        objInfo = Nothing
        FolderInfo = Nothing
        e.Node.Expand()
    End Sub

    Public ReadOnly Property FullPath() As String
        Get
            If mstrRootPath.Length = 0 Then
                Return ""
            Else
                Return CStr(IIf(tvFolders.SelectedNode Is Nothing, "", mstrRootPath & tvFolders.SelectedNode.FullPath))
            End If
        End Get
    End Property

    Public Property Attributes() As IO.FileAttributes
        Get
            Return menuAttributes
        End Get
        Set(ByVal Value As IO.FileAttributes)
            menuAttributes = Value
            ' Me.SetPath(mstrRootPath)
        End Set
    End Property

    Private Sub tvFolders_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles tvFolders.Click
        RaiseEvent NodeClick(tvFolders.SelectedNode)
    End Sub
End Class
