'<ToolboxBitmap("d:\multi.bmp")> _
Public Class TileBrowser
    Inherits System.Windows.Forms.UserControl

    Private mintTileSize As Integer = 16
    Private mintTileSizeDisplayed As Integer = 16
    Private menuScrollBars As ScrollBars = ScrollBars.Both
    Private mobjImage As Bitmap

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'UserControl overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents vsbVert As System.Windows.Forms.VScrollBar
    Friend WithEvents pbArea As System.Windows.Forms.PictureBox
    Friend WithEvents hsbHoriz As System.Windows.Forms.HScrollBar
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.vsbVert = New System.Windows.Forms.VScrollBar()
        Me.pbArea = New System.Windows.Forms.PictureBox()
        Me.hsbHoriz = New System.Windows.Forms.HScrollBar()
        Me.SuspendLayout()
        '
        'vsbVert
        '
        Me.vsbVert.Dock = System.Windows.Forms.DockStyle.Right
        Me.vsbVert.Location = New System.Drawing.Point(119, 0)
        Me.vsbVert.Name = "vsbVert"
        Me.vsbVert.Size = New System.Drawing.Size(17, 176)
        Me.vsbVert.TabIndex = 8
        '
        'pbArea
        '
        Me.pbArea.Dock = System.Windows.Forms.DockStyle.Fill
        Me.pbArea.Name = "pbArea"
        Me.pbArea.Size = New System.Drawing.Size(119, 159)
        Me.pbArea.TabIndex = 7
        Me.pbArea.TabStop = False
        '
        'hsbHoriz
        '
        Me.hsbHoriz.Dock = System.Windows.Forms.DockStyle.Bottom
        Me.hsbHoriz.Location = New System.Drawing.Point(0, 159)
        Me.hsbHoriz.Name = "hsbHoriz"
        Me.hsbHoriz.Size = New System.Drawing.Size(119, 17)
        Me.hsbHoriz.TabIndex = 6
        '
        'TileBrowser
        '
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.pbArea, Me.hsbHoriz, Me.vsbVert})
        Me.Name = "TileBrowser"
        Me.Size = New System.Drawing.Size(136, 176)
        Me.ResumeLayout(False)

    End Sub

#End Region

    <Description("The actual size of the tiles that are loaded into the image property."), _
    Category("Appearance")> _
    Public Property TileSize() As Integer
        Get
            Return mintTileSize
        End Get
        Set(ByVal Value As Integer)
            mintTileSize = Value
            DrawTheTiles()
        End Set
    End Property

    <Description("The size that the tiles will be displayed in the TileBrowser."), _
    Category("Appearance")> _
    Public Property TileSizeDisplayed() As Integer
        Get
            Return mintTileSizeDisplayed
        End Get
        Set(ByVal Value As Integer)
            mintTileSizeDisplayed = Value
            DrawTheTiles()
        End Set
    End Property

    <Description("The tiles displayed in the TileBrowser."), _
    Category("Appearance")> _
        Public Property Image() As Image
        Get
            Return mobjImage
        End Get
        Set(ByVal Value As Image)
            mobjImage = CType(Value, Bitmap)
            DrawTheTiles() '(True)
        End Set
    End Property

    <Description("Indicates which scroll bars will be shown for this control."), _
    Category("Appearance")> _
        Public Property ScrollBars() As ScrollBars
        Get
            Return menuScrollBars
        End Get
        Set(ByVal Value As ScrollBars)
            menuScrollBars = Value
            Select Case menuScrollBars
                Case ScrollBars.Both
                    hsbHoriz.Show()
                    vsbVert.Show()

                Case ScrollBars.Horizontal
                    hsbHoriz.Show()
                    vsbVert.Hide()

                Case ScrollBars.None
                    hsbHoriz.Hide()
                    vsbVert.Hide()

                Case ScrollBars.Vertical
                    hsbHoriz.Hide()
                    vsbVert.Show()
            End Select

            DoRedraw()
        End Set
    End Property

    Public Sub DoRedraw()
        DrawTheTiles() '(True)
    End Sub

    Protected Overrides Sub Finalize()
        MyBase.Finalize()
        mobjImage.Dispose()
    End Sub

    Private Sub pbArea_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles pbArea.Paint
        DrawTheTiles()
    End Sub

    Private Sub DrawTheTiles() 'Optional ByVal ThrowException As Boolean = False)
        Dim xSrc, ySrc, xDest, yDest As Integer
        Dim objRect As Rectangle

        ' Dim d As Imaging.BitmapData
        ' Dim i As Image
        ' d = a.LockBits(New Rectangle(0, 0, a.Width, a.Height), Drawing.Imaging.ImageLockMode.WriteOnly, a.PixelFormat)

        ' With pbArea.CreateGraphics.FromImage(a)

        ' End With
        'If ThrowException Then
        '    If pbArea.Image Is Nothing Then Throw New NullReferenceException("The image property is nothing.")
        '    Exit Sub
        'End If
        Try
            Dim a As New Bitmap(pbArea.Width, pbArea.Height, mobjImage.PixelFormat)
            With pbArea.CreateGraphics.FromImage(a)
                'xSrc = CInt(.ClipBounds.Left) : ySrc = CInt(.ClipBounds.Top)
                'xDest = xSrc : yDest = ySrc

                xSrc = 0 : ySrc = 0
                xDest = xSrc : yDest = ySrc

                For ySrc = 0 To mobjImage.Height - 1 Step mintTileSize
                    For xSrc = 0 To mobjImage.Width - 1 Step mintTileSize
                        objRect = New Rectangle(xSrc, ySrc, mintTileSize, mintTileSize)
                        .DrawImage(mobjImage.Clone(objRect, mobjImage.PixelFormat), xDest, yDest, mintTileSizeDisplayed, mintTileSizeDisplayed)

                        If xDest + mintTileSizeDisplayed > pbArea.Width Then
                            xDest = 0
                            yDest += mintTileSizeDisplayed
                        Else
                            xDest += mintTileSizeDisplayed
                        End If
                    Next
                Next

                objRect = Nothing
            End With
            pbArea.Image = a
        Catch
        End Try
    End Sub

    Private Sub pbArea_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles pbArea.Resize
        DrawTheTiles()
    End Sub
End Class
