Public Class CellControl
    Inherits System.Windows.Forms.UserControl

    Private mobjCellSize As Size = New Size(8, 21)
    Private mobjAlternatingColor As Color = SystemColors.Control
    ' Private mobjGridColor As Color = SystemColors.Control
    Private mblnShowGrid As Boolean = True
    Private mobjOffset As Point = New Point(0, 0)
    Private mintAlternatingIndex As Integer = 5

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'UserControl overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        '
        'CellControl
        '
        Me.ForeColor = System.Drawing.SystemColors.Window
        Me.Name = "CellControl"
        Me.Size = New System.Drawing.Size(280, 24)

    End Sub

#End Region


    Private Sub CellControl_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint
        Dim idx As Integer
        Dim objCellBrush, objAlternatingBrush, objUseBrush As Brush
        Dim objGridColor As Pen
        Dim objRect As Rectangle


        objCellBrush = New SolidBrush(Me.ForeColor)
        objAlternatingBrush = New SolidBrush(mobjAlternatingColor)

        e.Graphics.Clear(Me.BackColor)
        objRect = New Rectangle(mobjOffset, mobjCellSize)

        While objRect.Y < Me.Height
            idx = 0
            While objRect.X < Me.Width

                ' determin what color to use
                If idx = mintAlternatingIndex Then
                    objUseBrush = objAlternatingBrush
                Else
                    objUseBrush = objCellBrush
                End If

                ' draw cell
                e.Graphics.FillRectangle(objUseBrush, objRect)

                ' reposition rectangle
                objRect.X += mobjCellSize.Width
                idx += 1
                If idx > mintAlternatingIndex Then idx = 0
            End While

            objRect.X = 0
            objRect.Y += mobjCellSize.Height
        End While

        ' draw grid
        If mblnShowGrid Then
            objGridColor = New Pen(Me.ForeColor)

            ' draw vert lines
            For idx = mobjOffset.X To Me.Width Step mobjCellSize.Width
                e.Graphics.DrawLine(objGridColor, idx, 0, idx, Me.Height)
            Next

            ' draw horiz lines
            For idx = mobjOffset.Y To Me.Height Step mobjCellSize.Height
                e.Graphics.DrawLine(objGridColor, 0, idx, Me.Width, idx)
            Next

            e.Graphics.DrawRectangle(objGridColor, New Rectangle(New Point(0, 0), Me.Size))
        End If
    End Sub

    Public Property AlternatingColor() As Color
        Get
            Return mobjAlternatingColor
        End Get
        Set(ByVal Value As Color)
            mobjAlternatingColor = Value
            Me.Refresh()
        End Set
    End Property

    Public Property CellSize() As Size
        Get
            Return mobjCellSize
        End Get
        Set(ByVal Value As Size)
            mobjCellSize = Value
            CellControl_Resize(Nothing, Nothing)
            Me.Refresh()
        End Set
    End Property

    Public Property ShowGrid() As Boolean
        Get
            Return mblnShowGrid
        End Get
        Set(ByVal Value As Boolean)
            mblnShowGrid = Value
            Me.Refresh()
        End Set
    End Property

    'Public Property GridColor() As Color
    '    Get
    '        Return mobjGridColor
    '    End Get
    '    Set(ByVal Value As Color)
    '        mobjGridColor = Value
    '        Me.Refresh()
    '    End Set
    'End Property

    Public Property Offset() As Point
        Get
            Return mobjOffset
        End Get
        Set(ByVal Value As Point)
            mobjOffset = Value
            Me.Refresh()
        End Set
    End Property

    Public Property AlternatingIndex() As Integer
        Get
            Return mintAlternatingIndex
        End Get
        Set(ByVal Value As Integer)
            mintAlternatingIndex = CInt(IIf(Value < 1, 1, Value))
            Me.Refresh()
        End Set
    End Property

    'Private Sub CellControl_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
    '    mobjCellSize = New Size(10, 16)
    '    mobjAlternatingColor = Color.Blue
    '    mobjGridColor = Color.Black
    '    mobjOffset = New Point(0, 0)
    'End Sub

    Private Sub CellControl_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        Me.Height = mobjCellSize.Height
        Me.Refresh()
    End Sub

    Public Function CreateCellGraphics(ByVal Cell As Integer) As Graphics
        Dim G As Graphics

        G = Me.CreateGraphics
        G.SetClip(New Rectangle(New Point(Cell * mobjCellSize.Width, 0), mobjCellSize))
        Return G
    End Function
End Class
