Public Class TimeLine
    Inherits System.Windows.Forms.UserControl

    Public Event TracksMouseDown(ByVal TrackIndex As Integer, ByVal e As System.Windows.Forms.MouseEventArgs)
    Public Event TracksMouseMove(ByVal TrackIndex As Integer, ByVal e As System.Windows.Forms.MouseEventArgs)
    Public Event TracksMouseUp(ByVal TrackIndex As Integer, ByVal e As System.Windows.Forms.MouseEventArgs)
    Public Event CustomTrack(ByRef Track As CellControl)
    Public Event BeforeAddTrack(ByRef Cancel As Boolean)
    Public Event TrackAdded(ByVal Index As Integer)
    Public Event TrackRemoved(ByVal Index As Integer)
    Public Event BeforeRemoveTrack(ByVal Index As Integer, ByRef Cancel As Boolean)
    Public Event BeforeCellSizeChange(ByVal OldValue As Size, ByRef NewValue As Size, ByRef Cancel As Boolean)

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
    End Sub

    'UserControl overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents rcRuler As CBX.WinCtrls.CTRLBasicsR1.RulerControl
    Friend WithEvents pnlTracks As System.Windows.Forms.Panel
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.rcRuler = New CBX.WinCtrls.CTRLBasicsR1.RulerControl()
        Me.pnlTracks = New System.Windows.Forms.Panel()
        Me.SuspendLayout()
        '
        'rcRuler
        '
        Me.rcRuler.BaseNumber = 0
        Me.rcRuler.CellSize = New System.Drawing.Size(8, 21)
        Me.rcRuler.Dock = System.Windows.Forms.DockStyle.Top
        Me.rcRuler.Name = "rcRuler"
        Me.rcRuler.NumberIndex = 5
        Me.rcRuler.Offset = New System.Drawing.Point(0, 0)
        Me.rcRuler.ShowNumbers = True
        Me.rcRuler.ShowTicks = True
        Me.rcRuler.Size = New System.Drawing.Size(464, 21)
        Me.rcRuler.TabIndex = 0
        '
        'pnlTracks
        '
        Me.pnlTracks.AutoScroll = True
        Me.pnlTracks.Dock = System.Windows.Forms.DockStyle.Fill
        Me.pnlTracks.Location = New System.Drawing.Point(0, 21)
        Me.pnlTracks.Name = "pnlTracks"
        Me.pnlTracks.Size = New System.Drawing.Size(464, 139)
        Me.pnlTracks.TabIndex = 2
        '
        'TimeLine
        '
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.pnlTracks, Me.rcRuler})
        Me.Name = "TimeLine"
        Me.Size = New System.Drawing.Size(464, 160)
        Me.ResumeLayout(False)

    End Sub

#End Region

    'Private Sub TimeLine_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
    '    Me.Height = rcRuler.Height + ccCells.Height
    '    Me.Refresh()
    'End Sub
    Private Sub TrackMouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs)
        Dim T As CellControl

        T = CType(sender, CellControl)
        RaiseEvent TracksMouseDown(CInt(T.Tag), e)
    End Sub

    Private Sub TrackMouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs)
        Dim T As CellControl

        T = CType(sender, CellControl)
        RaiseEvent TracksMouseMove(CInt(T.Tag), e)
    End Sub

    Private Sub TrackMouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs)
        Dim T As CellControl

        T = CType(sender, CellControl)
        RaiseEvent TracksMouseUp(CInt(T.Tag), e)
    End Sub

    Public Function AddTrack() As Integer
        Dim T As CellControl
        Dim blnCancel As Boolean = False

        RaiseEvent BeforeAddTrack(blnCancel)
        If blnCancel Then Exit Function

        RaiseEvent CustomTrack(T)
        If T Is Nothing Then
            T = New CellControl()
            T.Dock = DockStyle.Top
            T.ShowGrid = True
        End If

        AddHandler T.MouseDown, AddressOf TrackMouseDown
        AddHandler T.MouseMove, AddressOf TrackMouseMove
        AddHandler T.MouseUp, AddressOf TrackMouseUp

        pnlTracks.Controls.Add(T)
        T.Tag = pnlTracks.Controls.IndexOf(T)
        T.Show()
        RaiseEvent TrackAdded(CInt(T.Tag))
        Return CInt(T.Tag)
    End Function

    Public Sub RemoveTrack(ByVal Index As Integer)
        Dim T As CellControl

        Dim blnCancel As Boolean = False

        RaiseEvent BeforeRemoveTrack(Index, blnCancel)
        If blnCancel Then Exit Sub

        T = CType(pnlTracks.Controls(Index), CellControl)
        RemoveHandler T.MouseDown, AddressOf TrackMouseDown
        RemoveHandler T.MouseMove, AddressOf TrackMouseMove
        RemoveHandler T.MouseUp, AddressOf TrackMouseUp
        T = Nothing

        pnlTracks.Controls.RemoveAt(Index)
        RaiseEvent TrackRemoved(Index)
    End Sub

    Public ReadOnly Property Tracks(ByVal Index As Integer) As CellControl
        Get
            Return CType(pnlTracks.Controls(Index), CellControl)
        End Get
    End Property

    Public ReadOnly Property TrackCount() As Integer
        Get
            Return pnlTracks.Controls.Count
        End Get
    End Property

    Public Property CellSize() As Size
        Get
            Return rcRuler.CellSize
        End Get
        Set(ByVal Value As Size)
            Dim blnCancel As Boolean = False

            RaiseEvent BeforeCellSizeChange(rcRuler.CellSize, Value, blnCancel)
            If blnCancel Then Exit Property

            rcRuler.CellSize = Value
            Me.Refresh()
        End Set
    End Property

    <Browsable(False)> _
    Public ReadOnly Property RulerControl() As RulerControl
        Get
            Return rcRuler
        End Get
    End Property
End Class
