Public Class CharacterAnimationController
    Inherits DX9ToolsR4.Animation.AnimationController

    Private mobjTimeCallback As GetTheTime

    Public Property TimeCallback() As GetTheTime
        Get
            Return mobjTimeCallback
        End Get
        Set(ByVal Value As GetTheTime)
            mobjTimeCallback = Value
        End Set
    End Property

    Public Function BuildMatrix() As Matrix
        Dim M, Tmp As Matrix
        Dim Obj, NextObj As Object
        Dim idx As Integer
        Dim V As Vector3
        Dim lngCurrentTime As Long
        Dim Track As CharacterAnimationTrack
        Dim sngValue As Single

        lngCurrentTime = mobjTimeCallback.Invoke
        M = Matrix.Identity

        For idx = 0 To Me.Count - 1
            Track = CType(Me.Item(idx), CharacterAnimationTrack)
            If Track.Enabled Then

                Obj = Track.GetCurrentKey

                Tmp = Matrix.Identity

                If TypeOf Obj Is DX9ToolsR4.Animation.KeyScale3 Then
                    If Track.CurrentKeyIndex + 1 > Track.Count - 1 Then
                        NextObj = Track.Item(0)
                    Else
                        NextObj = Track.Item(Track.CurrentKeyIndex + 1)
                    End If
                    With CType(Obj, DX9ToolsR4.Animation.KeyScale3)
                        sngValue = CSng((lngCurrentTime - Track.BaseTime) / .Time)
                        V = Vector3.Lerp(.Scale, CType(NextObj, DX9ToolsR4.Animation.KeyScale3).Scale, _
                                         sngValue)
                        Tmp.Scale(V)
                    End With

                ElseIf TypeOf Obj Is DX9ToolsR4.Animation.KeyRotation3 Then
                    If Track.CurrentKeyIndex + 1 > Track.Count - 1 Then
                        NextObj = Track.Item(0)
                    Else
                        NextObj = Track.Item(Track.CurrentKeyIndex + 1)
                    End If
                    With CType(Obj, DX9ToolsR4.Animation.KeyRotation3)
                        sngValue = CSng((lngCurrentTime - Track.BaseTime) / .Time)
                        V = Vector3.Lerp(.Rotation, CType(NextObj, DX9ToolsR4.Animation.KeyRotation3).Rotation, _
                                         sngValue)
                        Tmp.RotateYawPitchRoll(V.X, V.Y, V.Z)
                    End With
                End If

                M.Multiply(Tmp)

            End If
        Next

        Return M
    End Function

    Public Sub UpdateTracks()
        Dim idx As Integer

        For idx = 0 To Me.Count - 1
            CType(Me.Item(idx), CharacterAnimationTrack).Update()
        Next
    End Sub

    Public Sub New(ByVal TCallback As GetTheTime)
        MyBase.new()
        mobjTimeCallback = TCallback
    End Sub
End Class
