Public Delegate Function GetTheTime() As Long

Public Class CharacterAnimationTrack
    Inherits DX9ToolsR4.Animation.Track


    Private mintCurrentKey As Integer
    Private mobjTimeCallback As GetTheTime
    Private mlngBaseTime As Long
    Private mblnEnabled As Boolean = True


    Public Property BaseTime() As Long
        Get
            Return mlngBaseTime
        End Get
        Set(ByVal Value As Long)
            mlngBaseTime = Value
        End Set
    End Property

    Public Sub New(ByVal TCallback As GetTheTime)
        MyBase.new()
        mobjTimeCallback = TCallback
    End Sub

    Public Property CurrentKeyIndex() As Integer
        Get
            Return mintCurrentKey
        End Get
        Set(ByVal Value As Integer)
            mintCurrentKey = Value
        End Set
    End Property

    Public Function GetCurrentKey() As Object
        Return Me.Item(mintCurrentKey)
    End Function

    Public Sub MoveNext()
        mintCurrentKey += 1
        If mintCurrentKey > Me.Count - 1 Then mintCurrentKey = 0
    End Sub

    Public Sub Update()
        Dim lngCurrentTime As Long

        lngCurrentTime = mobjTimeCallback.Invoke
        If lngCurrentTime > mlngBaseTime + Me.Item(mintCurrentKey).Time Then
            Me.MoveNext()
            mlngBaseTime = lngCurrentTime
        End If
    End Sub

    Public Property TimeCallback() As GetTheTime
        Get
            Return mobjTimeCallback
        End Get
        Set(ByVal Value As GetTheTime)
            mobjTimeCallback = Value
        End Set
    End Property

    Public Property Enabled() As Boolean
        Get
            Return mblnEnabled
        End Get
        Set(ByVal Value As Boolean)
            mblnEnabled = Value
        End Set
    End Property
End Class
