'*********************************************************
'Thanks to P.Gielens that help out with the icon 
'handle that didn't work a couple months ago
'*********************************************************
Imports System.Runtime.InteropServices

Public Class XPNotifyBalloon

    <StructLayout(LayoutKind.Sequential)> Private Structure NOTIFYICONDATA
        Dim cbSize As Int32
        Dim hwnd As IntPtr
        Dim uID As Int32
        Dim uFlags As Int32
        Dim uCallbackMessage As IntPtr
        Dim hIcon As IntPtr
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=128)> Dim szTip As String
        Dim dwState As Int32
        Dim dwStateMask As Int32
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=256)> Dim szInfo As String
        Dim uVersion As Int32
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=64)> Dim szInfoTitle As String
        Dim dwInfoFlags As Int32
    End Structure

    Private Const NIF_MESSAGE As Int32 = &H1
    Private Const NIF_ICON As Int32 = &H2
    Private Const NIF_STATE As Int32 = &H8
    Private Const NIF_INFO As Int32 = &H10
    Private Const NIF_TIP As Int32 = &H4
    Private Const NIM_ADD As Int32 = &H0
    Private Const NIM_MODIFY As Int32 = &H1
    Private Const NIM_DELETE As Int32 = &H2
    Private Const NIM_SETVERSION As Int32 = &H4
    Private Const NOTIFYICON_VERSION As Int32 = &H5
    Private Const NIS_HIDDEN As Int32 = &H1
    Private Const NIS_SHAREDICON As Int32 = &H2
    Private Const NIIF_ERROR As Int32 = &H3
    Private Const NIIF_INFO As Int32 = &H1
    Private Const NIIF_NONE As Int32 = &H0
    Private Const NIIF_WARNING As Int32 = &H2
    Private Const NIM_SETFOCUS As Int32 = &H4
    Private Const NIIF_GUID As Int32 = &H5

    Private Declare Function Shell_NotifyIcon Lib "shell32.dll" _
    Alias "Shell_NotifyIconA" (ByVal dwMessage As Int32, _
    ByRef lpData As NOTIFYICONDATA) As Boolean

    Private uNIF As NOTIFYICONDATA
    Private mobjFormReference As Form

    Public Enum NotificationType
        [Warning] = 1
        [Error] = 2
        [Information] = 3
    End Enum

    Public Function Notification(ByVal Type As NotificationType, ByVal sMessage As String) As Boolean
        With uNIF
            .uFlags = NIF_INFO
            .uVersion = 2000
            .szInfo = sMessage
            Select Case Type
                Case NotificationType.Error
                    .szInfoTitle = "Error"
                    .dwInfoFlags = NIIF_ERROR

                Case NotificationType.Information
                    .szInfoTitle = "Information"
                    .dwInfoFlags = NIIF_INFO

                Case NotificationType.Warning
                    .szInfoTitle = "Warning"
                    .dwInfoFlags = NIIF_WARNING
            End Select

        End With

        Return Shell_NotifyIcon(NIM_MODIFY, uNIF)
    End Function

    Public Function RemoveIcon(Optional ByVal RemoveFormRef As Boolean = True) As Boolean
        With uNIF
            .cbSize = Marshal.SizeOf(uNIF)
            .hwnd = mobjFormReference.Handle()
            .uID = 1
        End With
        If RemoveFormRef Then mobjFormReference = Nothing
        Return Shell_NotifyIcon(NIM_DELETE, uNIF)
    End Function

    Public Function AddIcon(ByRef Form As System.Windows.Forms.Form, ByVal Icon As Icon) As Boolean
        mobjFormReference = Form
        With uNIF
            .cbSize = Marshal.SizeOf(uNIF)
            .hwnd = mobjFormReference.Handle
            .uID = 1
            .uFlags = NIF_MESSAGE Or NIF_ICON Or NIF_TIP
            .uCallbackMessage = New IntPtr(&H500)
            .uVersion = NOTIFYICON_VERSION
            .hIcon = Icon.Handle
        End With
        Return Shell_NotifyIcon(NIM_ADD, uNIF)
    End Function
End Class
