'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: November 23, 2003
'=============================================

''' <summary>
''' Contains types relates to animation.
''' </summary>
Namespace Animation

    ''' <summary>
    ''' Provides a sprite key object that implements the IKeySprite interface.
    ''' </summary>
    Public Class KeySprite
        Implements IKeySprite

        Private mobjScale As Vector2
        Private mobjTranslation As Vector2
        Private mobjRotationCenter As Vector2
        Private msngRotation As Single
        Private mobjSourceRectangle As Rectangle
        Private mobjColor As Color
        Private mlngTime As Long

        ''' <summary>
        ''' Gets/Sets the Color value for the sprite.
        ''' </summary>
        ''' <returns>Returns the Color value for the sprite.</returns>
        Public Property Color() As System.Drawing.Color Implements CBX.Libs.DX9ToolsR4.Animation.IKeySprite.Color
            Get
                Return mobjColor
            End Get
            Set(ByVal Value As System.Drawing.Color)
                mobjColor = Value
            End Set
        End Property

        ''' <summary>
        ''' Gets/Sets the Rotation value for the sprite.
        ''' </summary>
        ''' <returns>Returns the Rotation value for the sprite.</returns>
        Public Property Rotation() As Single Implements CBX.Libs.DX9ToolsR4.Animation.IKeySprite.Rotation
            Get
                Return msngRotation
            End Get
            Set(ByVal Value As Single)
                msngRotation = Value
            End Set
        End Property

        ''' <summary>
        ''' Gets/Sets the RotationCenter value for the sprite.
        ''' </summary>
        ''' <returns>Returns the RotationCenter value for the sprite.</returns>
        Public Property RotationCenter() As Microsoft.DirectX.Vector2 Implements CBX.Libs.DX9ToolsR4.Animation.IKeySprite.RotationCenter
            Get
                Return mobjRotationCenter
            End Get
            Set(ByVal Value As Microsoft.DirectX.Vector2)
                mobjRotationCenter = Value
            End Set
        End Property

        ''' <summary>
        ''' Gets/Sets the Scale value for the sprite.
        ''' </summary>
        ''' <returns>Returns the Scale value for the sprite.</returns>
        Public Property Scale() As Microsoft.DirectX.Vector2 Implements CBX.Libs.DX9ToolsR4.Animation.IKeySprite.Scale
            Get
                Return mobjScale
            End Get
            Set(ByVal Value As Microsoft.DirectX.Vector2)
                mobjScale = Value
            End Set
        End Property

        ''' <summary>
        ''' Gets/Sets the SourceRectangle value for the sprite.
        ''' </summary>
        ''' <returns>Returns the SourceRectangle value for the sprite.</returns>
        Public Property SourceRectangle() As System.Drawing.Rectangle Implements CBX.Libs.DX9ToolsR4.Animation.IKeySprite.SourceRectangle
            Get
                Return mobjSourceRectangle
            End Get
            Set(ByVal Value As System.Drawing.Rectangle)
                mobjSourceRectangle = Value
            End Set
        End Property

        ''' <summary>
        ''' Represents a mesure of time.
        ''' </summary>
        ''' <returns>Returns a time value.</returns>
        Public Property Time() As Long Implements CBX.Libs.DX9ToolsR4.Animation.IKeySprite.Time
            Get
                Return mlngTime
            End Get
            Set(ByVal Value As Long)
                mlngTime = Value
            End Set
        End Property

        ''' <summary>
        ''' Gets/Sets the Translation value for the sprite.
        ''' </summary>
        ''' <returns>Returns the Translation value for the sprite.</returns>
        Public Property Translation() As Microsoft.DirectX.Vector2 Implements CBX.Libs.DX9ToolsR4.Animation.IKeySprite.Translation
            Get
                Return mobjTranslation
            End Get
            Set(ByVal Value As Microsoft.DirectX.Vector2)
                mobjTranslation = Value
            End Set
        End Property

#Region " New Overloads ... "
        ''' <summary>
        ''' Creates a new instance of this object.
        ''' </summary>
        Public Sub New()
            MyBase.new()
        End Sub

        ''' <summary>
        ''' Creates a new instance of this object.
        ''' </summary>
        ''' <param name="Scale">Sets the Scale value.</param>
        ''' <param name="Translation">Sets the Translation value.</param>
        ''' <param name="RotationCenter">Sets the RotationCenter value.</param>
        ''' <param name="Rotation">Sets the Rotation value.</param>
        ''' <param name="SourceRectangle">Sets the SourceRectangle value.</param>
        ''' <param name="Color">Sets the Color value.</param>
        ''' <param name="Time">Sets the Time value.</param>
        Public Sub New(ByVal Scale As Vector2, ByVal Translation As Vector2, ByVal RotationCenter As Vector2, _
                       ByVal Rotation As Single, ByVal SourceRectangle As Rectangle, ByVal Color As Color, _
                       ByVal Time As Long)
            Me.New()
            mobjScale = Scale
            mobjTranslation = Translation
            mobjRotationCenter = RotationCenter
            msngRotation = Rotation
            mobjSourceRectangle = SourceRectangle
            mobjColor = Color
            mlngTime = Time
        End Sub
#End Region
    End Class

    ''' <summary>
    ''' Provides a Matrix key object that implements the IKeyMatrix interface.
    ''' </summary>
    Public Class KeyMatrix
        Implements Animation.IKeyMatrix

        Private mlngTime As Long
        Private mobjMatrix As Matrix


        ''' <summary>
        ''' Represents a mesure of time.
        ''' </summary>
        ''' <returns>Returns a time value.</returns>
        Public Overridable Property Time() As Long Implements Animation.IKeyMatrix.Time
            Get
                Return mlngTime
            End Get
            Set(ByVal Value As Long)
                mlngTime = Value
            End Set
        End Property

        ''' <summary>
        ''' Gets sets a D3D matrix type.
        ''' </summary>
        ''' <returns>Returns a D3D matrix type.</returns>
        Public Overridable Property Matrix() As Matrix Implements Animation.IKeyMatrix.Matrix
            Get
                Return mobjMatrix
            End Get
            Set(ByVal Value As Matrix)
                mobjMatrix = Value
            End Set
        End Property

        ''' <summary>
        ''' Creates a new instance of this object.
        ''' </summary>
        Public Sub New()
            MyBase.new()
        End Sub

        ''' <summary>
        ''' Creates a new instance of this object.
        ''' </summary>
        ''' <param name="Time">Sets the Time value.</param>
        Public Sub New(ByVal Time As Long)
            Me.New()
            mlngTime = Time
        End Sub

        ''' <summary>
        ''' Creates a new instance of this object.
        ''' </summary>
        ''' <param name="M">Sets the Matrix value.</param>
        Public Sub New(ByVal M As Matrix)
            Me.New()
            mobjMatrix = M
        End Sub

        ''' <summary>
        ''' Creates a new instance of this object.
        ''' </summary>
        ''' <param name="Time">Sets the Time value.</param>
        ''' <param name="M">Sets the Matrix value.</param>
        Public Sub New(ByVal Time As Long, ByVal M As Matrix)
            Me.New()
            mlngTime = Time
            mobjMatrix = M
        End Sub
    End Class

    ''' <summary>
    ''' Provides a TextureState key object that implements the IKeyTextureState interface.
    ''' </summary>
    Public Class KeyTextureState
        Implements Animation.IKeyTextureState

        Private mlngTime As Long
        Private mobjState As Direct3D.TextureState

        ''' <summary>
        ''' Gets/Sets the texture state.
        ''' </summary>
        ''' <returns>Returns the texture state.</returns>
        Public Overridable Property State() As Direct3D.TextureState Implements Animation.IKeyTextureState.State
            Get
                Return mobjState
            End Get
            Set(ByVal Value As Direct3D.TextureState)
                mobjState = Value
            End Set
        End Property

        ''' <summary>
        ''' Represents a mesure of time.
        ''' </summary>
        ''' <returns>Returns a time value.</returns>
        Public Overridable Property Time() As Long Implements Animation.IKeyTextureState.Time
            Get
                Return mlngTime
            End Get
            Set(ByVal Value As Long)
                mlngTime = Value
            End Set
        End Property

        ''' <summary>
        ''' Creates a new instance of this object.
        ''' </summary>
        Public Sub New()
            MyBase.new()
        End Sub

        ''' <summary>
        ''' Creates a new instance of this object.
        ''' </summary>
        ''' <param name="Time">Sets the Time value.</param>
        Public Sub New(ByVal Time As Long)
            Me.New()
            mlngTime = Time
        End Sub

        ''' <summary>
        ''' Creates a new instance of this object.
        ''' </summary>
        ''' <param name="State">Sets the State value.</param>
        Public Sub New(ByVal State As Direct3D.TextureState)
            Me.New()
            mobjState = State
        End Sub

        ''' <summary>
        ''' Creates a new instance of this object.
        ''' </summary>
        ''' <param name="Time">Sets the Time value.</param>
        ''' <param name="State">Sets the State value.</param>
        Public Sub New(ByVal Time As Long, ByVal State As Direct3D.TextureState)
            Me.New()
            mobjState = State
            mlngTime = Time
        End Sub
    End Class

    ''' <summary>
    ''' Provides a PRS (Position, Rotation, Scale) key object that implements the IKeyPRS3 interface.
    ''' </summary>
    Public Class KeyPRS3
        Implements Animation.IKeyPRS3

        Private mlngTime As Long
        Private mobjPosition, mobjRotation, mobjScale As Vector3

        ''' <summary>
        ''' Gets/Sets the position value.
        ''' </summary>
        ''' <returns>Returns the position value.</returns>
        Public Overridable Property Position() As Vector3 Implements Animation.IKeyPRS3.Position
            Get
                Return mobjPosition
            End Get
            Set(ByVal Value As Vector3)
                mobjPosition = Value
            End Set
        End Property

        ''' <summary>
        ''' Gets/Sets the Rotation value.
        ''' </summary>
        ''' <returns>Returns the Rotation value.</returns>
        Public Overridable Property Rotation() As Vector3 Implements Animation.IKeyPRS3.Rotation
            Get
                Return mobjRotation
            End Get
            Set(ByVal Value As Vector3)
                mobjRotation = Value
            End Set
        End Property

        ''' <summary>
        ''' Gets/Sets the Scale value.
        ''' </summary>
        ''' <returns>Returns the Scale value.</returns>
        Public Overridable Property Scale() As Vector3 Implements Animation.IKeyPRS3.Scale
            Get
                Return mobjScale
            End Get
            Set(ByVal Value As Vector3)
                mobjScale = Value
            End Set
        End Property

        ''' <summary>
        ''' Represents a mesure of time.
        ''' </summary>
        ''' <returns>Returns a time value.</returns>
        Public Overridable Property Time() As Long Implements Animation.IKeyPRS3.Time
            Get
                Return mlngTime
            End Get
            Set(ByVal Value As Long)
                mlngTime = Value
            End Set
        End Property

        ''' <summary>
        ''' Creates a new instance of this object.
        ''' </summary>
        Public Sub New()
            MyBase.new()
        End Sub

        ''' <summary>
        ''' Creates a new instance of this object.
        ''' </summary>
        ''' <param name="Time">Sets the Time value.</param>
        Public Sub New(ByVal Time As Long)
            Me.New()
            mlngTime = Time
        End Sub

        ''' <summary>
        ''' Creates a new instance of this object.
        ''' </summary>
        ''' <param name="Position">Sets the Position value.</param>
        ''' <param name="Rotation">Sets the Rotation value.</param>
        ''' <param name="Scale">Sets the Scale value.</param>
        Public Sub New(ByVal Position As Vector3, ByVal Rotation As Vector3, ByVal Scale As Vector3)
            Me.New()
            mobjPosition = Position
            mobjRotation = Rotation
            mobjScale = Scale
        End Sub

        ''' <summary>
        ''' Creates a new instance of this object.
        ''' </summary>
        ''' <param name="Time">Sets the Time value.</param>
        ''' <param name="Position">Sets the Position value.</param>
        ''' <param name="Rotation">Sets the Rotation value.</param>
        ''' <param name="Scale">Sets the Scale value.</param>
        Public Sub New(ByVal Time As Long, ByVal Position As Vector3, ByVal Rotation As Vector3, ByVal Scale As Vector3)
            Me.New()
            mlngTime = Time
            mobjPosition = Position
            mobjRotation = Rotation
            mobjScale = Scale
        End Sub
    End Class

    ''' <summary>
    ''' Provides a Position key object that implements the IKeyPosition3 interface.
    ''' </summary>
    Public Class KeyPosition3
        Implements Animation.IKeyPosition3

        Private mlngTime As Long
        Private mobjPosition As Vector3

        ''' <summary>
        ''' Gets/Sets the position value.
        ''' </summary>
        ''' <returns>Returns the position value.</returns>
        Public Overridable Property Position() As Vector3 Implements Animation.IKeyPosition3.Value
            Get
                Return mobjPosition
            End Get
            Set(ByVal Value As Vector3)
                mobjPosition = Value
            End Set
        End Property

        ''' <summary>
        ''' Represents a mesure of time.
        ''' </summary>
        ''' <returns>Returns a time value.</returns>
        Public Overridable Property Time() As Long Implements Animation.IKeyPosition3.Time
            Get
                Return mlngTime
            End Get
            Set(ByVal Value As Long)
                mlngTime = Value
            End Set
        End Property

        ''' <summary>
        ''' Creates a new instance of this object.
        ''' </summary>
        Public Sub New()
            MyBase.new()
        End Sub

        ''' <summary>
        ''' Creates a new instance of this object.
        ''' </summary>
        ''' <param name="Time">Sets the Time value.</param>
        Public Sub New(ByVal Time As Long)
            Me.New()
            mlngTime = Time
        End Sub

        ''' <summary>
        ''' Creates a new instance of this object.
        ''' </summary>
        ''' <param name="V">Sets the Position value.</param>
        Public Sub New(ByVal V As Vector3)
            Me.New()
            mobjPosition = V
        End Sub

        ''' <summary>
        ''' Creates a new instance of this object.
        ''' </summary>
        ''' <param name="Time">Sets the Time value.</param>
        ''' <param name="V">Sets the Position value.</param>
        Public Sub New(ByVal Time As Long, ByVal V As Vector3)
            Me.New()
            mlngTime = Time
            mobjPosition = V
        End Sub
    End Class

    ''' <summary>
    ''' Provides a Rotation key object that implements the IKeyPosition3 interface.
    ''' </summary>
    Public Class KeyRotation3
        Implements Animation.IKeyRotation3

        Private mlngTime As Long
        Private mobjRotation As Vector3

        ''' <summary>
        ''' Gets/Sets the Rotation value.
        ''' </summary>
        ''' <returns>Returns the Rotation value.</returns>
        Public Overridable Property Rotation() As Vector3 Implements Animation.IKeyRotation3.Value
            Get
                Return mobjRotation
            End Get
            Set(ByVal Value As Vector3)
                mobjRotation = Value
            End Set
        End Property

        ''' <summary>
        ''' Represents a mesure of time.
        ''' </summary>
        ''' <returns>Returns a time value.</returns>
        Public Overridable Property Time() As Long Implements Animation.IKeyRotation3.Time
            Get
                Return mlngTime
            End Get
            Set(ByVal Value As Long)
                mlngTime = Value
            End Set
        End Property

        ''' <summary>
        ''' Creates a new instance of this object.
        ''' </summary>
        Public Sub New()
            MyBase.new()
        End Sub

        ''' <summary>
        ''' Creates a new instance of this object.
        ''' </summary>
        ''' <param name="Time">Sets the Time value.</param>
        Public Sub New(ByVal Time As Long)
            Me.New()
            mlngTime = Time
        End Sub

        ''' <summary>
        ''' Creates a new instance of this object.
        ''' </summary>
        ''' <param name="V">Sets the Rotation value.</param>
        Public Sub New(ByVal V As Vector3)
            Me.New()
            mobjRotation = V
        End Sub

        ''' <summary>
        ''' Creates a new instance of this object.
        ''' </summary>
        ''' <param name="Time">Sets the Time value.</param>
        ''' <param name="V">Sets the Rotation value.</param>
        Public Sub New(ByVal Time As Long, ByVal V As Vector3)
            Me.New()
            mlngTime = Time
            mobjRotation = V
        End Sub
    End Class

    ''' <summary>
    ''' Provides a Scale key object that implements the IKeyPosition3 interface.
    ''' </summary>
    Public Class KeyScale3
        Implements Animation.IKeyScale3

        Private mlngTime As Long
        Private mobjScale As Vector3

        ''' <summary>
        ''' Gets/Sets the Scale value.
        ''' </summary>
        ''' <returns>Returns the Scale value.</returns>
        Public Overridable Property Scale() As Vector3 Implements Animation.IKeyScale3.Value
            Get
                Return mobjScale
            End Get
            Set(ByVal Value As Vector3)
                mobjScale = Value
            End Set
        End Property

        ''' <summary>
        ''' Represents a mesure of time.
        ''' </summary>
        ''' <returns>Returns a time value.</returns>
        Public Overridable Property Time() As Long Implements Animation.IKeyScale3.Time
            Get
                Return mlngTime
            End Get
            Set(ByVal Value As Long)
                mlngTime = Value
            End Set
        End Property

        ''' <summary>
        ''' Creates a new instance of this object.
        ''' </summary>
        Public Sub New()
            MyBase.new()
        End Sub

        ''' <summary>
        ''' Creates a new instance of this object.
        ''' </summary>
        ''' <param name="Time">Sets the Time value.</param>
        Public Sub New(ByVal Time As Long)
            Me.New()
            mlngTime = Time
        End Sub

        ''' <summary>
        ''' Creates a new instance of this object.
        ''' </summary>
        ''' <param name="V">Sets the Scale value.</param>
        Public Sub New(ByVal V As Vector3)
            Me.New()
            mobjScale = V
        End Sub

        ''' <summary>
        ''' Creates a new instance of this object.
        ''' </summary>
        ''' <param name="Time">Sets the Time value.</param>
        ''' <param name="V">Sets the Scale value.</param>
        Public Sub New(ByVal Time As Long, ByVal V As Vector3)
            Me.New()
            mlngTime = Time
            mobjScale = V
        End Sub
    End Class
End Namespace