'Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: Sunday, December 29, 2002
'=============================================

''' <summary>
''' The DX9DDGraphics is a wrapper for the directdraw9 device. This class is indended for windowed use.
''' </summary>
Public Class DX9DDGraphicsWin

    Private mobjDevice As DirectDraw.Device
    Private mobjSurfaceFront, mobjSurfaceBack As DirectDraw.Surface
    'Private mobjSize As Size
    Private mobjDestRect As Rectangle
    ' Private mobjCtrlReference As Control



    ''' <summary>
    ''' Returns a the size of the back buffer.
    ''' </summary>
    ''' <returns>Returns a the size of the back buffer.</returns>
    'Public ReadOnly Property BackBufferDimentions() As Size
    '    Get
    '        Return mobjSize
    '    End Get
    'End Property

    '''' <summary>
    '''' Returns weather or not directdraw is in windows for fullscreen mode.
    '''' </summary>
    '''' <returns>If True directdraw is in windowed mode else directdraw is in fullscreen mode.</returns>
    'Public ReadOnly Property Windowed() As Boolean
    '    Get
    '        Return mblnWindowed
    '    End Get
    'End Property

    ''' <summary>
    ''' Returns a reference to the directdraw device.
    ''' </summary>
    ''' <returns>Returns a reference to the directdraw device.</returns>
    Public Property Device() As DirectDraw.Device
        Get
            Return mobjDevice
        End Get
        Set(ByVal Value As DirectDraw.Device)
            mobjDevice = Value
        End Set
    End Property


    ''' <summary>
    ''' Returns a reference to the front surface.
    ''' </summary>
    ''' <returns>Returns a reference to the front surface.</returns>
    Public Property FrontSurface() As DirectDraw.Surface
        Get
            Return mobjSurfaceFront
        End Get
        Set(ByVal Value As DirectDraw.Surface)
            mobjSurfaceFront = Value
        End Set
    End Property


    ''' <summary>
    ''' Returns a reference to the back surface.
    ''' </summary>
    ''' <returns>Returns a reference to the back surface.</returns>
    Public Property BackSurface() As DirectDraw.Surface
        Get
            Return mobjSurfaceBack
        End Get
        Set(ByVal Value As DirectDraw.Surface)
            mobjSurfaceBack = Value
        End Set
    End Property

    '''' <summary>
    '''' Returns a reference to the control that directdraw is rendering to.
    '''' </summary>
    '''' <returns>Returns a reference to the control that directdraw is rendering to.</returns>
    'Public Property ControlReference() As Control
    '    Get
    '        Return mobjCtrlReference
    '    End Get
    '    Set(ByVal Value As Control)
    '        mobjCtrlReference = Value
    '    End Set
    'End Property


    Private Sub DoneDirectDraw()
        DoneSurfaces()
        If Not mobjDevice Is Nothing Then
            '  If Not mblnWindowed Then mobjDevice.RestoreDisplayMode()
            ' mobjDevice.RestoreDisplayMode()
            'mobjDevice.SetCooperativeLevel(mobjCtrlReference, DirectDraw.CooperativeLevelFlags.Normal)
            mobjDevice.Dispose()
            mobjDevice = Nothing
        End If
    End Sub

    Private Sub DoneSurfaces()
        If Not mobjSurfaceBack Is Nothing Then
            mobjSurfaceBack.Dispose()
            mobjSurfaceBack = Nothing
        End If

        If Not mobjSurfaceFront Is Nothing Then
            mobjSurfaceFront.Dispose()
            mobjSurfaceFront = Nothing
        End If
    End Sub

#Region " New overloads ... "
    Private Sub OneTimeInit(ByVal Ctrl As Control, ByVal Create As DirectDraw.CreateFlags, ByVal Width As Integer, ByVal Height As Integer)
        mobjDevice = New DirectDraw.Device(Create)
        'If Not GeneralHelpers.ModeAvailible(mobjDevice, Width, Height, BPP) Then
        '    DoneDirectDraw()
        '    Throw New Exceptions.DX9ToolsModeNotAvailible("Display mode is not availible.", Exceptions.DX9TErrorCode.ModeNotAvailible)
        'End If

        mobjDevice.SetCooperativeLevel(Ctrl, DirectDraw.CooperativeLevelFlags.Normal)
        ' mobjDevice.SetDisplayMode(Width, Height, BPP, 0, False)

        ' mobjCtrlReference = Ctrl
        DoneSurfaces()
        InitSurfaces(Ctrl, Width, Height)
    End Sub

    'Private Sub SetupDestRect()
    '    If mblnWindowed Then
    '        With mobjCtrlReference
    '            mobjDestRect = New Rectangle(.PointToScreen(New Point(.ClientRectangle.X, .ClientRectangle.Y)), .ClientSize)
    '        End With
    '    End If
    'End Sub

    ''' <summary>
    ''' Creates a new instance of the object.
    ''' </summary>
    ''' <param name="Ctrl">A reference to a control that you want directdraw to render to.</param>
    ''' <param name="Create">Specifies the type of device you wish to create hardware, emulated etc.</param>
    ''' <param name="Width">The width of the backbuffer to create.</param>
    ''' <param name="Height">The height of the backbuffer to create.</param>
    Public Sub New(ByVal Ctrl As Control, ByVal Create As DirectDraw.CreateFlags, ByVal Width As Integer, ByVal Height As Integer)
#If Trace = True Then
        TEnter("CBX.Libs.DX9ToolsR4.DX9DDGraphicsWin.New")
        TDataDump(Create.ToString, "Create", "CBX.Libs.DX9ToolsR4.DX9DDGraphicsWin.New")
        TDataDump(Width.ToString, "Width", "CBX.Libs.DX9ToolsR4.DX9DDGraphicsWin.New")
        TDataDump(Height.ToString, "Height", "CBX.Libs.DX9ToolsR4.DX9DDGraphicsWin.New")
#End If

        OneTimeInit(Ctrl, Create, Width, Height)

#If Trace = True Then
        TExit("CBX.Libs.DX9ToolsR4.DX9DDGraphicsWin.New")
#End If
    End Sub

    ''' <summary>
    ''' Creates a new instance of the object.
    ''' </summary>
    ''' <param name="Ctrl">A reference to a control that you want directdraw to render to.</param>
    ''' <param name="Create">Specifies the type of device you wish to create hardware, emulated etc.</param>
    ''' <param name="BackBufferSize">The width/height of the backbuffer to create.</param>
    Public Sub New(ByVal Ctrl As Control, ByVal Create As DirectDraw.CreateFlags, ByVal BackBufferSize As Size)
#If Trace = True Then
        TEnter("CBX.Libs.DX9ToolsR4.DX9DDGraphicsWin.New")
        TDataDump(Create.ToString, "Create", "CBX.Libs.DX9ToolsR4.DX9DDGraphicsWin.New")
        TDataDump(BackBufferSize.ToString, "BackBufferSize", "CBX.Libs.DX9ToolsR4.DX9DDGraphicsWin.New")
#End If

        OneTimeInit(Ctrl, Create, BackBufferSize.Width, BackBufferSize.Height)

#If Trace = True Then
        TExit("CBX.Libs.DX9ToolsR4.DX9DDGraphicsWin.New")
#End If
    End Sub

    ''' <summary>
    ''' Creates a new instance of the object. Width/Height are retrieved from Ctrl.
    ''' </summary>
    ''' <param name="Ctrl">A reference to a control that you want directdraw to render to.</param>
    ''' <param name="Create">Specifies the type of device you wish to create hardware, emulated etc.</param>
    Public Sub New(ByVal Ctrl As Control, ByVal Create As DirectDraw.CreateFlags)
#If Trace = True Then
        TEnter("CBX.Libs.DX9ToolsR4.DX9DDGraphicsWin.New")
        TDataDump(Create.ToString, "Create", "CBX.Libs.DX9ToolsR4.DX9DDGraphicsWin.New")
#End If

        OneTimeInit(Ctrl, Create, Ctrl.ClientSize.Width, Ctrl.ClientSize.Height)

#If Trace = True Then
        TExit("CBX.Libs.DX9ToolsR4.DX9DDGraphicsWin.New")
#End If
    End Sub

    ''' <summary>
    ''' Creates a new instance of the object. Uses DirectDraw.CreateFlags.Default for the creation flags.
    ''' </summary>
    ''' <param name="Ctrl">A reference to a control that you want directdraw to render to.</param>
    Public Sub New(ByVal Ctrl As Control)
#If Trace = True Then
        TEnter("CBX.Libs.DX9ToolsR4.DX9DDGraphicsWin.New")
#End If

        OneTimeInit(Ctrl, DirectDraw.CreateFlags.Default, Ctrl.ClientSize.Width, Ctrl.ClientSize.Height)

#If Trace = True Then
        TExit("CBX.Libs.DX9ToolsR4.DX9DDGraphicsWin.New")
#End If

    End Sub

    '''' <summary>
    '''' Creates a new instance of the object.
    '''' </summary>
    '''' <param name="Ctrl">A reference to a control that you want directdraw to render to.</param>
    '''' <param name="Create">Specifies the type of device you wish to create hardware, emulated etc.</param>
    '''' <param name="Width">The width of the backbuffer to create.</param>
    '''' <param name="Height">The height of the backbuffer to create.</param>
    '''' <param name="FullScreen">Determins weather or not to use fullscreen mode or windowed.</param>
    '''' <Remarks>
    '''' Because no control parameter is availible DX9DDGraphics will create a form internally using the fallowing code.
    '''' <Example>
    '''' Dim objForm As Form
    ''''
    '''' objForm = New Form()
    '''' With objForm
    ''''    .Text = Text
    ''''    .StartPosition = FormStartPosition.CenterScreen
    ''''    .Size = New Size(BBW, BBH)
    ''''    .ControlBox = False
    ''''    .MaximizeBox = False
    ''''    .MinimizeBox = False
    ''''    .FormBorderStyle = FormBorderStyle.None
    ''''    If FullScreen Then .Location = New Point(0, 0)
    ''''
    ''''    .Show()
    '''' End With
    ''''
    '''' </Example>
    '''' </Remarks>
    'Public Sub New(ByVal Ctrl As Control, ByVal Create As DirectDraw.CreateFlags, ByVal Width As Integer, ByVal Height As Integer, ByVal BPP As Integer)
    '    OneTimeInit(Ctrl, Create, Width, Height, BPP)
    'End Sub

    'Private Function CreateNewForm(Optional ByVal Text As String = "", Optional ByVal FullScreen As Boolean = False, _
    '                           Optional ByVal BBW As Integer = 640, Optional ByVal BBH As Integer = 480) As Form
    '    Dim objForm As Form

    '    objForm = New Form()
    '    With objForm
    '        .Text = Text
    '        .StartPosition = FormStartPosition.CenterScreen
    '        .Size = New Size(BBW, BBH)
    '        .ControlBox = False
    '        .MaximizeBox = False
    '        .MinimizeBox = False
    '        .FormBorderStyle = FormBorderStyle.None
    '        If FullScreen Then .Location = New Point(0, 0)

    '        .Show()
    '    End With

    '    Return objForm
    'End Function
#End Region


    Private Sub InitSurfaces(ByVal Ctrl As Control, ByVal Width As Integer, ByVal Height As Integer)
        Dim Caps As New DirectDraw.SurfaceCaps()
        Dim surfFront As DirectDraw.SurfaceDescription

        If Ctrl Is Nothing Then Throw New ArgumentNullException("Ctrl")

        With Caps
            .Clear()
            .PrimarySurface = True
        End With

        surfFront = New DirectDraw.SurfaceDescription(Caps)
        'surfFront.BackBufferCount = 1

        mobjSurfaceFront = New DirectDraw.Surface(surfFront, mobjDevice)
        mobjSurfaceFront.Clipper = New DirectDraw.Clipper(mobjDevice)
        mobjSurfaceFront.Clipper.Window = Ctrl


        ResizeBackBuffer(Ctrl)
    End Sub


#Region " ResizeBackBuffer overloads ... "
    ''' <summary>
    ''' Resizes the back buffer.
    ''' </summary>
    ''' <param name="Ctrl">A reference to a control. THe back buffer will be sized to the controls client size.</param>
    Public Sub ResizeBackBuffer(ByVal Ctrl As Control)
        If Ctrl Is Nothing Then Throw New ArgumentNullException("Ctrl")
        ResizeBackBuffer(Ctrl.ClientSize.Width, Ctrl.ClientSize.Height)
    End Sub

    ''' <summary>
    ''' Resizes the back buffer.
    ''' </summary>
    ''' <param name="Width">The width of the new back buffer to create.</param>
    ''' <param name="Height">The height of the new back buffer to create.</param>
    Public Sub ResizeBackBuffer(ByVal Width As Integer, ByVal Height As Integer)
        Dim Caps As New DirectDraw.SurfaceCaps()
        Dim surfBack As DirectDraw.SurfaceDescription


        'Setup Back surface
        With Caps
            .Clear()
            .OffScreenPlain = True
        End With

        surfBack = New DirectDraw.SurfaceDescription(Caps)
        surfBack.Width = Width
        surfBack.Height = Height
        If Not mobjSurfaceBack Is Nothing Then mobjSurfaceBack.Dispose()
        mobjSurfaceBack = Nothing
        mobjSurfaceBack = New DirectDraw.Surface(surfBack, mobjDevice)
    End Sub

    ''' <summary>
    ''' Resizes the back buffer.
    ''' </summary>
    ''' <param name="Size">The size of the back buffer to create.</param>
    Public Sub ResizeBackBuffer(ByVal Size As Size)
        ResizeBackBuffer(Size.Width, Size.Height)
    End Sub
#End Region


    ''' <summary>
    ''' 
    ''' </summary>
    Protected Overrides Sub Finalize()
#If Trace = True Then
        TEnter("CBX.Libs.DX9ToolsR4.DX9DDGraphicsWin.Finalize")
#End If

        MyBase.Finalize()
        '  mobjCtrlReference = Nothing
        Try
            DoneDirectDraw()

        Catch ex As Exception
            'ERR: handle error?
        End Try

#If Trace = True Then
        TExit("CBX.Libs.DX9ToolsR4.DX9DDGraphicsWin.Finalize")
#End If
    End Sub

#Region " Present methods ... "
    ''' <summary>
    ''' Renders the scene by drawing the backbuffer onto the front surface.
    ''' </summary>
    ''' <param name="Fast">If True this method will use the DrawFast method to render the scene.</param>
    Public Sub Present(ByVal Fast As Boolean)
        ' SetupDestRect()
        If Fast Then
            mobjSurfaceFront.DrawFast(mobjDestRect.X, mobjDestRect.Y, mobjSurfaceBack, DirectDraw.DrawFastFlags.Wait)
        Else
            mobjSurfaceFront.Draw(mobjDestRect, mobjSurfaceBack, DirectDraw.DrawFlags.Wait)
        End If
    End Sub

    ''' <summary>
    ''' Renders the scene by drawing the backbuffer onto the front surface. This method only uses the Surface.DrawFast method.
    ''' </summary>
    ''' <param name="Fast">Allows specific draw fast flags to be specified.</param>
    Public Sub Present(ByVal Fast As DirectDraw.DrawFastFlags)
        'SetupDestRect()
        mobjSurfaceFront.DrawFast(mobjDestRect.X, mobjDestRect.Y, mobjSurfaceBack, Fast)
    End Sub

    ''' <summary>
    ''' Renders the scene by drawing the backbuffer onto the front surface. This method only uses the Surface.Draw method.
    ''' </summary>
    ''' <param name="Flags">Allows specific draw flags to be specified.</param>
    Public Sub Present(ByVal Flags As DirectDraw.DrawFlags)
        ' SetupDestRect()
        mobjSurfaceFront.Draw(mobjDestRect, mobjSurfaceBack, Flags)
    End Sub

    ''' <summary>
    ''' Renders the scene by drawing the backbuffer onto the front surface. This method only uses the Surface.Draw method using 
    ''' DirectDraw.DrawFlags.Wait as a flag parameter.
    ''' </summary>
    Public Sub Present()
        Me.Present(False)
    End Sub
#End Region

#Region " Clear methods ... "
    ''' <summary>
    ''' Clears the backbuffer using black as the color.
    ''' </summary>
    Public Sub Clear()
        ' clear back buffer
        mobjSurfaceBack.ColorFill(Color.Black)
    End Sub

    ''' <summary>
    ''' Clears the back buffer.
    ''' </summary>
    ''' <param name="Color">The Color that will be used to clear the backbuffer with.</param>
    Public Sub Clear(ByVal Color As Color)
        ' clear back buffer
        mobjSurfaceBack.ColorFill(Color)
    End Sub

    ''' <summary>
    ''' Clears the back buffer.
    ''' </summary>
    ''' <param name="Color">The Color that will be used to clear the backbuffer with.</param>
    Public Sub Clear(ByVal Color As Integer)
        ' clear back buffer
        mobjSurfaceBack.ColorFill(Color)
    End Sub

    ''' <summary>
    ''' Clears the back buffer.
    ''' </summary>
    ''' <param name="Destination">The destination on the back buffer to clear.</param>
    ''' <param name="Color">The Color that will be used to clear the backbuffer with.</param>
    Public Sub Clear(ByVal Destination As Rectangle, ByVal Color As Color)
        ' clear back buffer
        mobjSurfaceBack.ColorFill(Destination, Color)
    End Sub

    ''' <summary>
    ''' Clears the back buffer.
    ''' </summary>
    ''' <param name="Destination">The destination on the back buffer to clear.</param>
    ''' <param name="Color">The Color that will be used to clear the backbuffer with.</param>
    Public Sub Clear(ByVal Destination As Rectangle, ByVal Color As Integer)
        ' clear back buffer
        mobjSurfaceBack.ColorFill(Destination, Color)
    End Sub
#End Region

    ''' <summary>
    ''' Gets or Sets the destination that the backbuffer will be drawn to.
    ''' </summary>
    ''' <returns>Returns the destination that the backbuffer will be drawn to.</returns>
    Public Property DestinationRectangle() As Rectangle
        Get
            Return mobjDestRect
        End Get
        Set(ByVal Value As Rectangle)
            mobjDestRect = Value
        End Set
    End Property
End Class
