'Created by: X   
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: November 27, 2003
'=============================================


''' <summary>
''' DirectDrawLayer provides a means of layering direct draw surfaces.
''' </summary>
Public Class DirectDrawLayer
    Private mobjSurface As DirectDraw.Surface
    Private mobjDDSD As DirectDraw.SurfaceDescription

    ''' <summary>
    ''' Gets or Sets the surface for this layer.
    ''' </summary>
    ''' <returns>Returns the surface for this layer.</returns>
    Public Property Surface() As DirectDraw.Surface
        Get
            Return mobjSurface
        End Get
        Set(ByVal Value As DirectDraw.Surface)
            mobjSurface = Value
        End Set
    End Property

    ''' <summary>
    ''' Creates a new instance of this class.
    ''' </summary>
    Public Sub New()
        MyBase.new()
#If Trace = True Then
        TEnter("CBX.Libs.DX9ToolsR4.DirectDrawLayer.New")
#End If
        mobjDDSD = New DirectDraw.SurfaceDescription()

#If Trace = True Then
        TExit("CBX.Libs.DX9ToolsR4.DirectDrawLayer.New")
#End If

    End Sub

    ''' <summary>
    ''' Creates a new instance of this class.
    ''' </summary>
    ''' <param name="Surface">Sets the initial value of the surface property.</param>
    Public Sub New(ByVal Surface As DirectDraw.Surface)
        MyBase.new()
#If Trace = True Then
        TEnter("CBX.Libs.DX9ToolsR4.DirectDrawLayer.New")
#End If

        mobjSurface = Surface
        mobjDDSD = New DirectDraw.SurfaceDescription()

#If Trace = True Then
        TExit("CBX.Libs.DX9ToolsR4.DirectDrawLayer.New")
#End If

    End Sub


#Region " ReCreateSrface overloads ... "
    ''' <summary>
    ''' Recreates the surface.
    ''' </summary>
    ''' <param name="Device">A reference to a DirectDraw.Device type.</param>
    Public Sub ReCreateSrface(ByVal Device As DirectDraw.Device)
#If Trace = True Then
        TEnter("CBX.Libs.DX9ToolsR4.DirectDrawLayer.ReCreateSrface")
#End If

        If Not mobjSurface Is Nothing Then mobjSurface.Dispose()
        mobjSurface = Nothing
        mobjSurface = New DirectDraw.Surface(mobjDDSD, Device)

#If Trace = True Then
        TExit("CBX.Libs.DX9ToolsR4.DirectDrawLayer.ReCreateSrface")
#End If
    End Sub

    ''' <summary>
    ''' Recreates the surface. 
    ''' </summary>
    ''' <param name="Device">A reference to a DirectDraw.Device type.</param>
    ''' <param name="File">THe name of the file to create the surface from.</param>
    Public Sub ReCreateSrface(ByVal Device As DirectDraw.Device, ByVal File As String)
#If Trace = True Then
        TEnter("CBX.Libs.DX9ToolsR4.DirectDrawLayer.ReCreateSrface")
#End If

        If Not mobjSurface Is Nothing Then mobjSurface.Dispose()
        mobjSurface = Nothing
        mobjSurface = New DirectDraw.Surface(File, mobjDDSD, Device)

#If Trace = True Then
        TExit("CBX.Libs.DX9ToolsR4.DirectDrawLayer.ReCreateSrface")
#End If
    End Sub
#End Region

    ''' <summary>
    ''' Gets or Sets the surface description.
    ''' </summary>
    ''' <returns>Returns the surface description.</returns>
    Public Property SurfaceDescription() As DirectDraw.SurfaceDescription
        Get
            Return mobjDDSD
        End Get
        Set(ByVal Value As DirectDraw.SurfaceDescription)

            mobjDDSD = Value
        End Set
    End Property

           ''' <summary>
    ''' Cleans up and disposes of the layers internal varibles and references.
    ''' </summary>
    Protected Overrides Sub Finalize()
#If Trace = True Then
        TEnter("CBX.Libs.DX9ToolsR4.DirectDrawLayer.Finalize")
#End If

        MyBase.Finalize()

#If Trace = True Then
        TExit("CBX.Libs.DX9ToolsR4.DirectDrawLayer.Finalize")
#End If
    End Sub
End Class