'Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: April 12, 2003
'=============================================

Public Class LVExportItem
    Inherits ListViewItem
    Implements Extentions.IBaseExport

    Public Enum ExportType
        MapImage = 1
        TrackedTiles = 2
    End Enum

    Private mstrDescription, mstrFileDescription, mstrFileEXT, mstrTitle, mstrFileName, mstrObject As String
    Private mobjType As ExportType

    Public Sub SetDescription(ByVal Value As String)
        mstrDescription = Value
    End Sub

    Public Sub SetFileDescription(ByVal Value As String)
        mstrFileDescription = Value
    End Sub

    Public Sub SetFIleEXT(ByVal Value As String)
        mstrFileEXT = Value
    End Sub

    Public Sub SetTitle(ByVal Value As String)
        mstrTitle = Value
    End Sub

    Public ReadOnly Property Description() As String Implements CBX.Games.EasyG.Extentions.IBaseExport.Description
        Get
            Return mstrDescription
        End Get
    End Property

    Public ReadOnly Property FileTypeDescription() As String Implements CBX.Games.EasyG.Extentions.IBaseExport.FileTypeDescription
        Get
            Return mstrFileDescription
        End Get
    End Property

    Public ReadOnly Property FileTypeExtention() As String Implements CBX.Games.EasyG.Extentions.IBaseExport.FileTypeExtention
        Get
            Return mstrFileEXT
        End Get
    End Property

    Public ReadOnly Property Title() As String Implements CBX.Games.EasyG.Extentions.IBaseExport.Title
        Get
            Return mstrTitle
        End Get
    End Property

    Public Property FileName() As String
        Get
            Return mstrFileName
        End Get
        Set(ByVal Value As String)
            mstrFileName = Value
        End Set
    End Property

    Public Property TypeOfExporter() As ExportType
        Get
            Return mobjType
        End Get
        Set(Byval Value As ExportType)
            mobjType = Value
        End Set
    End Property

    Public Property ObjectName() As String
        Get
            Return mstrObject
        End Get
        Set(Byval Value As String)
            mstrObject = Value
        End Set
    End Property
End Class

Public Module Exporters
    Public Sub RunTTExporter(ByVal File As String, ByVal Obj As String, ByVal SaveFile As String, ByVal Tiles As Extentions.TileTrackingCollection)
        Dim objConnection As Extentions.ITileTrackingExport
        Dim ObjH As System.Runtime.Remoting.ObjectHandle

        ObjH = Activator.CreateInstanceFrom(File, Obj)
        ' check if implements proper interface
        If TypeOf ObjH.Unwrap Is Extentions.ITileTrackingExport Then
            objConnection = CType(ObjH.Unwrap, Extentions.ITileTrackingExport)
            With objConnection
                .Run(SaveFile, Tiles)
            End With

            objConnection = Nothing
        End If
    End Sub

    Public Function ExporterAlreadyAdded(ByVal File As String, ByVal Obj As String) As Boolean
        Dim Reader As IO.StreamReader
        Dim strTmp As String
        Dim intPosition As Integer

        If Not IO.File.Exists(mstrExportFile) Then Return False
        Reader = IO.File.OpenText(mstrExportFile)
        While Reader.Peek > -1
            strTmp = Reader.ReadLine().Trim
            If strTmp <> "" Then
                intPosition = strTmp.IndexOf(":")
                ' ignore bad entries
                If intPosition > 0 Then
                    ' check if same filename
                    If IO.Path.GetFileName(strTmp.Substring(0, intPosition)).Trim.ToUpper = IO.Path.GetFileName(File).Trim.ToUpper Then
                        ' check if same object
                        If strTmp.Substring(intPosition + 1).Trim = Obj.Trim Then
                            ' entry exists already
                            Return True
                        End If
                    End If
                End If
            End If
        End While
        Reader.Close()
        Reader = Nothing

        Return False
    End Function

    Public Sub RemoveExporter(ByVal File As String, ByVal Obj As String)
        Dim Reader As IO.StreamReader
        Dim Writer As IO.StreamWriter
        Dim strTmp, strTmpFile As String
        Dim intPosition As Integer


        Reader = IO.File.OpenText(Application.StartupPath & "\" & mstrExportFile)
        strTmpFile = IO.Path.GetTempFileName
        Writer = IO.File.CreateText(strTmpFile)

        While Reader.Peek > -1
            strTmp = Reader.ReadLine().Trim
            If strTmp <> "" Then
                intPosition = strTmp.IndexOf(":")
                ' ignore bad entries
                If intPosition > 0 Then
                    ' check if same filename
                    If IO.Path.GetFileName(strTmp.Substring(0, intPosition)).Trim.ToUpper = IO.Path.GetFileName(File).Trim.ToUpper Then
                        ' check if same object
                        If strTmp.Substring(intPosition + 1).Trim = Obj.Trim Then
                            ' found entry we want to remove so do nothing (IE: don't copy)
                        Else
                            ' copy entry
                            Writer.WriteLine(strTmp)
                        End If
                    Else
                        ' copy entry
                        Writer.WriteLine(strTmp)
                    End If
                End If
            End If
        End While

        Reader.Close()
        Reader = Nothing
        Writer.Flush()
        Writer.Close()
        Writer = Nothing

        ' delete current exporter file
        IO.File.Delete(Application.StartupPath & "\" & mstrExportFile)
        ' move new exporters file into position
        IO.File.Move(strTmpFile, Application.StartupPath & "\" & mstrExportFile)
    End Sub

    Public Sub AddExporter(ByVal File As String, ByVal Obj As String)
        Dim Writer As IO.StreamWriter

        Writer = IO.File.AppendText(Application.StartupPath & "\" & mstrExportFile)
        Writer.WriteLine(IO.Path.GetFileName(File).Trim & ":" & Obj.Trim)
        Writer.Flush()
        Writer.Close()
        Writer = Nothing
    End Sub

    Public Function DoExporterTest(ByVal File As String, ByVal Obj As String, Optional ByVal Owner As Form = Nothing, Optional ByRef ReturnMsg As String = "") As Boolean
        Dim objConnection As Extentions.IBaseExport
        Dim ObjH As System.Runtime.Remoting.ObjectHandle
        Dim Msg, strFile, strObject As String

        ChDir(Application.StartupPath)
        strFile = IO.Path.GetFileName(File).Trim
        strObject = Obj.Trim
        If strFile.Length = 0 Or strObject.Length = 0 Then
            ErrWin.ShowError(Owner, MsgBoxStyle.OKOnly Or MsgBoxStyle.Information, "Argument error", _
                             "The filename or object name is invalid.")
            Return False
        End If

        ' try to connect
        Try
            ObjH = Activator.CreateInstanceFrom(strFile, strObject)
        Catch ex As ArgumentNullException
            ErrWin.ShowError(Owner, MsgBoxStyle.OKOnly Or MsgBoxStyle.Information, "Argument error", _
                                         "The filename or object name is invalid.")
            Return False

        Catch ex As MissingMethodException
            ErrWin.ShowError(Owner, MsgBoxStyle.OKOnly Or MsgBoxStyle.Information, "Error", _
                             "No constructor availible for object.")
            Return False

        Catch ex As TypeLoadException
            ErrWin.ShowError(Owner, MsgBoxStyle.OKOnly Or MsgBoxStyle.Information, "Error", _
                             "Bad object Name. Object names are case sensitive.")
            Return False

        Catch ex As IO.FileNotFoundException
            ErrWin.ShowError(Owner, MsgBoxStyle.OKOnly Or MsgBoxStyle.Information, "Error", _
                             "File does not exist.")
            Return False

        Catch ex As MethodAccessException
            ErrWin.ShowError(Owner, MsgBoxStyle.OKOnly Or MsgBoxStyle.Information, "Error", _
                             "No constructor availible for object.")
            Return False

        Catch ex As Reflection.TargetInvocationException
            ErrWin.ShowError(Owner, MsgBoxStyle.OKOnly Or MsgBoxStyle.Information, "Error", _
                             "This application does not have permission to call this constructor.")
            Return False

        Catch ex As Exception
            ErrWin.ShowError(Owner, MsgBoxStyle.OKOnly Or MsgBoxStyle.Information, "Error", _
                                         "Unexpected error." & vbCrLf & _
                                         "------------------------------------" & vbCrLf & _
                                         ex.ToString)

            Return False
        End Try

        ' check if implements proper interface
        If TypeOf ObjH.Unwrap Is Extentions.IBaseExport Then
            objConnection = CType(ObjH.Unwrap, Extentions.IBaseExport)

            Msg = "Title: " & objConnection.Title & vbCrLf
            Msg &= "Filter Description: " & objConnection.FileTypeDescription & vbCrLf
            Msg &= "Filter Extention: " & objConnection.FileTypeExtention & vbCrLf

            If TypeOf ObjH.Unwrap Is Extentions.IImageExport Then
                Msg &= "Uses Interface: IImageExport" & vbCrLf
            ElseIf TypeOf ObjH.Unwrap Is Extentions.ITileTrackingExport Then
                Msg &= "Uses Interface: ITileTrackingExport" & vbCrLf
            Else
                ErrWin.ShowError(Owner, MsgBoxStyle.OKOnly Or MsgBoxStyle.Information, "Error", _
                                 "Object does not implement required export interface.")

                Return False
            End If

            Msg &= "Description: " & objConnection.Description
            ReturnMsg = Msg
        Else
            ErrWin.ShowError(Owner, MsgBoxStyle.OKOnly Or MsgBoxStyle.Information, "Error", _
                             "Object does not implement required interface.")
            Return False
        End If

        Return True
    End Function

    Public Sub LoadExporters(ByVal ExportFile As String, ByVal LView As ListView)
        Dim Reader As IO.StreamReader
        Dim strExporter, strFile, strObject, strExportFile As String
        Dim intPosition As Integer
        Dim ItemX As LVExportItem

        ChDir(Application.StartupPath)
        If Not IO.File.Exists(ExportFile) Then Exit Sub
        Reader = IO.File.OpenText(ExportFile)
        While Reader.Peek > -1
            strExporter = Reader.ReadLine().Trim
            If strExporter <> "" Then
                intPosition = strExporter.IndexOf(":")
                ' ignore bad entries
                If intPosition > 0 Then
                    strFile = strExporter.Substring(0, intPosition)
                    strObject = strExporter.Substring(intPosition + 1)
                    strExportFile = Application.StartupPath & "\" & strFile

                    If IO.File.Exists(strExportFile) Then
                        ItemX = GetExporterInfo(strExportFile, strObject)

                        If Not ItemX Is Nothing Then LView.Items.Add(ItemX)
                    End If
                End If
            End If
        End While

        Reader.Close()
        Reader = Nothing
    End Sub

    Public Function GetExporterInfo(ByVal File As String, ByVal Obj As String) As LVExportItem
        Dim objConnection As Extentions.IBaseExport
        Dim ObjH As System.Runtime.Remoting.ObjectHandle
        Dim Item As LVExportItem

        Try
            ObjH = Activator.CreateInstanceFrom(File, Obj)
        Catch ex As Exception
            Return Nothing
        End Try

        ' check if implements proper interface
        If TypeOf ObjH.Unwrap Is Extentions.IBaseExport Then
            objConnection = CType(ObjH.Unwrap, Extentions.IBaseExport)
            With objConnection
                Item = New LVExportItem()

                Item.SetTitle(.Title)
                Item.FileName = IO.Path.GetFileName(File)
                Item.SetFileDescription(.FileTypeDescription)
                Item.SetFIleEXT(.FileTypeExtention)
                Item.SetDescription(.Description)
                Item.ObjectName = Obj

                If TypeOf ObjH.Unwrap Is Extentions.IImageExport Then
                    Item.TypeOfExporter = LVExportItem.ExportType.MapImage

                ElseIf TypeOf ObjH.Unwrap Is Extentions.ITileTrackingExport Then
                    Item.TypeOfExporter = LVExportItem.ExportType.TrackedTiles

                Else
                    ' unknown type so return nothing
                    Return Nothing
                End If
            End With
            objConnection = Nothing

            Return Item
        End If

        Return Nothing
    End Function
End Module