'Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: April 12, 2003
'=============================================

Module modGeneral
    Public Const mstrINIFile As String = "Settings.xml"
    Public Const mstrExportFile As String = "Exporters.txt"

    Public Class LayerItem
        Public Name As String
        Public TransparentColor As Color
        Public BackgroundColor As Color
        Public Image As Bitmap
    End Class

    Public Class TilesetItem
        Public FileName As String
        Public Image As Bitmap
    End Class

    Public Enum EasyGSettings
        BackgroundColor = 0
        ColorKeyColor = 1
        BoundaryColor = 2
        GridColor = 3
        NewImageWidth = 4
        NewImageHeight = 5
        GridWidth = 6
        GridHeight = 7
        SnapWidth = 8
        SnapHeight = 9
        TileWidth = 10
        TileHeight = 11
        ImageThumbWidth = 12
        ImageThumbHeight = 13
        LayerThumbWidth = 14
        LayerThumbHeight = 15
        GridAtStartUp = 16
        SnapAtStartUp = 17
        TrackTilesAtStartUp = 18
    End Enum

    Public Function SettingToString(ByVal Setting As EasyGSettings) As String
        Dim strKey As String

        Select Case Setting
            Case EasyGSettings.BackgroundColor
                strKey = "BackgroundColor"

            Case EasyGSettings.BoundaryColor
                strKey = "BoundaryColor"

            Case EasyGSettings.ColorKeyColor
                strKey = "ColorKeyColor"

            Case EasyGSettings.GridColor
                strKey = "GridColor"

            Case EasyGSettings.GridHeight
                strKey = "GridHeight"

            Case EasyGSettings.GridWidth
                strKey = "GridWidth"

            Case EasyGSettings.NewImageHeight
                strKey = "NewImageHeight"

            Case EasyGSettings.NewImageWidth
                strKey = "NewImageWidth"

            Case EasyGSettings.SnapHeight
                strKey = "SnapHeight"

            Case EasyGSettings.SnapWidth
                strKey = "SnapWidth"

            Case EasyGSettings.TileWidth
                strKey = "TileWidth"

            Case EasyGSettings.TileHeight
                strKey = "TileHeight"

            Case EasyGSettings.ImageThumbWidth
                strKey = "ImageThumbWidth"

            Case EasyGSettings.ImageThumbHeight
                strKey = "ImageThumbHeight"

            Case EasyGSettings.LayerThumbWidth
                strKey = "LayerThumbWidth"

            Case EasyGSettings.LayerThumbHeight
                strKey = "LayerThumbHeight"

            Case EasyGSettings.GridAtStartUp
                strKey = "GridAtStartUp"

            Case EasyGSettings.SnapAtStartUp
                strKey = "SnapAtStartUp"

            Case EasyGSettings.TrackTilesAtStartUp
                strKey = "TrackTilesAtStartUp"
        End Select

        Return strKey
    End Function

#Region " GetSetting/SetSetting overload ... "
    Public Sub GetSetting(ByVal Setting As EasyGSettings, ByRef ReturnValue As Color)
        Dim strFile, strData, strKey As String
        Dim objDefault As Color


        strFile = Application.StartupPath & "\" & mstrINIFile
        strKey = SettingToString(Setting)
        Select Case Setting
            Case EasyGSettings.BackgroundColor
                objDefault = Color.White

            Case EasyGSettings.BoundaryColor
                objDefault = Color.Red

            Case EasyGSettings.ColorKeyColor
                objDefault = Color.Black

            Case EasyGSettings.GridColor
                objDefault = Color.Blue
        End Select

        strData = General.GetINIData(strFile, "Settings", strKey)
        If strData Is Nothing Then
            ReturnValue = objDefault
        Else
            ReturnValue = Color.FromArgb(CInt(strData))
        End If
    End Sub

    Public Sub GetSetting(ByVal Setting As EasyGSettings, ByRef ReturnValue As Integer)
        Dim strFile, strData, strKey As String
        Dim intDefault As Integer


        strFile = Application.StartupPath & "\" & mstrINIFile
        strKey = SettingToString(Setting)
        Select Case Setting
            Case EasyGSettings.GridHeight
                intDefault = 32

            Case EasyGSettings.GridWidth
                intDefault = 32

            Case EasyGSettings.NewImageHeight
                intDefault = 480

            Case EasyGSettings.NewImageWidth
                intDefault = 640

            Case EasyGSettings.SnapHeight
                intDefault = 32

            Case EasyGSettings.SnapWidth
                intDefault = 32

            Case EasyGSettings.TileWidth
                intDefault = 16

            Case EasyGSettings.TileHeight
                intDefault = 16

            Case EasyGSettings.ImageThumbWidth
                intDefault = 64

            Case EasyGSettings.ImageThumbHeight
                intDefault = 64

            Case EasyGSettings.LayerThumbWidth
                intDefault = 128

            Case EasyGSettings.LayerThumbHeight
                intDefault = 128
        End Select

        strData = General.GetINIData(strFile, "Settings", strKey)
        If strData Is Nothing Then
            ReturnValue = intDefault
        Else
            ReturnValue = CInt(strData)
        End If
    End Sub

    Public Sub GetSetting(ByVal Setting As EasyGSettings, ByRef ReturnValue As Boolean)
        Dim strFile, strData, strKey As String
        Dim intDefault As Boolean


        strFile = Application.StartupPath & "\" & mstrINIFile
        strKey = SettingToString(Setting)
        Select Case Setting
            Case EasyGSettings.GridAtStartUp
                intDefault = False

            Case EasyGSettings.SnapAtStartUp
                intDefault = False

            Case EasyGSettings.TrackTilesAtStartUp
                intDefault = False

        End Select

        strData = General.GetINIData(strFile, "Settings", strKey)
        If strData Is Nothing Then
            ReturnValue = intDefault
        Else
            ReturnValue = CBool(strData)
        End If
    End Sub

    Public Sub SetSetting(ByVal Setting As EasyGSettings, ByVal Value As Integer)
        Dim strFile, strKey As String

        strFile = Application.StartupPath & "\" & mstrINIFile
        strKey = SettingToString(Setting)

        General.SetINIData(strFile, "Settings", strKey, Value.ToString)
    End Sub

    Public Sub SetSetting(ByVal Setting As EasyGSettings, ByVal Value As Boolean)
        Dim strFile, strKey As String

        strFile = Application.StartupPath & "\" & mstrINIFile
        strKey = SettingToString(Setting)

        General.SetINIData(strFile, "Settings", strKey, Value.ToString)
    End Sub
#End Region

    Public Sub ShowEmailDlg(ByVal Frm As Form)
        Dim objForm As EmailDialog
        Dim Info As AssemblyInfo

        Info = New AssemblyInfo(Frm)
        objForm = New EmailDialog()
        With objForm
            .AddSubject("General message")
            .AddSubject("Reporting error/problem")
            .AddSubject("Report a sugestion")

            .From = Info.Product.Trim & "@" & Info.Product.Trim & ".com"
            .From = .From.Replace(" ", "_")
            .FromEnabled = False

            Select Case .ShowDialog(Frm)
                Case DialogResult.OK
                    Try
                        Web.Mail.SmtpMail.Send(.From, "createdbyx@yahoo.com", _
                                               .GetSelectedSubject, _
                                               "Title: " & Info.Title & vbCrLf & _
                                               "Version: " & Info.Version.ToString & vbCrLf & _
                                               "----------------------------------" & vbCrLf & _
                                               .Message)
                    Catch ex As Exception
                        Select Case ErrWin.ShowError(objForm, MsgBoxStyle.YesNo, "Error sending mail.", _
                        "There was a problem sending your email. If you are using WindowsXP Professional" & vbCrLf & _
                        "or one of the Microsoft Windows NT operating systems and you see this message" & vbCrLf & _
                        "make sure you have the 'Internet Information Services IIS -> SMTP Service'" & vbCrLf & _
                        "installed under the Add/Remove windows components dialog. If you are using", _
                        "WindowsXP Home or an earlier operating system you will not be able to send mail" & vbCrLf & _
                        "using this program." & vbCrLf & _
                        "-------------------------------------" & vbCrLf & _
                        "Would you like to view the error?" & vbCrLf & _
                        Info.Title)

                            Case DialogResult.Yes
                                ErrWin.ShowError(objForm, MsgBoxStyle.OKOnly, "Viewing error", ex.ToString, Info.Title)

                            Case DialogResult.No
                                'do notihng
                        End Select

                        Exit Sub
                    End Try

                Case DialogResult.Cancel
            End Select
        End With

        objForm.Dispose()
        objForm = Nothing
    End Sub

    Public Sub DrawPic(ByVal G As Graphics, ByVal I As Image, ByVal P As Point, ByVal ColorKey As Color, Optional ByVal UseColorKey As Boolean = False)
        Dim im As New Drawing.Imaging.ImageAttributes()
        Dim pps(2) As Point

        pps(0) = P
        pps(1) = New Point(P.X + I.Width, P.Y)
        pps(2) = New Point(P.X, P.Y + I.Height)

        If UseColorKey Then
            im.SetColorKey(ColorKey, ColorKey, Drawing.Imaging.ColorAdjustType.Bitmap)
            G.DrawImage(I, pps, General.ToRectangle(I), GraphicsUnit.Pixel, im)
        Else
            G.DrawImage(I, New Rectangle(P, I.Size))
        End If
    End Sub

    Public Sub DoMapImageExport()
        MsgBox("work in progress")
    End Sub

    Public Sub DoTrackedTilesExport(ByVal Owner As Form, ByVal Tiles As Extentions.TileTrackingCollection)
        Dim objForm As frmTileTrackingExport
        Dim ItemX As LVExportItem

        objForm = New frmTileTrackingExport()
        objForm.SetupExporters()
        If objForm.lvExporters.Items.Count = 0 Then
            ErrWin.ShowError(Owner, MsgBoxStyle.OKOnly Or MsgBoxStyle.Information, "Information", _
                             "There are no tile tracking exporters installed.")
        Else

            With objForm
                Select Case .ShowDialog(Owner)
                    Case DialogResult.OK
                        ItemX = .GetSelectedItem
                        Try
                            RunTTExporter(ItemX.FileName, ItemX.ObjectName, .txtSaveFile.Text.Trim, Tiles)
                        Catch ex As Exception
                            ErrWin.ShowError(Owner, MsgBoxStyle.OKOnly Or MsgBoxStyle.Critical, "Error?", _
                                             "The fallowing error was raised while trying to run the exporter ..." & vbCrLf & _
                                             "-----------------------------------" & vbCrLf & _
                                             ex.ToString)
                        End Try

                    Case DialogResult.Cancel
                        ' do nothing
                End Select
            End With
        End If

        objForm.Dispose()
        objForm = Nothing
    End Sub
End Module