'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: December 10, 2003
'=============================================

Public Class Connect
    Implements EasyG.Extentions.ITileTrackingExport

    Private Structure TileSetFile
        Public File As String
        Public ID As Integer
    End Structure

    Public ReadOnly Property FileTypeDescription() As String Implements CBX.Games.EasyG.Extentions.ITileTrackingExport.FileTypeDescription
        Get
            Return "XML *.XML"
        End Get
    End Property

    Public ReadOnly Property FileTypeExtention() As String Implements CBX.Games.EasyG.Extentions.ITileTrackingExport.FileTypeExtention
        Get
            Return "XML"
        End Get
    End Property

    Public Sub Run(ByVal Filename As String, ByVal TrackedTiles As CBX.Games.EasyG.Extentions.TileTrackingCollection) Implements CBX.Games.EasyG.Extentions.ITileTrackingExport.Run
        Dim F As Xml.XmlTextWriter
        Dim Files() As TileSetFile

        F = New Xml.XmlTextWriter(Filename, Text.Encoding.ASCII)
        F.WriteStartDocument(True)
        F.WriteStartElement("XMLTileSetV1")

        Files = BuidFileList(TrackedTiles)
        SaveFiles(F, Files)

        SaveTiles(F, Files, TrackedTiles)

        F.WriteEndElement()
        F.WriteEndDocument()
        F.Flush()
        F.Close()
        F = Nothing
        Erase Files
        Files = Nothing
    End Sub

    Private Sub SaveTiles(ByVal F As Xml.XmlTextWriter, ByVal Files() As TileSetFile, ByVal TrackedTiles As CBX.Games.EasyG.Extentions.TileTrackingCollection)
        Dim Item As EasyG.Extentions.TileTrackingItem


        F.WriteStartElement("Tiles")
        For Each Item In TrackedTiles
            F.WriteStartElement("Tile")

            F.WriteStartElement("Column")
            F.WriteString(Item.Column.ToString)
            F.WriteEndElement()    'column

            WriteRectangle(F, "Destination", Item.Destination)

            F.WriteStartElement("Layer")
            F.WriteString(Item.Layer.ToString)
            F.WriteEndElement()   'layer

            F.WriteStartElement("Row")
            F.WriteString(Item.Row.ToString)
            F.WriteEndElement()  'row

            WriteRectangle(F, "Source", Item.Source)

            F.WriteStartElement("TextureID")
            F.WriteString(GetID(Files, Item.Filename).ToString)
            F.WriteEndElement()      ' textureid

            F.WriteEndElement()   ' tile
        Next

        F.WriteEndElement() 'tiles
    End Sub

    Private Sub WriteRectangle(ByVal F As Xml.XmlTextWriter, ByVal ElementName As String, ByVal Rect As Drawing.Rectangle)
        F.WriteStartElement(ElementName)

        F.WriteStartElement("Left")
        F.WriteString(Rect.Left.ToString)
        F.WriteEndElement()

        F.WriteStartElement("Top")
        F.WriteString(Rect.Top.ToString)
        F.WriteEndElement()

        F.WriteStartElement("Width")
        F.WriteString(Rect.Width.ToString)
        F.WriteEndElement()

        F.WriteStartElement("Height")
        F.WriteString(Rect.Height.ToString)
        F.WriteEndElement()

        F.WriteEndElement()     ' element name
    End Sub

    Private Function BuidFileList(ByVal TrackedTiles As CBX.Games.EasyG.Extentions.TileTrackingCollection) As TileSetFile()
        Dim idx As Integer
        Dim Item As EasyG.Extentions.TileTrackingItem
        Dim Files() As TileSetFile

        For Each Item In TrackedTiles
            If Files Is Nothing Then
                ReDim Files(0)
            Else
                For idx = 0 To Files.Length - 1
                    If Files(idx).File.ToUpper = Item.Filename.ToUpper Then GoTo continueforloop
                Next

                ReDim Preserve Files(Files.Length)
            End If

            Files(Files.Length - 1).File = Item.Filename
            Files(Files.Length - 1).ID = Files.Length - 1

ContinueForLoop:
        Next

        Return Files
    End Function

    Private Sub SaveFiles(ByVal F As Xml.XmlTextWriter, ByVal Files() As TileSetFile)
        Dim idx As Integer


        F.WriteStartElement("Files")

        For idx = 0 To Files.Length - 1
            F.WriteStartElement("File")

            F.WriteStartElement("ID")
            F.WriteString(Files(idx).ID.ToString)
            F.WriteEndElement()

            Dim ff As IO.BinaryReader
            Dim Btys() As Byte
            ff = New IO.BinaryReader(IO.File.OpenRead(Files(idx).File))
            Btys = ff.ReadBytes(CInt(ff.BaseStream.Length))
            ff.Close()
            ff = Nothing

            F.WriteStartElement("StoredFile")
            F.WriteString(Convert.ToBase64String(Btys))
            F.WriteEndElement()

            F.WriteStartElement("OriginalStoredFileName")
            F.WriteString(IO.Path.GetFileName(Files(idx).File))
            F.WriteEndElement()

            F.WriteEndElement()
        Next

        F.WriteEndElement()
    End Sub

    Private Function GetID(ByVal FileList() As TileSetFile, ByVal File As String) As Integer
        Dim Item As TileSetFile

        For Each Item In FileList
            If Item.File.ToUpper = File.ToUpper Then Return Item.ID
        Next

        Return -1
    End Function

    Public ReadOnly Property Description() As String Implements CBX.Games.EasyG.Extentions.ITileTrackingExport.Description
        Get
            Return "Exports to a XML format."
        End Get
    End Property

    Public ReadOnly Property Title() As String Implements CBX.Games.EasyG.Extentions.ITileTrackingExport.Title
        Get
            Return "XML Tile Storage"
        End Get
    End Property
End Class
