Public Class OpenSaveColorItems
    Public Shared Function ReadFIle(ByVal Filename As String) As ColorItemCollection
        Dim objItem As Extentions.ColorItem
        Dim objFile As Grouper.GrouperReader
        Dim intCount, idx, intTmp As Integer
        Dim objCollection As ColorItemCollection

        Try
            objCollection = New ColorItemCollection()

            objFile = New Grouper.GrouperReader()
            objFile.Open(Filename)

            ' read header
            objFile.BeginDataBlock(0)
            objFile.ReadDataBlock(intCount)
            objFile.ReadDataBlock(intTmp)
            objCollection.BackColor = Color.FromArgb(intTmp)
            objFile.ReadDataBlock(objCollection.MaxWidth)
            objFile.ReadDataBlock(objCollection.TileSize)
            objFile.EndDataBlock()


            ' read colors
            objFile.BeginDataBlock(1)
            For idx = 0 To intCount - 1
                objItem = New Extentions.ColorItem()
                objFile.ReadDataBlock(intTmp)
                objItem.Color = Color.FromArgb(intTmp)
                objFile.ReadDataBlock(objItem.Value)
                objFile.ReadDataBlock(intTmp)
                objFile.ReadDataBlock(objItem.Name, intTmp)

                objCollection.Add(objItem)
            Next

            objFile.Close()
            objFile = Nothing

        Catch ex As Exception
            Try
                If Not objCollection Is Nothing Then
                    objCollection.Clear()
                    objCollection.Dispose()
                    objCollection = Nothing
                End If

            Catch clearcol As Exception
                ' ERR: do somthing
            End Try
        End Try

        Return objCollection
    End Function

    Public Shared Sub WriteFile(ByVal Filename As String, ByVal Collection As ColorItemCollection)
        Dim objFile As Grouper.GrouperWriter
        Dim idx As Integer


        Try
            If Collection Is Nothing Then Exit Sub

            objFile = New Grouper.GrouperWriter()
            objFile.Create(Filename)

            ' write header
            objFile.BeginDataBlock()
            objFile.WriteData(Collection.Count)
            objFile.WriteData(Collection.BackColor.ToArgb)
            objFile.WriteData(Collection.MaxWidth)
            objFile.WriteData(Collection.TileSize)
            objFile.EndDataBlock()


            ' write colors
            objFile.BeginDataBlock()
            For idx = 0 To Collection.Count - 1

                With CType(Collection(idx), ColorItem)
                    objFile.WriteData(.Color.ToArgb)
                    objFile.WriteData(.Value)
                    objFile.WriteData(.Name.Length)
                    objFile.WriteData(.Name)
                End With

            Next

            objFile.Close()
            objFile = Nothing

        Catch ex As Exception

        End Try
    End Sub
End Class
