'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: August 5, 2003
'=============================================

<ComClass(MSAnimationConverter.ClassId, MSAnimationConverter.InterfaceId, MSAnimationConverter.EventsId)> _
Public Class MSAnimationConverter

#Region "COM GUIDs"
    ' These  GUIDs provide the COM identity for this class 
    ' and its COM interfaces. If you change them, existing 
    ' clients will no longer be able to access the class.
    Public Const ClassId As String = "50E62ECD-B4FB-4739-8CB6-0A2B8EF57C52"
    Public Const InterfaceId As String = "1FB73E20-06F2-40E2-9D02-514DA2286968"
    Public Const EventsId As String = "FF4E661B-1ED9-431B-B5BD-0299A414D815"
#End Region

    Private Class Frame
        Public Frame As Integer
    End Class

    Private Class Point3
        Inherits Frame
        Public X, Y, Z As Single
    End Class

    Private Class AngleAxis
        Inherits Point3
        Public Angle As Single
    End Class

    Private Class MeshObject
        Public Name As String
        Public PositionKeys() As Point3
        Public RotationKeys() As AngleAxis
        Public ScaleKeys() As Point3
    End Class

    Public Function Convert(ByVal SourceFile As String, ByVal DestFile As String) As Boolean
        Dim objInFile As IO.StreamReader
        Dim strTmp As String
        Dim Objs() As MeshObject
        Dim intCurrentObj As Integer


        objInFile = New IO.StreamReader(SourceFile)

        While objInFile.Peek > -1
            ' read obj name
            strTmp = ReadObjName(objInFile)
            If strTmp <> "" Then
                ReDim Preserve Objs(intCurrentObj)
                intCurrentObj = Objs.Length - 1
                Objs(intCurrentObj) = New MeshObject()
                Objs(intCurrentObj).Name = strTmp

                ReadKeys(objInFile, Objs(intCurrentObj).PositionKeys)
                ReadKeys(objInFile, Objs(intCurrentObj).RotationKeys)
                ReadKeys(objInFile, Objs(intCurrentObj).ScaleKeys)

            End If
        End While

        SaveAniData(DestFile, Objs)
    End Function

    Private Sub ReadKeys(ByVal File As IO.StreamReader, ByRef Keys() As Point3)
        Dim idx, intCount, intCurrentKey As Integer
        Dim PosKey As Point3

        ' read pos key count
        intCount = ReadKeyCount(File)
        intCurrentKey = -1
        For idx = 0 To intCount - 1
            ' read pos keys
            ReadPos3Key(File, PosKey)

            ' add to key list
            ReDim Preserve Keys(intCurrentKey + 1)
            intCurrentKey = Keys.Length - 1
            Keys(intCurrentKey) = PosKey

            '' check for duplicates
            'For idy = 0 To Objs(intCurrentObj).Keys.GetUpperBound(0)
            '    ' check if frame added already
            '    If Objs(intCurrentObj).Keys(idy).Frame = intFrame Then
            '        ' if so do nothing (or replace)
            '    Else
            '        ' add to key
            '        ReDim Preserve Objs(intCurrentObj).Keys(Objs(intCurrentObj).Keys.GetUpperBound(0))
            '        Objs(intCurrentObj).Keys(Objs(intCurrentObj).Keys.GetUpperBound(0)) = PosKey
            '    End If
            'Next

        Next
    End Sub

    Private Sub ReadKeys(ByVal File As IO.StreamReader, ByRef Keys() As AngleAxis)
        Dim idx, intCount, intCurrentKey As Integer
        Dim RotKey As AngleAxis

        ' read rot key count
        intCount = ReadKeyCount(File)
        intCurrentKey = -1
        For idx = 0 To intCount - 1
            ' read rot keys
            ReadRotKey(File, RotKey)

            ' add to key list
            ReDim Preserve Keys(intCurrentKey + 1)
            intCurrentKey = Keys.Length - 1
            Keys(intCurrentKey) = RotKey

        Next
    End Sub

    Private Sub SaveAniData(ByVal Filename As String, ByVal Objs() As MeshObject)
        Dim objFile As CommonCommandsR3.Grouper.GrouperWriter
        Dim idx As Integer


        ' save ani data
        objFile = New CommonCommandsR3.Grouper.GrouperWriter(Filename)
        With objFile
            ' write header
            .BeginDataBlock()
            .WriteData(1) ' file version
            .WriteData(Objs.Length) 'Object count
            .EndDataBlock()

            ' write objs ani data
            For idx = 0 To Objs.Length - 1
                .BeginDataBlock()
                .WriteData(Objs(idx).Name.Length)
                .WriteData(Objs(idx).Name)
                .WriteData(Objs(idx).PositionKeys.Length)
                .WriteData(Objs(idx).RotationKeys.Length)
                .WriteData(Objs(idx).ScaleKeys.Length)

                WriteKeys(objFile, Objs(idx).PositionKeys)
                WriteKeys(objFile, Objs(idx).RotationKeys)
                WriteKeys(objFile, Objs(idx).ScaleKeys)

                .EndDataBlock()
            Next
        End With
    End Sub

    Private Sub WriteKeys(ByVal File As CommonCommandsR3.Grouper.GrouperWriter, ByVal Keys() As Point3)
        Dim idx As Integer

        ' store point3 keys
        For idx = 0 To Keys.Length - 1
            With Keys(idx)
                File.WriteData(.Frame)
                File.WriteData(.X)
                File.WriteData(.Y)
                File.WriteData(.Z)
            End With
        Next
    End Sub

    Private Sub WriteKeys(ByVal File As CommonCommandsR3.Grouper.GrouperWriter, ByVal Keys() As AngleAxis)
        Dim idx As Integer

        ' store rotation keys
        For idx = 0 To Keys.Length - 1
            With Keys(idx)
                File.WriteData(.Frame)
                File.WriteData(.Angle)
                File.WriteData(.X)
                File.WriteData(.Y)
                File.WriteData(.Z)
            End With
        Next
    End Sub

    Private Function ReadObjName(ByVal File As IO.StreamReader) As String
        Dim strTmp As String

        strTmp = File.ReadLine().Trim()
        If strTmp = "OK" Or strTmp = "" Then Return ""
        ' remove " from string
        strTmp = Mid(strTmp, 2, InStr(strTmp, "--") - 2).Trim
        Return strTmp
    End Function

    Private Function ReadKeyCount(ByVal File As IO.StreamReader) As Integer
        Dim strTmp As String

        strTmp = File.ReadLine().Trim()
        If strTmp = "OK" Or strTmp = "" Then Return -1
        ' remove " from string
        strTmp = Mid(strTmp, 2, InStr(strTmp, "--") - 2).Trim
        Return CInt(IIf(strTmp = "", 0, strTmp))
    End Function

    Private Sub ReadPos3Key(ByVal File As IO.StreamReader, ByRef Key As Point3)
        Dim strTmp, strSpl() As String

        strTmp = File.ReadLine().Trim()
        If strTmp = "OK" Or strTmp = "" Then
            Key = Nothing
            Exit Sub
        End If
        ' remove " from string
        strTmp = Mid(strTmp, 2).Trim
        strTmp = Mid(strTmp, 1, InStr(strTmp, """") - 1).Trim
        strSpl = strTmp.Split(",".Chars(0))

        Key = New Point3()
        strSpl(0) = Mid(strSpl(0), 1, InStr(strSpl(0).ToUpper, "F") - 1)
        Key.Frame = CInt(strSpl(0))
        Key.X = CSng(strSpl(1))
        Key.Y = CSng(strSpl(2))
        Key.Z = CSng(strSpl(3))
    End Sub

    Private Sub ReadRotKey(ByVal File As IO.StreamReader, ByRef Key As AngleAxis)
        Dim strTmp, strSpl() As String

        strTmp = File.ReadLine().Trim()
        ' remove " from string
        strTmp = Mid(strTmp, 2)
        strTmp = Mid(strTmp, 1, InStr(strTmp, """") - 1).Trim
        strSpl = strTmp.Split(",".Chars(0))

        Key = New AngleAxis()
        strSpl(0) = Mid(strSpl(0), 1, InStr(strSpl(0), "f") - 1)
        Key.Frame = CInt(strSpl(0))
        Key.Angle = CSng(strSpl(1))
        Key.X = CSng(strSpl(2))
        Key.Y = CSng(strSpl(3))
        Key.Z = CSng(strSpl(4))
    End Sub
End Class
