'Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: Monday, December 23, 2002
'=============================================

Public Module General
    ''' <summary>
    ''' Builds a treenode hiarchy from a given path.
    ''' </summary>
    ''' <param name="Pth">A array of strings representing the path.</param>
    ''' <param name="Index">The start index in the path to start at.</param>
    ''' <param name="Nodes">A reference to a nodes collection.</param>
    ''' <returns>If successfull will return a reference to the treenode.</returns>
    Public Function BuildNodePath(ByVal Pth() As String, ByVal Index As Integer, ByVal Nodes As TreeNodeCollection) As TreeNode
        Dim idx As Integer
        Dim NodeX As TreeNode

        Try
            ' check if indes is beyond
            If Index = Pth.Length Then Return Nothing

            ' try to find node
            With Nodes.GetEnumerator
                .Reset()
                While .MoveNext
                    With CType(.Current, TreeNode)
                        If .Text.ToUpper = Pth(Index).ToUpper Then
                            NodeX = BuildNodePath(Pth, Index + 1, .Nodes)
                            If NodeX Is Nothing Then Return Nothing
                        End If
                    End With
                End While
            End With

            If NodeX Is Nothing Then
                NodeX = New TreeNode()
                NodeX.Text = Pth(Index)
                Nodes.Add(NodeX)
                If Index <> Pth.Length - 1 Then
                    NodeX = BuildNodePath(Pth, Index + 1, NodeX.Nodes)
                End If
            End If

            Return NodeX

        Catch ex As Exception
            MsgBox(ex.ToString)
        End Try
    End Function

    ''' <summary>
    ''' Gets the file descriptionfor a registerd file type.
    ''' </summary>
    ''' <param name="File">The name of the file to get the file type description from. NOTE: that the 
    '''                    files does not have to exist. GetEXTDescription is only interexted in the file extention.</param>
    ''' <returns>Returns the file type description for the specified file.</returns>
    Public Function GetEXTDescription(ByVal File As String) As String
        Dim R As Microsoft.Win32.RegistryKey
        Dim strTmp As String


        R = Microsoft.Win32.Registry.ClassesRoot.OpenSubKey(IO.Path.GetExtension(File))
        strTmp = CStr(R.GetValue(""))
        If strTmp Is Nothing Then Return Nothing

        R = Microsoft.Win32.Registry.ClassesRoot.OpenSubKey(strTmp)
        strTmp = CStr(R.GetValue(""))

        Return strTmp
    End Function

#Region " Inbounds ... "
    'TODO: add more inbound overloads
    Public Function InBounds(ByVal Value As Long, ByVal Min As Long, ByVal Max As Long) As Boolean
        Return CBool(Value >= Min And Value <= Max)
    End Function

    Public Function InBounds(ByVal Value As Single, ByVal Min As Single, ByVal Max As Single) As Boolean
        Return CBool(Value >= Min And Value <= Max)
    End Function

    Public Function InBounds(ByVal Value As Short, ByVal Min As Short, ByVal Max As Short) As Boolean
        Return CBool(Value >= Min And Value <= Max)
    End Function

    Public Function InBounds(ByVal Value As Integer, ByVal Min As Integer, ByVal Max As Integer) As Boolean
        Return CBool(Value >= Min And Value <= Max)
    End Function

    Public Function InBounds(ByVal Value As Byte, ByVal Min As Byte, ByVal Max As Byte) As Boolean
        Return CBool(Value >= Min And Value <= Max)
    End Function

    Public Function InBounds(ByVal Value As Char, ByVal Min As Char, ByVal Max As Char) As Boolean
        Return CBool(Value >= Min And Value <= Max)
    End Function

    Public Function InBounds(ByVal Value As Decimal, ByVal Min As Decimal, ByVal Max As Decimal) As Boolean
        Return CBool(Value >= Min And Value <= Max)
    End Function

    Public Function InBounds(ByVal Value As Double, ByVal Min As Double, ByVal Max As Double) As Boolean
        Return CBool(Value >= Min And Value <= Max)
    End Function

    Public Function InBounds(ByVal P As Point, ByVal R As Rectangle) As Boolean
        Return CBool(InBounds(P.X, R.Left, R.Left + R.Width) And _
                     InBounds(P.Y, R.Top, R.Top + R.Height))
    End Function

    Public Function InBounds(ByVal P As PointF, ByVal R As Rectangle) As Boolean
        Return CBool(InBounds(P.X, R.Left, R.Left + R.Width) And _
                     InBounds(P.Y, R.Top, R.Top + R.Height))
    End Function

    Public Function InBounds(ByVal P As Point, ByVal R As RectangleF) As Boolean
        Return CBool(InBounds(P.X, R.Left, R.Left + R.Width) And _
                     InBounds(P.Y, R.Top, R.Top + R.Height))
    End Function

    Public Function InBounds(ByVal P As PointF, ByVal R As RectangleF) As Boolean
        Return CBool(InBounds(P.X, R.Left, R.Left + R.Width) And _
                     InBounds(P.Y, R.Top, R.Top + R.Height))
    End Function

    Public Function InBounds(ByVal P As Point, ByVal S As Size) As Boolean
        Return CBool(InBounds(P.X, 0, S.Width) And InBounds(P.Y, 0, S.Height))
    End Function

    Public Function InBounds(ByVal P As Point, ByVal S As SizeF) As Boolean
        Return CBool(InBounds(P.X, 0, S.Width) And InBounds(P.Y, 0, S.Height))
    End Function

    Public Function InBounds(ByVal P As PointF, ByVal S As Size) As Boolean
        Return CBool(InBounds(P.X, 0, S.Width) And InBounds(P.Y, 0, S.Height))
    End Function

    Public Function InBounds(ByVal P As PointF, ByVal S As SizeF) As Boolean
        Return CBool(InBounds(P.X, 0, S.Width) And InBounds(P.Y, 0, S.Height))
    End Function

    Public Function InBounds(ByVal PX As Integer, ByVal PY As Integer, ByVal R As Rectangle) As Boolean
        Return CBool(InBounds(PX, R.Left, R.Left + R.Width) And _
                     InBounds(PY, R.Top, R.Top + R.Height))
    End Function

    Public Function InBounds(ByVal PX As Single, ByVal PY As Single, ByVal R As Rectangle) As Boolean
        Return CBool(InBounds(PX, R.Left, R.Left + R.Width) And _
                     InBounds(PY, R.Top, R.Top + R.Height))
    End Function

    Public Function InBounds(ByVal PX As Integer, ByVal PY As Integer, ByVal R As RectangleF) As Boolean
        Return CBool(InBounds(PX, R.Left, R.Left + R.Width) And _
                     InBounds(PY, R.Top, R.Top + R.Height))
    End Function

    Public Function InBounds(ByVal PX As Single, ByVal PY As Single, ByVal R As RectangleF) As Boolean
        Return CBool(InBounds(PX, R.Left, R.Left + R.Width) And _
                     InBounds(PY, R.Top, R.Top + R.Height))
    End Function

    Public Function InBounds(ByVal PX As Integer, ByVal PY As Integer, ByVal S As Size) As Boolean
        Return CBool(InBounds(PX, 0, S.Width) And InBounds(PY, 0, S.Height))
    End Function

    Public Function InBounds(ByVal PX As Integer, ByVal PY As Integer, ByVal S As SizeF) As Boolean
        Return CBool(InBounds(PX, 0, S.Width) And InBounds(PY, 0, S.Height))
    End Function

    Public Function InBounds(ByVal PX As Single, ByVal PY As Single, ByVal S As Size) As Boolean
        Return CBool(InBounds(PX, 0, S.Width) And InBounds(PY, 0, S.Height))
    End Function

    Public Function InBounds(ByVal PX As Single, ByVal PY As Single, ByVal S As SizeF) As Boolean
        Return CBool(InBounds(PX, 0, S.Width) And InBounds(PY, 0, S.Height))
    End Function

    Public Function InBounds(ByVal PX As Integer, ByVal PY As Integer, ByVal Left As Integer, ByVal Top As Integer, ByVal Width As Integer, ByVal Height As Integer) As Boolean
        Return CBool(InBounds(PX, Left, Left + Width) And _
                     InBounds(PY, Top, Top + Height))
    End Function

    Public Function InBounds(ByVal PX As Single, ByVal PY As Single, ByVal Left As Integer, ByVal Top As Integer, ByVal Width As Integer, ByVal Height As Integer) As Boolean
        Return CBool(InBounds(PX, Left, Left + Width) And _
                     InBounds(PY, Top, Top + Height))
    End Function

    Public Function InBounds(ByVal PX As Integer, ByVal PY As Integer, ByVal Left As Single, ByVal Top As Single, ByVal Width As Single, ByVal Height As Single) As Boolean
        Return CBool(InBounds(PX, Left, Left + Width) And _
                     InBounds(PY, Top, Top + Height))
    End Function

    Public Function InBounds(ByVal PX As Single, ByVal PY As Single, ByVal Left As Single, ByVal Top As Single, ByVal Width As Single, ByVal Height As Single) As Boolean
        Return CBool(InBounds(PX, Left, Left + Width) And _
                     InBounds(PY, Top, Top + Height))
    End Function

    Public Function InBounds(ByVal PX As Integer, ByVal PY As Integer, ByVal P As Point, ByVal Width As Integer, ByVal Height As Integer) As Boolean
        Return CBool(InBounds(PX, P.X, P.X + Width) And _
                     InBounds(PY, P.Y, P.Y + Height))
    End Function

    Public Function InBounds(ByVal PX As Single, ByVal PY As Single, ByVal P As Point, ByVal Width As Integer, ByVal Height As Integer) As Boolean
        Return CBool(InBounds(PX, P.X, P.X + Width) And _
                     InBounds(PY, P.Y, P.Y + Height))
    End Function

    Public Function InBounds(ByVal PX As Integer, ByVal PY As Integer, ByVal P As PointF, ByVal Width As Single, ByVal Height As Single) As Boolean
        Return CBool(InBounds(PX, P.X, P.X + Width) And _
                     InBounds(PY, P.Y, P.Y + Height))
    End Function

    Public Function InBounds(ByVal PX As Single, ByVal PY As Single, ByVal P As PointF, ByVal Width As Single, ByVal Height As Single) As Boolean
        Return CBool(InBounds(PX, P.X, P.X + Width) And _
                     InBounds(PY, P.Y, P.Y + Height))
    End Function

    Public Function InBounds(ByVal PX As Integer, ByVal PY As Integer, ByVal Left As Integer, ByVal Top As Integer, ByVal S As Size) As Boolean
        Return CBool(InBounds(PX, Left, Left + S.Width) And _
                     InBounds(PY, Top, Top + S.Height))
    End Function

    Public Function InBounds(ByVal PX As Single, ByVal PY As Single, ByVal Left As Integer, ByVal Top As Integer, ByVal S As Size) As Boolean
        Return CBool(InBounds(PX, Left, Left + S.Width) And _
                     InBounds(PY, Top, Top + S.Height))
    End Function

    Public Function InBounds(ByVal PX As Integer, ByVal PY As Integer, ByVal Left As Single, ByVal Top As Single, ByVal S As SizeF) As Boolean
        Return CBool(InBounds(PX, Left, Left + S.Width) And _
                     InBounds(PY, Top, Top + S.Height))
    End Function

    Public Function InBounds(ByVal PX As Single, ByVal PY As Single, ByVal Left As Single, ByVal Top As Single, ByVal S As SizeF) As Boolean
        Return CBool(InBounds(PX, Left, Left + S.Width) And _
                     InBounds(PY, Top, Top + S.Height))
    End Function

    Public Function InBounds(ByVal PX As Integer, ByVal PY As Integer, ByVal Width As Integer, ByVal Height As Integer) As Boolean
        Return CBool(InBounds(PX, 0, Width) And InBounds(PY, 0, Height))
    End Function

    Public Function InBounds(ByVal PX As Integer, ByVal PY As Integer, ByVal Width As Single, ByVal Height As Single) As Boolean
        Return CBool(InBounds(PX, 0, Width) And InBounds(PY, 0, Height))
    End Function

    Public Function InBounds(ByVal PX As Single, ByVal PY As Single, ByVal Width As Integer, ByVal Height As Integer) As Boolean
        Return CBool(InBounds(PX, 0, Width) And InBounds(PY, 0, Height))
    End Function

    Public Function InBounds(ByVal PX As Single, ByVal PY As Single, ByVal Width As Single, ByVal Height As Single) As Boolean
        Return CBool(InBounds(PX, 0, Width) And InBounds(PY, 0, Height))
    End Function
#End Region

#Region " Min/Max functions ... "
    Public Function Min(ByVal EnumType As [Enum]) As Object
        Dim Values As Array
        Dim idx As Integer
        Dim objCurrent As Object


        Values = EnumType.GetValues(EnumType.GetType)
        For idx = 0 To Values.Length - 1
            If IsNumeric(Values.GetValue(idx)) Then
                If Val(objCurrent) > Val(Values.GetValue(idx)) Then objCurrent = Values.GetValue(idx)
            End If
        Next

        Return objCurrent
    End Function

    Public Function Max(ByVal EnumType As [Enum]) As Object
        Dim Values As Array
        Dim idx As Integer
        Dim objCurrent As Object


        Values = EnumType.GetValues(EnumType.GetType)
        For idx = 0 To Values.Length - 1
            If IsNumeric(Values.GetValue(idx)) Then
                If Val(objCurrent) < Val(Values.GetValue(idx)) Then objCurrent = Values.GetValue(idx)
            End If
        Next

        Return objCurrent
    End Function

    ' --------------------------
    ' --- Min Max base functions
    ' --------------------------

    Public Function Max(ByVal Value1 As Object, ByVal Value2 As Object) As Object
        If Not IsNumeric(Value1) Then
            Throw New ArgumentException("The 'Value1' parameter is not a numeric value.", "Value1")
        End If

        If Not IsNumeric(Value2) Then
            Throw New ArgumentException("The 'Value2' parameter is not a numeric value.", "Value2")
        End If

        Return IIf(Val(Value1) < Val(Value2), Value2, Value1)
    End Function

    Public Function Min(ByVal Value1 As Object, ByVal Value2 As Object) As Object
        If Not IsNumeric(Value1) Then
            Throw New ArgumentException("The 'Value1' parameter is not a numeric value.", "Value1")
        End If

        If Not IsNumeric(Value2) Then
            Throw New ArgumentException("The 'Value2' parameter is not a numeric value.", "Value2")
        End If

        Return IIf(Val(Value1) < Val(Value2), Value1, Value2)
    End Function

#End Region

#Region " Center overloads ... "
    'TODO: add more center overloads!
    Public Function Center(ByVal Rect As Rectangle) As Point
        Return New Point(Center(Rect.Left, Rect.Left + Rect.Width), Center(Rect.Top, Rect.Top + Rect.Height))
    End Function

    Public Function Center(ByVal Size As Size) As Point
        Return New Point(Size.Width \ 2, Size.Height \ 2)
    End Function

    Public Function Center(ByVal Min As Integer, ByVal Max As Integer) As Integer
        Return (Max - Min) \ 2
    End Function
#End Region

#Region " ToPoint overloads ... "
    Public Function ToPoint(ByVal P As PointF) As Point
        Return New Point(CInt(P.X), CInt(P.Y))
    End Function

    Public Function ToPoint(ByVal X As Single, ByVal Y As Single) As Point
        Return New Point(CInt(X), CInt(Y))
    End Function

    Public Function ToPointF(ByVal P As Point) As PointF
        Return New PointF(P.X, P.Y)
    End Function

    Public Function ToPointF(ByVal X As Integer, ByVal Y As Integer) As PointF
        Return New PointF(X, Y)
    End Function
#End Region

#Region " ToSize overloads ... "
    Public Function ToSize(ByVal S As SizeF) As Size
        Return New Size(CInt(S.Width), CInt(S.Height))
    End Function

    Public Function ToSize(ByVal Width As Single, ByVal Height As Single) As Size
        Return New Size(CInt(Width), CInt(Height))
    End Function

    Public Function ToSizeF(ByVal S As Size) As SizeF
        Return New SizeF(S.Width, S.Height)
    End Function

    Public Function ToSizeF(ByVal Width As Integer, ByVal Height As Integer) As SizeF
        Return New SizeF(Width, Height)
    End Function

    Public Function ToSize(ByVal I As Image) As Size
        Return New Size(I.Width, I.Height)
    End Function

    Public Function ToSizeF(ByVal I As Image) As SizeF
        Return New SizeF(I.Width, I.Height)
    End Function
#End Region

#Region " RectangleFromCenter overloads ... "
    'ERR: possible stack overflow error with these overloads check and tripple check them
    Public Function RectangleFromCenter(ByVal Center As Point, ByVal Size As Size) As Rectangle
        Return New Rectangle(Center.X - (Size.Width \ 2), Center.Y - (Size.Height \ 2), Size.Width, Size.Height)
    End Function

    Public Function RectangleFromCenter(ByVal Center As PointF, ByVal Size As Size) As Rectangle
        Return RectangleFromCenter(ToPoint(Center), Size)
    End Function

    Public Function RectangleFromCenter(ByVal Center As Point, ByVal Size As SizeF) As Rectangle
        Return RectangleFromCenter(Center, ToSize(Size))
    End Function

    Public Function RectangleFromCenter(ByVal Center As PointF, ByVal Size As SizeF) As Rectangle
        Return RectangleFromCenter(ToPoint(Center), ToSize(Size))
    End Function
    '--------
    Public Function RectangleFromCenter(ByVal CenterX As Integer, ByVal CenterY As Integer, ByVal Size As Size) As Rectangle
        Return RectangleFromCenter(New Point(CenterX, CenterY), Size)
    End Function

    Public Function RectangleFromCenter(ByVal Center As Point, ByVal Width As Integer, ByVal Height As Integer) As Rectangle
        Return RectangleFromCenter(Center, New Size(Width, Height))
    End Function

    Public Function RectangleFromCenter(ByVal CenterX As Single, ByVal CenterY As Single, ByVal Size As Size) As Rectangle
        Return RectangleFromCenter(ToPoint(CenterX, CenterY), Size)
    End Function

    Public Function RectangleFromCenter(ByVal Center As PointF, ByVal Width As Integer, ByVal Height As Integer) As Rectangle
        Return RectangleFromCenter(ToPoint(Center), New Size(Width, Height))
    End Function

    Public Function RectangleFromCenter(ByVal CenterX As Integer, ByVal CenterY As Integer, ByVal Size As SizeF) As Rectangle
        Return RectangleFromCenter(New Point(CenterX, CenterY), ToSize(Size))
    End Function

    Public Function RectangleFromCenter(ByVal Center As Point, ByVal Width As Single, ByVal Height As Single) As Rectangle
        Return RectangleFromCenter(Center, ToSize(Width, Height))
    End Function

    Public Function RectangleFromCenter(ByVal CenterX As Single, ByVal CenterY As Single, ByVal Size As SizeF) As Rectangle
        Return RectangleFromCenter(ToPoint(CenterX, CenterY), ToSize(Size))
    End Function

    Public Function RectangleFromCenter(ByVal Center As PointF, ByVal Width As Single, ByVal Height As Single) As Rectangle
        Return RectangleFromCenter(ToPoint(Center), ToSize(Width, Height))
    End Function
    '-----------
    Public Function RectangleFromCenter(ByVal CenterX As Integer, ByVal CenterY As Integer, ByVal Width As Integer, ByVal Height As Integer) As Rectangle
        Return RectangleFromCenter(ToPoint(CenterX, CenterY), ToSize(Width, Height))
    End Function

    Public Function RectangleFromCenter(ByVal CenterX As Single, ByVal CenterY As Single, ByVal Width As Single, ByVal Height As Single) As Rectangle
        Return RectangleFromCenter(ToPoint(CenterX, CenterY), ToSize(Width, Height))
    End Function
#End Region

#Region " RectangleFromCenterF overloads ... "
    'ERR: possible stack overflow error with these overloads check and tripple check them
    Public Function RectangleFFromCenter(ByVal Center As Point, ByVal Size As Size) As RectangleF
        Return RectangleFFromCenter(ToPointF(Center), ToSizeF(Size))
    End Function

    Public Function RectangleFFromCenter(ByVal Center As PointF, ByVal Size As Size) As RectangleF
        Return RectangleFFromCenter(Center, Size)
    End Function

    Public Function RectangleFFromCenter(ByVal Center As Point, ByVal Size As SizeF) As RectangleF
        Return RectangleFFromCenter(Center, Size)
    End Function

    Public Function RectangleFFromCenter(ByVal Center As PointF, ByVal Size As SizeF) As RectangleF
        Return New RectangleF(Center.X - (Size.Width / 2), Center.Y - (Size.Height / 2), Size.Width, Size.Height)
    End Function
    '--------
    Public Function RectangleFFromCenter(ByVal CenterX As Integer, ByVal CenterY As Integer, ByVal Size As Size) As RectangleF
        Return RectangleFFromCenter(New PointF(CenterX, CenterY), Size)
    End Function

    Public Function RectangleFFromCenter(ByVal Center As Point, ByVal Width As Integer, ByVal Height As Integer) As RectangleF
        Return RectangleFFromCenter(Center, New SizeF(Width, Height))
    End Function

    Public Function RectangleFFromCenter(ByVal CenterX As Single, ByVal CenterY As Single, ByVal Size As Size) As RectangleF
        Return RectangleFFromCenter(New PointF(CenterX, CenterY), Size)
    End Function

    Public Function RectangleFFromCenter(ByVal Center As PointF, ByVal Width As Integer, ByVal Height As Integer) As RectangleF
        Return RectangleFFromCenter(Center, New SizeF(Width, Height))
    End Function

    Public Function RectangleFFromCenter(ByVal CenterX As Integer, ByVal CenterY As Integer, ByVal Size As SizeF) As RectangleF
        Return RectangleFFromCenter(ToPointF(CenterX, CenterY), Size)
    End Function

    Public Function RectangleFFromCenter(ByVal Center As Point, ByVal Width As Single, ByVal Height As Single) As RectangleF
        Return RectangleFFromCenter(Center, New SizeF(Width, Height))
    End Function

    Public Function RectangleFFromCenter(ByVal CenterX As Single, ByVal CenterY As Single, ByVal Size As SizeF) As RectangleF
        Return RectangleFFromCenter(New PointF(CenterX, CenterY), Size)
    End Function

    Public Function RectangleFFromCenter(ByVal Center As PointF, ByVal Width As Single, ByVal Height As Single) As RectangleF
        Return RectangleFFromCenter(Center, New SizeF(Width, Height))
    End Function
    '-----------
    Public Function RectangleFFromCenter(ByVal CenterX As Integer, ByVal CenterY As Integer, ByVal Width As Integer, ByVal Height As Integer) As RectangleF
        Return RectangleFFromCenter(ToPointF(CenterX, CenterY), ToSizeF(Width, Height))
    End Function

    Public Function RectangleFFromCenter(ByVal CenterX As Single, ByVal CenterY As Single, ByVal Width As Single, ByVal Height As Single) As RectangleF
        Return RectangleFFromCenter(New PointF(CenterX, CenterY), New SizeF(Width, Height))
    End Function
#End Region

#Region " ExpandRectangle overloads ... "
    Public Function ExpandRectangle(ByVal r As Rectangle, ByVal Ammount As Integer) As Rectangle
        Dim intHalfAmmount As Integer

        intHalfAmmount = Ammount \ 2
        Return New Rectangle(r.Left - intHalfAmmount, r.Top - intHalfAmmount, _
                             r.Width + Ammount, r.Height + Ammount)
    End Function

    Public Function ExpandRectangle(ByVal r As Rectangle, ByVal AmmountX As Integer, ByVal AmmountY As Integer) As Rectangle
        Dim intHalfAmmountX, intHalfAmmountY As Integer

        intHalfAmmountX = AmmountX \ 2
        intHalfAmmountY = AmmountY \ 2
        Return New Rectangle(r.Left - intHalfAmmountX, r.Top - intHalfAmmountY, _
                             r.Width + AmmountX, r.Height + AmmountY)
    End Function

    Public Function ExpandRectangle(ByVal r As Rectangle, ByVal Ammount As Point) As Rectangle
        Dim intHalfAmmountX, intHalfAmmountY As Integer

        intHalfAmmountX = Ammount.X \ 2
        intHalfAmmountY = Ammount.Y \ 2
        Return New Rectangle(r.Left - intHalfAmmountX, r.Top - intHalfAmmountY, _
                             r.Width + Ammount.X, r.Height + Ammount.Y)
    End Function

    Public Function ExpandRectangle(ByVal r As Rectangle, ByVal Ammount As Size) As Rectangle
        Dim intHalfAmmountX, intHalfAmmountY As Integer

        intHalfAmmountX = Ammount.Width \ 2
        intHalfAmmountY = Ammount.Height \ 2
        Return New Rectangle(r.Left - intHalfAmmountX, r.Top - intHalfAmmountY, _
                             r.Width + Ammount.Width, r.Height + Ammount.Height)
    End Function

    Public Function ExpandRectangle(ByVal r As RectangleF, ByVal Ammount As Double) As RectangleF
        Dim intHalfAmmount As Double

        intHalfAmmount = Ammount / 2
        Return New RectangleF(CSng(r.Left - intHalfAmmount), CSng(r.Top - intHalfAmmount), _
                              CSng(r.Width + Ammount), CSng(r.Height + Ammount))
    End Function

    Public Function ExpandRectangle(ByVal r As RectangleF, ByVal AmmountX As Double, ByVal AmmountY As Double) As RectangleF
        Dim intHalfAmmountX, intHalfAmmountY As Double

        intHalfAmmountX = AmmountX / 2
        intHalfAmmountY = AmmountY / 2
        Return New RectangleF(CSng(r.Left - intHalfAmmountX), CSng(r.Top - intHalfAmmountY), _
                              CSng(r.Width + AmmountX), CSng(r.Height + AmmountY))
    End Function

    Public Function ExpandRectangle(ByVal r As RectangleF, ByVal Ammount As PointF) As RectangleF
        Dim intHalfAmmountX, intHalfAmmountY As Double

        intHalfAmmountX = Ammount.X / 2
        intHalfAmmountY = Ammount.Y / 2
        Return New RectangleF(CSng(r.Left - intHalfAmmountX), CSng(r.Top - intHalfAmmountY), _
                              CSng(r.Width + Ammount.X), CSng(r.Height + Ammount.Y))
    End Function

    Public Function ExpandRectangle(ByVal r As RectangleF, ByVal Ammount As SizeF) As RectangleF
        Dim intHalfAmmountX, intHalfAmmountY As Double

        intHalfAmmountX = CSng(Ammount.Width / 2)
        intHalfAmmountY = CSng(Ammount.Height / 2)
        Return New RectangleF(CSng(r.Left - intHalfAmmountX), CSng(r.Top - intHalfAmmountY), _
                              CSng(r.Width + Ammount.Width), CSng(r.Height + Ammount.Height))
    End Function
#End Region

#Region " LocationInRectangle overloads ... "
    Public Function LocationInRectangle(ByVal P As Point, ByVal R As Rectangle) As Point
        Return CType(IIf(InBounds(P, R), New Point(P.X - R.Left, P.Y - R.Top), New Point(-1, -1)), Point)
    End Function

    Public Function LocationInRectangle(ByVal P As PointF, ByVal R As Rectangle) As Point
        Return CType(IIf(InBounds(P, R), New Point(CInt(P.X - R.Left), CInt(P.Y - R.Top)), New Point(-1, -1)), Point)
    End Function

    Public Function LocationInRectangle(ByVal P As Point, ByVal R As RectangleF) As Point
        Return CType(IIf(InBounds(P, R), New Point(CInt(P.X - R.Left), CInt(P.Y - R.Top)), New Point(-1, -1)), Point)
    End Function

    Public Function LocationInRectangle(ByVal P As PointF, ByVal R As RectangleF) As Point
        Return CType(IIf(InBounds(P, R), New Point(CInt(P.X - R.Left), CInt(P.Y - R.Top)), New Point(-1, -1)), Point)
    End Function
#End Region

#Region " AddToPoint overloads ... "
    Public Function AddToPoint(ByVal P As Point, ByVal Value As Point) As Point
        Return New Point(P.X + Value.X, P.Y + Value.Y)
    End Function

    Public Function AddToPoint(ByVal P As Point, ByVal Value As PointF) As Point
        Return New Point(CInt(P.X + Value.X), CInt(P.Y + Value.Y))
    End Function

    Public Function AddToPoint(ByVal P As Point, ByVal Value As Long) As Point
        Return New Point(P.X + CInt(Value), P.Y + CInt(Value))
    End Function

    Public Function AddToPoint(ByVal P As Point, ByVal Value As Integer) As Point
        Return New Point(P.X + Value, P.Y + Value)
    End Function

    Public Function AddToPoint(ByVal P As Point, ByVal Value As Byte) As Point
        Return New Point(P.X + Value, P.Y + Value)
    End Function

    Public Function AddToPoint(ByVal P As Point, ByVal Value As Single) As Point
        Return New Point(P.X + CInt(Value), P.Y + CInt(Value))
    End Function

    Public Function AddToPoint(ByVal P As Point, ByVal Value As Short) As Point
        Return New Point(P.X + Value, P.Y + Value)
    End Function

    Public Function AddToPoint(ByVal P As Point, ByVal Value As Double) As Point
        Return New Point(P.X + CInt(Value), P.Y + CInt(Value))
    End Function

    Public Function AddToPoint(ByVal P As Point, ByVal Value As Decimal) As Point
        Return New Point(P.X + CInt(Value), P.Y + CInt(Value))
    End Function

    Public Function AddToPoint(ByVal P As Point, ByVal ValueX As Long, ByVal ValueY As Long) As Point
        Return New Point(P.X + CInt(ValueX), P.Y + CInt(ValueY))
    End Function

    Public Function AddToPoint(ByVal P As Point, ByVal ValueX As Integer, ByVal ValueY As Integer) As Point
        Return New Point(P.X + ValueX, P.Y + ValueY)
    End Function

    Public Function AddToPoint(ByVal P As Point, ByVal ValueX As Byte, ByVal ValueY As Byte) As Point
        Return New Point(P.X + ValueX, P.Y + ValueY)
    End Function

    Public Function AddToPoint(ByVal P As Point, ByVal ValueX As Single, ByVal ValueY As Single) As Point
        Return New Point(P.X + CInt(ValueX), P.Y + CInt(ValueY))
    End Function

    Public Function AddToPoint(ByVal P As Point, ByVal ValueX As Short, ByVal ValueY As Short) As Point
        Return New Point(P.X + ValueX, P.Y + ValueY)
    End Function

    Public Function AddToPoint(ByVal P As Point, ByVal ValueX As Double, ByVal ValueY As Double) As Point
        Return New Point(P.X + CInt(ValueX), P.Y + CInt(ValueY))
    End Function

    Public Function AddToPoint(ByVal P As Point, ByVal ValueX As Decimal, ByVal ValueY As Decimal) As Point
        Return New Point(P.X + CInt(ValueX), P.Y + CInt(ValueY))
    End Function

    Public Function AddToPointF(ByVal P As PointF, ByVal Value As PointF) As PointF
        Return New PointF(P.X + Value.X, P.Y + Value.Y)
    End Function

    Public Function AddToPointF(ByVal P As PointF, ByVal Value As Point) As PointF
        Return New PointF(P.X + Value.X, P.Y + Value.Y)
    End Function

    Public Function AddToPointF(ByVal P As PointF, ByVal Value As Long) As PointF
        Return New PointF(P.X + Value, P.Y + Value)
    End Function

    Public Function AddToPointF(ByVal P As PointF, ByVal Value As Integer) As PointF
        Return New PointF(P.X + Value, P.Y + Value)
    End Function

    Public Function AddToPointF(ByVal P As PointF, ByVal Value As Byte) As PointF
        Return New PointF(P.X + Value, P.Y + Value)
    End Function

    Public Function AddToPointF(ByVal P As PointF, ByVal Value As Single) As PointF
        Return New PointF(P.X + Value, P.Y + Value)
    End Function

    Public Function AddToPointF(ByVal P As PointF, ByVal Value As Short) As PointF
        Return New PointF(P.X + Value, P.Y + Value)
    End Function

    Public Function AddToPointF(ByVal P As PointF, ByVal Value As Double) As PointF
        Return New PointF(P.X + CSng(Value), P.Y + CSng(Value))
    End Function

    Public Function AddToPointF(ByVal P As PointF, ByVal Value As Decimal) As PointF
        Return New PointF(P.X + Value, P.Y + Value)
    End Function

    Public Function AddToPointF(ByVal P As PointF, ByVal ValueX As Long, ByVal ValueY As Long) As PointF
        Return New PointF(P.X + ValueX, P.Y + ValueY)
    End Function

    Public Function AddToPointF(ByVal P As PointF, ByVal ValueX As Integer, ByVal ValueY As Integer) As PointF
        Return New PointF(P.X + ValueX, P.Y + ValueY)
    End Function

    Public Function AddToPointF(ByVal P As PointF, ByVal ValueX As Byte, ByVal ValueY As Byte) As PointF
        Return New PointF(P.X + ValueX, P.Y + ValueY)
    End Function

    Public Function AddToPointF(ByVal P As PointF, ByVal ValueX As Single, ByVal ValueY As Single) As PointF
        Return New PointF(P.X + ValueX, P.Y + ValueY)
    End Function

    Public Function AddToPointF(ByVal P As PointF, ByVal ValueX As Short, ByVal ValueY As Short) As PointF
        Return New PointF(P.X + ValueX, P.Y + ValueY)
    End Function

    Public Function AddToPointF(ByVal P As PointF, ByVal ValueX As Double, ByVal ValueY As Double) As PointF
        Return New PointF(P.X + CSng(ValueX), P.Y + CSng(ValueY))
    End Function

    Public Function AddToPointF(ByVal P As PointF, ByVal ValueX As Decimal, ByVal ValueY As Decimal) As PointF
        Return New PointF(P.X + ValueX, P.Y + ValueY)
    End Function
#End Region

#Region "Get/Set INIData methods ... "
    Public Function GetINIData(ByVal strFile As String, ByVal Node As String, ByVal Data As String) As String
        Dim objData As New DataSet()
        Dim objTable As DataTable

        Try
            objData.ReadXml(strFile)
            objTable = objData.Tables(Node)
            Return CStr(objTable.Rows(0)(Data))
        Catch ex As Exception
            Return Nothing
        End Try
    End Function

    Public Sub SetINIData(ByVal strFile As String, ByVal Node As String, ByVal Data As String, ByVal Value As String)
        Dim objData As New DataSet()
        Dim objDataOut As New DataSet()
        Dim objTable As DataTable = objDataOut.Tables.Add(Node)

        Try
            objData.ReadXml(strFile)
            objTable = objData.Tables(Node)
            objTable.Rows(0)(Data) = Value
            objData.WriteXml(strFile)

        Catch exFile As System.IO.FileNotFoundException
            Dim newXml As New System.Xml.XmlTextWriter(strFile, System.Text.Encoding.ASCII)

            ' if the file is not there create it
            With newXml
                .WriteStartDocument()
                .WriteStartElement(Node)
                .WriteElementString(Data, Value)
                .WriteEndElement()
                .WriteEndDocument()
                .Flush()
                .Close()
            End With

        Catch ex As Exception
            objTable.Columns.Add(Data)
            objTable.Rows(0)(Data) = Value
            objTable.DataSet.WriteXml(strFile)
        End Try
    End Sub
#End Region

    Public Function GetPixelBitCount(ByVal Format As Drawing.Imaging.PixelFormat) As Integer
        Select Case Format
            Case Drawing.Imaging.PixelFormat.Alpha
                Throw New ArgumentException("Format specified cannot return BPP (bits-per-pixel) value.", "Format")

            Case Drawing.Imaging.PixelFormat.Canonical
                Throw New ArgumentException("Format specified cannot return BPP (bits-per-pixel) value.", "Format")

            Case Drawing.Imaging.PixelFormat.DontCare
                Throw New ArgumentException("Format specified cannot return BPP (bits-per-pixel) value.", "Format")

            Case Drawing.Imaging.PixelFormat.Extended
                Throw New ArgumentException("Format specified cannot return BPP (bits-per-pixel) value.", "Format")

            Case Drawing.Imaging.PixelFormat.Format16bppArgb1555
                Return 16

            Case Drawing.Imaging.PixelFormat.Format16bppGrayScale
                Return 16

            Case Drawing.Imaging.PixelFormat.Format16bppRgb555
                Return 16

            Case Drawing.Imaging.PixelFormat.Format16bppRgb565
                Return 16

            Case Drawing.Imaging.PixelFormat.Format1bppIndexed
                Return 1

            Case Drawing.Imaging.PixelFormat.Format24bppRgb
                Return 24

            Case Drawing.Imaging.PixelFormat.Format32bppArgb
                Return 32

            Case Drawing.Imaging.PixelFormat.Format32bppPArgb
                Return 32

            Case Drawing.Imaging.PixelFormat.Format32bppRgb
                Return 32

            Case Drawing.Imaging.PixelFormat.Format48bppRgb
                Return 48

            Case Drawing.Imaging.PixelFormat.Format4bppIndexed
                Return 4

            Case Drawing.Imaging.PixelFormat.Format64bppArgb
                Return 64

            Case Drawing.Imaging.PixelFormat.Format64bppPArgb
                Return 64

            Case Drawing.Imaging.PixelFormat.Format8bppIndexed
                Return 8

            Case Drawing.Imaging.PixelFormat.Gdi
                Throw New ArgumentException("Format specified cannot return BPP (bits-per-pixel) value.", "Format")

            Case Drawing.Imaging.PixelFormat.Indexed
                Throw New ArgumentException("Format specified cannot return BPP (bits-per-pixel) value.", "Format")

            Case Drawing.Imaging.PixelFormat.Max
                Throw New ArgumentException("Format specified cannot return BPP (bits-per-pixel) value.", "Format")

            Case Drawing.Imaging.PixelFormat.PAlpha
                Throw New ArgumentException("Format specified cannot return BPP (bits-per-pixel) value.", "Format")

            Case Drawing.Imaging.PixelFormat.Undefined
                Throw New ArgumentException("Format specified cannot return BPP (bits-per-pixel) value.", "Format")

            Case Else
                Throw New ArgumentOutOfRangeException("Format")
        End Select
    End Function

#Region "ToRectangle Overloads ... "
    'TODO: add more torect overloads
    Public Function ToRectangle(ByVal Size As Size) As Rectangle
        Return New Rectangle(0, 0, Size.Width, Size.Height)
    End Function

    Public Function ToRectangle(ByVal Size As SizeF) As RectangleF
        Return New RectangleF(0, 0, Size.Width, Size.Height)
    End Function

    Public Function ToRectangle(ByVal I As Image) As Rectangle
        Return New Rectangle(0, 0, I.Width, I.Height)
    End Function

    Public Function ToRectangle(ByVal Width As Integer, ByVal Height As Integer) As Rectangle
        Return New Rectangle(0, 0, Width, Height)
    End Function

    Public Function ToRectangle(ByVal Width As Single, ByVal Height As Single) As RectangleF
        Return New RectangleF(0, 0, Width, Height)
    End Function

    Public Function ToRectangle(ByVal P As Point, ByVal Size As Integer) As Rectangle
        Return New Rectangle(P.X, P.Y, Size, Size)
    End Function

    Public Function ToRectangle(ByVal R As Rectangle) As Rectangle
        Return New Rectangle(R.X, R.Y, R.Width, R.Height)
    End Function

    Public Function ToRectangle(ByVal R As RectangleF) As RectangleF
        Return New RectangleF(R.X, R.Y, R.Width, R.Height)
    End Function
#End Region

#Region " ResiseImage overloads ..."
    'TODO add more resize image overloads ...
    Public Function ResizeImage(ByVal I As Image, _
    ByVal NewSize As Size, Optional ByVal PreserveImage As Boolean = True, _
    Optional ByVal BackColor As Integer = 0) As Image
        Return ResizeImage(I, New Point(0, 0), ToRectangle(I), NewSize, PreserveImage, BackColor)
    End Function

    Public Function ResizeImage(ByVal I As Image, _
    ByVal NewWidth As Integer, ByVal NewHeight As Integer, Optional ByVal PreserveImage As Boolean = True, _
    Optional ByVal BackColor As Integer = 0) As Image
        Return ResizeImage(I, New Point(0, 0), ToRectangle(I), New Size(NewWidth, NewHeight), PreserveImage, BackColor)
    End Function

    Public Function ResizeImage(ByVal I As Image, ByVal Offset As Point, _
    ByVal NewSize As Size, Optional ByVal PreserveImage As Boolean = True, _
    Optional ByVal BackColor As Integer = 0) As Image
        Return ResizeImage(I, Offset, ToRectangle(I), NewSize, PreserveImage, BackColor)
    End Function

    Public Function ResizeImage(ByVal I As Image, ByVal XOffset As Integer, ByVal YOffset As Integer, _
    ByVal NewSize As Size, Optional ByVal PreserveImage As Boolean = True, _
    Optional ByVal BackColor As Integer = 0) As Image
        Return ResizeImage(I, New Point(XOffset, YOffset), ToRectangle(I), NewSize, PreserveImage, BackColor)
    End Function

    Public Function ResizeImage(ByVal I As Image, ByVal XOffset As Integer, ByVal YOffset As Integer, _
    ByVal NewWidth As Integer, ByVal NewHeight As Integer, Optional ByVal PreserveImage As Boolean = True, _
    Optional ByVal BackColor As Integer = 0) As Image
        Return ResizeImage(I, New Point(XOffset, YOffset), ToRectangle(I), New Size(NewWidth, NewHeight), PreserveImage, BackColor)
    End Function

    Public Function ResizeImage(ByVal I As Image, ByVal XOffset As Integer, ByVal YOffset As Integer, _
    ByVal SourceRect As Rectangle, _
    ByVal NewSize As Size, Optional ByVal PreserveImage As Boolean = True, _
    Optional ByVal BackColor As Integer = 0) As Image
        Return ResizeImage(I, New Point(XOffset, YOffset), ToRectangle(I), NewSize, PreserveImage, BackColor)
    End Function

    Public Function ResizeImage(ByVal I As Image, ByVal Offset As Point, _
    ByVal SourceRect As Rectangle, _
    ByVal NewWidth As Integer, ByVal NewHeight As Integer, Optional ByVal PreserveImage As Boolean = True, _
    Optional ByVal BackColor As Integer = 0) As Image
        Return ResizeImage(I, Offset, ToRectangle(I), New Size(NewWidth, NewHeight), PreserveImage, BackColor)
    End Function

    Public Function ResizeImage(ByVal I As Image, ByVal XOffset As Integer, ByVal YOffset As Integer, _
    ByVal SourceRect As Rectangle, _
    ByVal NewWidth As Integer, ByVal NewHeight As Integer, Optional ByVal PreserveImage As Boolean = True, _
    Optional ByVal BackColor As Integer = 0) As Image
        Return ResizeImage(I, New Point(XOffset, YOffset), ToRectangle(I), New Size(NewWidth, NewHeight), PreserveImage, BackColor)
    End Function

    Public Function ResizeImage(ByVal I As Image, ByVal Offset As Point, _
    ByVal SourceRect As Rectangle, _
    ByVal NewSize As Size, Optional ByVal PreserveImage As Boolean = True, _
    Optional ByVal BackColor As Integer = 0) As Image
        Dim objTmp As Image

        objTmp = New Bitmap(NewSize.Width, NewSize.Height)
        With Graphics.FromImage(objTmp)
            .Clear(Color.FromArgb(BackColor))
            If PreserveImage Then .DrawImage(I, New Rectangle(Offset, I.Size), SourceRect, GraphicsUnit.Pixel)
        End With

        Return objTmp
    End Function
#End Region

End Module
