'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: August 12, 2003
'=============================================

Public Module General
    Public Function DoMsg(ByVal Owner As Form, ByVal Style As MsgBoxStyle, ByVal Header As String, ByVal Info As String) As DialogResult
        Return CommonCommandsR3.ErrWin.ShowError(Owner, Style, Header, Info)
    End Function

    Public Sub NavigateUp(ByVal TV As TreeView)
        If TV.SelectedNode Is Nothing Then Exit Sub
        If TV.SelectedNode.Parent Is Nothing Then Exit Sub

        TV.SelectedNode = TV.SelectedNode.Parent
    End Sub

    Public Sub AddNewCategory(ByVal Root As TreeNode, ByVal TV As TreeView)
        Dim Node As CategoryNode

        Node = New CategoryNode()
        Node.Text = "Untitled"
        If TV.SelectedNode Is Nothing Then
            Root.Nodes.Add(Node)
        Else
            TV.SelectedNode.Nodes.Add(Node)
        End If

        Node.EnsureVisible()
    End Sub

    Public Sub DoDelete(ByVal What As ControlFocus, ByVal TV As TreeView, ByVal LV As ListView, ByVal Root As TreeNode)
        Dim Item As LVFileItem
        Dim idx As Integer
        Dim Node As CategoryNode

        Select Case What
            Case ControlFocus.FListView
                idx = 0
                Node = DirectCast(TV.SelectedNode, CategoryNode)
                If LV.SelectedItems Is Nothing Then Exit Sub

                While idx < LV.SelectedItems.Count - 1
                    Item = DirectCast(LV.SelectedItems(idx), LVFileItem)
                    If Item.Selected Then
                        Node.Files.Remove(Item.FileItemIndex)
                        LV.Items.RemoveAt(Item.Index)
                    Else
                        idx += 1
                    End If
                End While
                Item = Nothing

            Case ControlFocus.FTreeView
                If TV.SelectedNode Is Nothing Then Exit Sub
                If TV.SelectedNode Is Root Then Exit Sub

                TV.Nodes.Remove(TV.SelectedNode)
                PopulateFiles(LV, TV.SelectedNode)
        End Select
    End Sub

    Public Sub PopulateFiles(ByVal LV As ListView, ByVal Node As TreeNode)
        Dim idx As Integer
        Dim NX As CategoryNode
        Dim Item As LVFileItem
        Dim strTmp As String

        LV.BeginUpdate()
        LV.Items.Clear()

        If Not TypeOf Node Is CategoryNode Then Exit Sub

        NX = DirectCast(Node, CategoryNode)
        For idx = 0 To NX.Files.Count - 1

            Item = New LVFileItem()
            Item.Text = IO.Path.GetFileName(NX.Files(idx).Filename)
            LV.Items.Add(Item)
            Item.FileItemIndex = NX.Files.IndexOf(NX.Files(idx))
            Item.SubItems.Add(NX.Files(idx).Size.ToString)
            ' check if it has extention
            If IO.Path.HasExtension(NX.Files(idx).Filename) Then
                Item.SubItems.Add(CommonCommandsR3.General.GetEXTDescription(NX.Files(idx).Filename))
            End If
        Next


        LV.EndUpdate()

        NX = Nothing
    End Sub

    Public Sub ImportFile(ByVal Owner As Form, ByVal TV As TreeView, ByVal LV As ListView)
        Dim dlgOpen As OpenFileDialog

        dlgOpen = New OpenFileDialog()
        With dlgOpen
            .AddExtension = True
            .CheckFileExists = True
            .CheckPathExists = True
            .FileName = ""
            .Filter = "All Files *.*|*.*"
            .FilterIndex = 0
            .Multiselect = True
            .ShowReadOnly = False
            .Title = "Import files ..."

            Select Case .ShowDialog(Owner)
                Case DialogResult.OK
                    ' add files
                    DoAddFiles(TV, LV, .FileNames)

                Case DialogResult.Cancel
                    ' do nothing
            End Select
        End With
        dlgOpen = Nothing
    End Sub

    Public Sub DoAddFiles(ByVal TV As TreeView, ByVal LV As ListView, ByVal Files() As String)
        Dim Node As CategoryNode
        Dim idx As Integer
        Dim FI As FileItem
        Dim Info As IO.FileInfo


        If TV.SelectedNode Is Nothing Then Exit Sub
        If Files Is Nothing Then Exit Sub
        If Not TypeOf TV.SelectedNode Is CategoryNode Then Exit Sub

        Node = DirectCast(TV.SelectedNode, CategoryNode)


        For idx = 0 To Files.Length - 1
            FI = New FileItem()
            FI.AlreadyStored = False
            FI.Filename = Files(idx)
            Info = New IO.FileInfo(FI.Filename)
            FI.Size = Info.Length
            Info = Nothing

            Node.Files.Add(FI)
        Next

        ' now that new files were added we re populate
        PopulateFiles(LV, Node)

        FI = Nothing
    End Sub

    Public Function DoSaveAs(ByVal Owner As Form) As String
        Dim dlgSave As SaveFileDialog
        Dim strFile As String = ""

        dlgSave = New SaveFileDialog()
        With dlgSave
            .AddExtension = True
            .CheckFileExists = False
            .CheckPathExists = True
            .FileName = ""
            .Filter = "CBX Group File *.XG|*.XG"
            .FilterIndex = 0
            .OverwritePrompt = True
            .CreatePrompt = False
            .Title = "Save File"

            Select Case .ShowDialog(Owner)
                Case DialogResult.OK
                    ' add files
                    strFile = .FileName

                Case DialogResult.Cancel
                    ' do nothing
                    strFile = ""
            End Select
        End With

        dlgSave = Nothing

        Return strFile
    End Function

    Public Function DoOpen(ByVal Owner As Form) As String
        Dim dlgOpen As OpenFileDialog
        Dim strFile As String = ""

        dlgOpen = New OpenFileDialog()
        With dlgOpen
            .AddExtension = True
            .CheckFileExists = True
            .CheckPathExists = True
            .Multiselect = False
            .ShowReadOnly = False
            .FileName = ""
            .Filter = "CBX Group File *.XG|*.XG"
            .FilterIndex = 0
            .Title = "Open File"

            Select Case .ShowDialog(Owner)
                Case DialogResult.OK
                    ' add files
                    strFile = .FileName

                Case DialogResult.Cancel
                    ' do nothing
                    strFile = ""
            End Select
        End With

        dlgOpen = Nothing

        Return strFile
    End Function

End Module