'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: August 13, 2003
'=============================================

Public Module SaveLoadMethods
    Public Function LoadGroupFile(ByVal File As String) As CategoryNode
        Dim F As gLoad
        Dim Node, NX As CategoryNode
        Dim idx As Integer
        Dim Pth() As String
        Dim FI As FileItem

        F = New gLoad(File)
        F.Load(Nothing)

        Node = New CategoryNode()
        Node.Text = IO.Path.DirectorySeparatorChar
        For idx = 0 To F.Entries.Count - 1
            ' get path for node
            Pth = F.Entries(idx).Path.Split(IO.Path.DirectorySeparatorChar)

            ' create new item
            FI = New FileItem()
            ' because we are reading it means file is already stored
            FI.AlreadyStored = True
            ' get filename
            FI.Filename = F.Entries(idx).FileName
            ' get filesize
            FI.Size = F.Entries(idx).FileSize
            ' get entry data (needed for when the user saves GuG file again)
            FI.mobjEntry = F.Entries(idx)

            'build a series os subcategories returning the last child
            NX = DirectCast(CommonCommandsR3.General.BuildNodePath(Pth, 0, Node.Nodes), CategoryNode)

            ' add file item to node
            NX.Files.Add(FI)
        Next

        F = Nothing
        Return Node
    End Function

    Public Sub SaveGroupFile(ByVal File As String, ByVal ExistingFile As String, ByVal Root As CategoryNode)
        Dim F As gSave

        F = New gSave(File)
        SaveGroupFileRecusive(F, ExistingFile, Root)
        F.Save(Nothing)
        F = Nothing

        'mark all files as saved
        MarkAllFilesAs(Root, True)
    End Sub

    Private Sub SaveGroupFileRecusive(ByVal F As gSave, ByVal ExistingFile As String, ByVal Node As CategoryNode)
        Dim idx As Integer
        Dim NX As CategoryNode
        Dim strTmpFile As String

        With Node
            ' add files
            For idx = 0 To .Files.Count - 1
                If .Files(idx).AlreadyStored Then
                    strTmpFile = DoExtractFromGuGFile(ExistingFile, .Files(idx).mobjEntry)

                    F.AddFile(.FullPath, .Files(idx).Filename, strTmpFile)
                Else
                    F.AddFile(.FullPath, _
                              IO.Path.GetFileName(.Files(idx).Filename), _
                              .Files(idx).Filename)
                End If
            Next

            ' save child node data
            For Each NX In Node.Nodes
                SaveGroupFileRecusive(F, ExistingFile, NX)
            Next
        End With
    End Sub

    Public Function DoExtractFromGuGFile(ByVal File As String, ByVal E As GuGFileEntry) As String
        Dim strTmpFile As String
        Dim F As IO.BinaryReader
        Dim Spitter As IO.BinaryWriter
        Dim Data() As Char
        Dim DataSize As Long = 1000000
        Dim DataRead As Long = 0

        strTmpFile = IO.Path.GetTempFileName
        F = New IO.BinaryReader(IO.File.OpenRead(File))
        Spitter = New IO.BinaryWriter(IO.File.Create(strTmpFile))

        F.BaseStream.Seek(E.Position, IO.SeekOrigin.Begin)
        If DataSize > E.FileSize Then DataSize = E.FileSize
        While DataRead < E.FileSize
            If DataRead + DataSize > E.FileSize Then DataSize = E.FileSize - DataRead
            Data = F.ReadChars(CInt(DataSize))
            Spitter.Write(Data)
            DataRead += DataSize
        End While

        Spitter.Flush()
        Spitter.Close()
        Spitter = Nothing

        F.Close()
        F = Nothing

        Return strTmpFile
    End Function

    Public Sub MarkAllFilesAs(ByVal Root As CategoryNode, ByVal Value As Boolean)
        Dim idx As Integer
        Dim Node As CategoryNode

        ' set file stored as values
        For idx = 0 To Root.Files.Count - 1
            Root.Files(idx).AlreadyStored = Value
        Next

        ' process all child nodes
        For Each Node In Root.Nodes
            MarkAllFilesAs(Node, Value)
        Next
    End Sub
End Module