'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: August 13, 2003
'=============================================

<ComClass(gLoad.ClassId, gLoad.InterfaceId, gLoad.EventsId)> _
Public Class gLoad

#Region "COM GUIDs"
    ' These  GUIDs provide the COM identity for this class 
    ' and its COM interfaces. If you change them, existing 
    ' clients will no longer be able to access the class.
    Public Const ClassId As String = "A4DFF778-1E65-432D-B816-052F37F03B41"
    Public Const InterfaceId As String = "BA3076F5-1382-4004-9385-182594CC687B"
    Public Const EventsId As String = "0C3CA481-24BB-4191-8A2F-758311BA8B0B"
#End Region

    Private mstrFile As String
    Private mobjEntries As GuGFileEntryColletion
    Private Header As GuGFileHeader

    Public Sub New(ByVal File As String)
        mstrFile = File
        mobjEntries = New GuGFileEntryColletion()
        Header.mintVersion = 1
        Header.mintNumberOfEntries = 0
        Header.mlngFileSize = 0
    End Sub

    Private Sub ExtractFile(ByVal File As String, ByVal F As IO.BinaryReader, ByVal FileSize As Long)
        Dim Spitter As IO.BinaryWriter
        Dim Data() As Char
        Dim DataSize As Long = 1000000
        Dim DataRead As Long = 0

        If DataSize > FileSize Then DataSize = FileSize
        Spitter = New IO.BinaryWriter(IO.File.Create(File))
        While DataRead < FileSize
            If DataRead + DataSize > FileSize Then DataSize = FileSize - DataRead
            Data = F.ReadChars(CInt(DataSize))
            Spitter.Write(Data)
            DataRead += DataSize
        End While

        Spitter.Flush()
        Spitter.Close()
        Spitter = Nothing
    End Sub

    Public Sub Load(ByVal Callback As gFileStatus)
        Dim F As IO.BinaryReader
        Dim TmpFile As String
        Dim idx, Count As Integer
        Dim Entry As GuGFileEntry
        Dim ActualFileSize As Long


        ' open file
        F = New IO.BinaryReader(IO.File.OpenRead(TmpFile))

        ' read header
        Header.mintVersion = F.ReadInt32
        Header.mintNumberOfEntries = F.ReadInt32
        Header.mlngFileSize = F.ReadInt64
        Header.mlngEntryPosition = F.ReadInt64

        ' get actual file size
        ActualFileSize = Header.mlngFileSize + Len(Header.mintVersion) + Len(Header.mintNumberOfEntries) + Len(Header.mlngFileSize) + Len(Header.mlngEntryPosition)
        If F.BaseStream.Length <> ActualFileSize Then
            ' ERR: handle err?
        End If

        ' seek to entry position
        F.BaseStream.Seek(Header.mlngEntryPosition, IO.SeekOrigin.Begin)

        ' read file entries
        For idx = 0 To CInt(Header.mintNumberOfEntries - 1)
            Entry = New GuGFileEntry()

            ' read path
            Count = F.ReadInt32
            Entry.mstrPath = F.ReadChars(Count)

            ' read file
            Count = F.ReadInt32
            Entry.mstrFileName = F.ReadChars(Count)

            ' read file size
            Entry.mlngFileSize = F.ReadInt64
            ' read file position
            Entry.mlngPosition = F.ReadInt64

            ' add entry
            mobjEntries.Add(Entry)
        Next

        ' cleanup file object
        F.Close()
        F = Nothing
    End Sub

    Public Sub ExtractEntry(ByVal Index As Integer, ByVal File As String)
        Dim F As IO.BinaryReader
        Dim Entry As GuGFileEntry
        Dim strTmpFile As String

        Entry = mobjEntries(Index)
        F = New IO.BinaryReader(IO.File.OpenRead(mstrFile))
        F.BaseStream.Seek(Entry.mlngPosition, IO.SeekOrigin.Begin)

        strTmpFile = IO.Path.GetTempFileName
        ExtractFile(strTmpFile, F, Entry.mlngFileSize)

        F.Close()
        F = Nothing

        If IO.File.Exists(File) Then IO.File.Delete(File)
        IO.File.Move(strTmpFile, File)
    End Sub

    Public ReadOnly Property Filename() As String
        Get
            Return mstrFile
        End Get
    End Property

    Protected Overrides Sub Finalize()
        MyBase.Finalize()
        mobjEntries.Clear()
        mobjEntries = Nothing
    End Sub

    Public ReadOnly Property Entries() As GuGFileEntryColletion
        Get
            Return mobjEntries
        End Get
    End Property

    Public ReadOnly Property FileHeader() As GuGFileHeader
        Get
            Return Header
        End Get
    End Property
End Class