'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: August 13, 2003
'=============================================


<ComClass(gSave.ClassId, gSave.InterfaceId, gSave.EventsId)> _
Public Class gSave

#Region "COM GUIDs"
    ' These  GUIDs provide the COM identity for this class 
    ' and its COM interfaces. If you change them, existing 
    ' clients will no longer be able to access the class.
    Public Const ClassId As String = "01AA2C3E-21E7-4907-BA06-27B1DE242B85"
    Public Const InterfaceId As String = "D545AE3F-ED96-4E81-920C-DD0955D7FB2B"
    Public Const EventsId As String = "9D0E0051-2E30-4B38-9E41-C08F8BF46881"
#End Region

    Private mstrFile As String
    Private mobjEntries As GuGFileEntryColletion
    Private Header As GuGFileHeader

    Public Sub New(ByVal File As String)
        mstrFile = File
        mobjEntries = New GuGFileEntryColletion()
        Header.mintVersion = 1
        Header.mintNumberOfEntries = 0
        Header.mlngFileSize = 0
        Header.mlngEntryPosition = 0
    End Sub

    Private Sub InsertFile(ByVal File As String, ByVal F As IO.BinaryWriter)
        Dim Sniffer As IO.BinaryReader
        Dim Data() As Char
        Dim DataSize As Integer = 1000000

        Sniffer = New IO.BinaryReader(IO.File.Open(File, IO.FileMode.Open))
        While Sniffer.PeekChar <> -1
            Data = Sniffer.ReadChars(DataSize)
            F.Write(Data)
        End While
        Sniffer.Close()
        Sniffer = Nothing
    End Sub

    Public Sub Save(ByVal Callback As gFileStatus)
        Dim F As IO.BinaryWriter
        Dim TmpFile As String
        Dim idx As Integer
        Dim Entry As GuGFileEntry

        ' get tmp filename for saving
        TmpFile = IO.Path.GetTempFileName
        ' create tmp file
        F = New IO.BinaryWriter(IO.File.Create(TmpFile))

        ' save header
        F.Write(Header.Version)
        F.Write(Header.NumberOfEntries)
        F.Write(Header.FileSize)
        F.Write(Header.mlngEntryPosition)

        ' write files
        For idx = 0 To mobjEntries.Count - 1
            With mobjEntries(idx)
                .SetPosition(F.BaseStream.Position)
                ' insert contents of file
                InsertFile(mobjEntries(idx).SourceFile, F)
            End With
        Next

        ' save entry start position
        Header.mlngEntryPosition = F.BaseStream.Position

        ' write file entries
        For idx = 0 To mobjEntries.Count - 1
            With mobjEntries(idx)
                ' save path
                F.Write(.Path.Length)
                F.Write(.Path.ToCharArray)
                ' save file
                F.Write(.FileName.Length)
                F.Write(.FileName.ToCharArray)
                ' save file size
                F.Write(.FileSize)
                ' save file position
                F.Write(.mlngPosition)
            End With
        Next

        ' resave header
        F.Seek(0, IO.SeekOrigin.Begin)
        F.Write(Header.Version)
        F.Write(Header.NumberOfEntries)
        F.Write(Header.FileSize)
        F.Write(Header.mlngEntryPosition)

        ' cleanup file object
        F.Flush()
        F.Close()
        F = Nothing
        ' delete the file if it is there
        If IO.File.Exists(mstrFile) Then IO.File.Delete(mstrFile)
        ' move tmp file over to take the place of the 
        IO.File.Move(TmpFile, mstrFile)
    End Sub

    Public ReadOnly Property Filename() As String
        Get
            Return mstrFile
        End Get
    End Property

    Public Function AddFile(ByVal InternalPath As String, ByVal FileName As String, ByVal SourceFile As String) As Integer
        Dim strTmp As String
        Dim Info As IO.FileInfo
        Dim Entry As GuGFileEntry
        Dim EntrySize As Long = 0


        ' add entry
        With Entry
            Info = New IO.FileInfo(SourceFile)

            .mstrFileName = FileName
            EntrySize += .mstrFileName.Length + Len(.mstrFileName.Length)

            .mlngFileSize = Info.Length
            EntrySize += .mlngFileSize + Len(.mlngFileSize)

            .mstrPath = InternalPath
            EntrySize += .mstrPath.Length + Len(.mstrPath.Length)

            EntrySize += Len(.mlngPosition)

            .mstrSourceFile = SourceFile
        End With
        Header.mintNumberOfEntries += 1
        Header.mlngFileSize += EntrySize

        Return mobjEntries.Add(Entry)
    End Function

    Public Sub RemoveEntry(ByVal Index As Integer)
        Dim EntrySize As Long = 0

        ' remove entry from collection
        With mobjEntries(Index)
            EntrySize += .mstrFileName.Length + Len(.mstrFileName.Length)
            EntrySize += .mlngFileSize + Len(.mlngFileSize)
            EntrySize += .mstrPath.Length + Len(.mstrPath.Length)
            EntrySize += Len(.mlngPosition)
        End With
        ' update header data
        Header.mintNumberOfEntries -= 1
        Header.mlngFileSize -= EntrySize
        ' remove entry
        mobjEntries.Remove(Index)
    End Sub

    Protected Overrides Sub Finalize()
        MyBase.Finalize()
        mobjEntries.Clear()
        mobjEntries = Nothing
    End Sub

    Public ReadOnly Property Entries() As GuGFileEntryColletion
        Get
            Return mobjEntries
        End Get
    End Property

    Public ReadOnly Property FileHeader() As GuGFileHeader
        Get
            Return Header
        End Get
    End Property
End Class
