'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: November 27, 2003
'=============================================


''' <summary>
''' Contains types relates to animation.
''' </summary>
Namespace Animation

    ''' <summary>
    ''' Privides support for 2D animated strips.
    ''' </summary>
    Public Class AnimatedStripItem
        Private mlngTime As Long = 0
        Private mlngLastTime As Long = 0
        Private mobjSource As Rectangle

        ''' <summary>
        ''' Gets or Sets a measure of time.
        ''' </summary>
        ''' <returns>Returns a measure of time.</returns>
        Public Property Time() As Long
            Get
                Return mlngTime
            End Get
            Set(ByVal Value As Long)
                mlngTime = Value
            End Set
        End Property

        ''' <summary>
        ''' Gets or Sets the last measure of time.
        ''' </summary>
        ''' <returns>Returns the last measure of time.</returns>
        Public Property LastTime() As Long
            Get
                Return mlngLastTime
            End Get
            Set(ByVal Value As Long)
                mlngLastTime = Value
            End Set
        End Property

        ''' <summary>
        ''' Gets or Sets the source rectangle.
        ''' </summary>
        ''' <returns>Returns the source rectangle.</returns>
        Public Property SourceRectangle() As Rectangle
            Get
                Return mobjSource
            End Get
            Set(ByVal Value As Rectangle)
                mobjSource = Value
            End Set
        End Property


#Region " Constructre overloads ... "
        ''' <summary>
        ''' Creates a new instance of this class.
        ''' </summary>
        Public Sub New()
            MyBase.new()

#If Trace = True Then
            TEnter("CBX.Libs.DX9ToolsR4.Animation.AnimatedStripItem.New")
#End If

            'add code here

#If Trace = True Then
            TExit("CBX.Libs.DX9ToolsR4.Animation.AnimatedStripItem.New")
#End If
        End Sub

        ''' <summary>
        ''' Creates a new instance of this class.
        ''' </summary>
        ''' <param name="Time">Sets the initial value for the Time property.</param>
        Public Sub New(ByVal Time As Long)
            MyBase.new()

#If Trace = True Then
            TEnter("CBX.Libs.DX9ToolsR4.Animation.AnimatedStripItem.New")
#End If

            mlngTime = Time


#If Trace = True Then
            TExit("CBX.Libs.DX9ToolsR4.Animation.AnimatedStripItem.New")
#End If
        End Sub

        ''' <summary>
        ''' Creates a new instance of this class.
        ''' </summary>
        ''' <param name="Source">Sets the initial value for the Source property.</param>
        Public Sub New(ByVal Source As Rectangle)
            MyBase.new()

#If Trace = True Then
            TEnter("CBX.Libs.DX9ToolsR4.Animation.AnimatedStripItem.New")
#End If

            mobjSource = Source

#If Trace = True Then
            TExit("CBX.Libs.DX9ToolsR4.Animation.AnimatedStripItem.New")
#End If
        End Sub

        ''' <summary>
        ''' Creates a new instance of this class.
        ''' </summary>
        ''' <param name="Time">Sets the initial value for the Time property.</param>
        ''' <param name="Source">Sets the initial value for the Source property.</param>
        Public Sub New(ByVal Time As Long, ByVal Source As Rectangle)
            MyBase.new()

#If Trace = True Then
            TEnter("CBX.Libs.DX9ToolsR4.Animation.AnimatedStripItem.New")
#End If

            mlngTime = Time
            mobjSource = Source

#If Trace = True Then
            TExit("CBX.Libs.DX9ToolsR4.Animation.AnimatedStripItem.New")
#End If
        End Sub

        ''' <summary>
        ''' Creates a new instance of this class.
        ''' </summary>
        ''' <param name="Time">Sets the initial value for the Time property.</param>
        ''' <param name="LastTime">Sets the initial value for the LastTime property.</param>
        ''' <param name="Source">Sets the initial value for the Source property.</param>
        Public Sub New(ByVal Time As Long, ByVal LastTime As Long, ByVal Source As Rectangle)
            MyBase.new()

#If Trace = True Then
            TEnter("CBX.Libs.DX9ToolsR4.Animation.AnimatedStripItem.New")
#End If

            mlngTime = Time
            mlngLastTime = LastTime
            mobjSource = Source

#If Trace = True Then
            TExit("CBX.Libs.DX9ToolsR4.Animation.AnimatedStripItem.New")
#End If
        End Sub
#End Region

       ''' <summary>
        ''' Cleans up and disposes of the animated strips internal varibles and references.
    ''' </summary>
        Protected Overrides Sub Finalize()
#If Trace = True Then
            TEnter("CBX.Libs.DX9ToolsR4.Animation.AnimatedStripItem.Finalize")
#End If

            MyBase.Finalize()
            'add code here

#If Trace = True Then
            TExit("CBX.Libs.DX9ToolsR4.Animation.AnimatedStripItem.Finalize")
#End If

        End Sub
    End Class
End Namespace