'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: November 22, 2003
'=============================================

Public Class CameraCollection
    Private mobjItems As Collections.ArrayList
    Private mobjDevice As Direct3D.Device

    Public Sub SwapItem(ByVal Index1 As Integer, ByVal Index2 As Integer)
        Dim intFirst, intLast As Integer
        Dim objFirst, objLast As Object

        ' do err chech
        If Index1 < 0 Or Index1 > mobjItems.Count - 1 Then
            Throw New ArgumentOutOfRangeException("Index1")
        End If
        If Index2 < 0 Or Index2 > mobjItems.Count - 1 Then
            Throw New ArgumentOutOfRangeException("Index2")
        End If
        If Index1 = Index2 Then Exit Sub

        intFirst = CType(IIf(Index1 < Index2, Index1, Index2), Integer)
        intLast = CType(IIf(Index1 > Index2, Index1, Index2), Integer)

        ' store items
        objFirst = mobjItems(intFirst)
        objLast = mobjItems(intLast)

        ' remove from list
        mobjItems.RemoveAt(intLast)
        mobjItems.RemoveAt(intFirst)

        ' reinsert
        mobjItems.Insert(intFirst, objFirst)
        mobjItems.Insert(intLast, objLast)
    End Sub

    Public Function Add(ByVal Item As Camera) As Integer
        If Not Item.Parent Is Nothing Then
            Throw New ArgumentOutOfRangeException("Item.Parent", Item.Parent, _
                "Cannot add item because it has already been added to a collection.")
        End If

        Item.SetDevice(Nothing)
        Item.SetDevice(mobjDevice)
        Item.SetParent(Me)
        Return mobjItems.Add(Item)
    End Function

    Public Function Add() As Integer
        Dim objCamera As Camera

        objCamera = New Camera()
        objCamera.SetDevice(Nothing)
        objCamera.SetDevice(mobjDevice)
        objCamera.SetParent(Me)
        Return Me.Add(objCamera)
    End Function

    Public Function GetEnumerator() As IEnumerator
        Return mobjItems.GetEnumerator
    End Function

    Public Sub Clear()
        mobjItems.Clear()
    End Sub

    Public ReadOnly Property Count() As Integer
        Get
            Return mobjItems.Count
        End Get
    End Property

    Public Function IndexOf(ByVal Item As Camera) As Integer
        Return mobjItems.IndexOf(Item)
    End Function

    Public Sub Insert(ByVal Index As Integer, ByVal Item As Camera)
        mobjItems.Insert(Index, Item)
    End Sub

    Default Public ReadOnly Property Item(ByVal Index As Integer) As Camera
        Get
            Return CType(mobjItems.Item(Index), Camera)
        End Get
    End Property

    Public Sub Remove(ByVal Item As Camera)
        mobjItems.Remove(Item)
    End Sub

    Public Sub Remove(ByVal Index As Integer)
        mobjItems.RemoveAt(Index)
    End Sub

    Public Sub Remove(ByVal Index As Integer, ByVal Count As Integer)
        mobjItems.RemoveRange(Index, Count)
    End Sub

    Public Sub New(ByVal Device As Direct3D.Device)
        If Device Is Nothing Then Throw New ArgumentNullException("Device")
        mobjDevice = Device
        mobjItems = New Collections.ArrayList()
    End Sub

    Public ReadOnly Property Device() As Direct3D.Device
        Get
            Return mobjDevice
        End Get
    End Property

    Protected Overrides Sub Finalize()
        MyBase.Finalize()
        mobjItems.Clear()
        mobjItems = Nothing
    End Sub
End Class