'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: August 4, 2003
'=============================================

#If TRACE = True Then
Friend Class DebugLogFileWriterTraceListener
    Inherits TraceListener

    Friend Enum EntryType
        Compleated = 1
        Entering = 2
        Exiting = 3
        Information = 4
        DataDump = 5
    End Enum

    Private File As Xml.XmlTextWriter

    Private Sub WriteTheTime()
        File.WriteStartElement("Time")
        File.WriteString(Now.Ticks.ToString)
        File.WriteEndElement()
        File.WriteStartElement("Date")
        File.WriteString(Now.Date.ToLongDateString)
        File.WriteEndElement()
    End Sub

    Private Sub WriteMessage(ByVal Message As String)
        File.WriteStartElement("Message")
        File.WriteString(Message)
        File.WriteEndElement()
    End Sub

    Private Sub WriteDataDump(ByVal Message As String)
        File.WriteStartElement("DataDump")

        File.WriteStartElement("Data")
        File.WriteString(Message)
        File.WriteEndElement()

        File.WriteEndElement()
    End Sub

    Private Sub WriteDataDump(ByVal Message As String, ByVal VaribleName As String)
        File.WriteStartElement("DataDump")

        File.WriteStartElement("VaribleName")
        File.WriteString(VaribleName)
        File.WriteEndElement()

        File.WriteStartElement("Data")
        File.WriteString(Message)
        File.WriteEndElement()

        File.WriteEndElement()
    End Sub

    Private Sub WriteSource(ByVal Source As String)
        File.WriteStartElement("Source")
        File.WriteString(Source)
        File.WriteEndElement()
    End Sub

    Public Sub WriteEntry(ByVal Type As EntryType, ByVal Message As String, ByVal VaribleName As String, ByVal Source As String)
        Select Case Type

            Case EntryType.DataDump
                File.WriteStartElement("DataDump")
                WriteTheTime()
                WriteSource(Source)
                WriteDataDump(Message, VaribleName)
                File.WriteEndElement()

        End Select
    End Sub

    Public Sub WriteEntry(ByVal Type As EntryType, ByVal Message As String, ByVal Source As String)
        Select Case Type
            Case EntryType.Compleated
                File.WriteStartElement("Compleated")
                WriteTheTime()
                WriteSource(Source)
                WriteMessage(Message)
                File.WriteEndElement()

            Case EntryType.Information
                File.WriteStartElement("Information")
                WriteTheTime()
                WriteSource(Source)
                WriteMessage(Message)
                File.WriteEndElement()

            Case EntryType.DataDump
                File.WriteStartElement("DataDump")
                WriteTheTime()
                WriteSource(Source)
                WriteDataDump(Message)
                File.WriteEndElement()

        End Select
    End Sub

    Public Sub WriteEntry(ByVal Type As EntryType, ByVal Message As String)
        Select Case Type
            Case EntryType.Compleated
                File.WriteStartElement("Compleated")
                WriteTheTime()
                WriteSource("")
                WriteMessage(Message)
                File.WriteEndElement()

            Case EntryType.Entering
                File.WriteStartElement("Entering")
                WriteTheTime()
                WriteMessage(Message)
                File.WriteEndElement()

            Case EntryType.Exiting
                File.WriteStartElement("Exiting")
                WriteTheTime()
                WriteMessage(Message)
                File.WriteEndElement()

            Case EntryType.Information
                File.WriteStartElement("Information")
                WriteTheTime()
                WriteSource("")
                WriteMessage(Message)
                File.WriteEndElement()

            Case EntryType.DataDump
                File.WriteStartElement("DataDump")
                WriteTheTime()
                WriteSource("")
                WriteDataDump(Message)
                File.WriteEndElement()

        End Select
    End Sub

    Public Overloads Overrides Sub Write(ByVal message As String)
        Try
            File.WriteString(message)

        Catch ex As Exception
            'ERR: handle error?
        End Try
    End Sub

    Public Overloads Overrides Sub WriteLine(ByVal message As String)
        Try
            File.WriteString(Space(Me.IndentLevel * Me.IndentSize) & message & vbCrLf)


        Catch ex As Exception
            'ERR: handle error?
        End Try
    End Sub

    Public Sub New(ByVal Filename As String)
        Try
            If IO.File.Exists(Filename) Then IO.File.Delete(Filename)
            File = New Xml.XmlTextWriter(Filename, System.Text.Encoding.ASCII)
            File.Formatting = Xml.Formatting.Indented
            File.WriteStartDocument(True)
            File.WriteStartElement("Root")

        Catch ex As Exception
            'ERR: handle error?
        End Try
    End Sub

    Protected Overrides Sub Finalize()
        MyBase.Finalize()
        Try

            File.WriteEndElement()
            File.WriteEndDocument()
            File.Flush()
            File.Close()
            File = Nothing

        Catch ex As Exception
            'ERR: handle error?
        End Try
    End Sub

    Public Overrides Sub Flush()
        MyBase.Flush()
        If Not File Is Nothing Then File.Flush()
    End Sub

    Public Overrides Sub Close()
        MyBase.Close()
        If Not File Is Nothing Then File.Close()
    End Sub
End Class
#End If