'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: November 23, 2003
'=============================================

Public Class Form1
    Inherits System.Windows.Forms.Form

    Private mobjGraphics As DX9ToolsR4.DX9Graphics
    Private mobjCamera As DX9ToolsR4.Camera
    Private mobjMesh As Direct3D.Mesh
    Private mobjRing As Direct3D.VertexBuffer
    Private mobjCamPositions() As Vector3
    Private mintCamIndex As Integer
    Private mblnAlignRing As Boolean = False

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents Timer1 As System.Windows.Forms.Timer
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Me.Timer1 = New System.Windows.Forms.Timer(Me.components)
        '
        'Timer1
        '
        Me.Timer1.Enabled = True
        Me.Timer1.Interval = 1
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(376, 326)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.Name = "Form1"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "Press the ""B"" button on the keyboard ..."

    End Sub

#End Region

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.Show()
        mobjGraphics = New DX9ToolsR4.DX9Graphics(Me)
        With mobjGraphics.Device
            .RenderState.Lighting = False
            .RenderState.CullMode = DirectX.Direct3D.Cull.None
            .RenderState.FillMode = DirectX.Direct3D.FillMode.WireFrame
        End With

        mobjCamera = New DX9ToolsR4.Camera(mobjGraphics)
        mintCamIndex = 0
        mobjCamera.AutoUpdateView = True
        mobjCamera.Reset()


        ' create teapot
        mobjMesh = Direct3D.Mesh.Teapot(mobjGraphics.Device)


        ' Generate camera position points
        DX9ToolsR4.GeoHelpers.GenerateEllipsePoints(New RectangleF(0, 0, 3, 3), _
                                                    DX9ToolsR4.Orientation.XZ, mobjCamPositions)


        ' create ring vertexbuffer 
        mobjRing = New Direct3D.VertexBuffer(GetType(Direct3D.CustomVertex.PositionColored), 360, _
                                             mobjGraphics.Device, 0, _
                                             Direct3D.CustomVertex.PositionColored.Format, _
                                             DirectX.Direct3D.Pool.Default)
        AddHandler mobjRing.Created, AddressOf Me.OnCreateVertexBuffer
        Me.OnCreateVertexBuffer(mobjRing, Nothing)

        Timer1.Start()
    End Sub

    Public Sub OnCreateVertexBuffer(ByVal sender As Object, ByVal e As EventArgs)
        Dim vb As Direct3D.VertexBuffer = CType(sender, Direct3D.VertexBuffer)
        Dim verts As Direct3D.CustomVertex.PositionColored()
        Dim Pts() As Vector3
        Dim idx As Integer

        verts = CType(vb.Lock(0, DirectX.Direct3D.LockFlags.None), Direct3D.CustomVertex.PositionColored())

        ' Generate ring points
        DX9ToolsR4.GeoHelpers.GenerateEllipsePoints(New RectangleF(0, 0, 2, 2), DX9ToolsR4.Orientation.XY, Pts)

        ' populate 
        For idx = 0 To 359
            verts(idx) = New Direct3D.CustomVertex.PositionColored(Pts(idx), Color.Green.ToArgb)
        Next

        vb.Unlock()
    End Sub 'OnCreateVertexBuffer

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Dim M As Matrix
        Dim Mat As Direct3D.Material
        Dim V As Vector3

        With mobjGraphics
            .Clear(Color.DarkGray)
            .Device.BeginScene()

            ' set the cameras position
            mobjCamera.Position = mobjCamPositions(mintCamIndex)

            Mat.Ambient = Color.White
            Mat.Diffuse = Color.White
            .Device.Material = Mat
            .Device.VertexFormat = mobjMesh.VertexFormat
            .Device.Transform.World = Matrix.Identity ' default world transform
            mobjMesh.DrawSubset(0) ' draw teapot


            ' check to billboard the ring
            If mblnAlignRing Then
                ' The key to bilboarding is the next thre lines of code
                M = Matrix.Identity
                M.Multiply(Matrix.RotationY(Direct3D.Geometry.DegreeToRadian(-mintCamIndex + 90)))
                .Device.Transform.World = M
            End If

            ' draw the ring vertex buffer
            '--------------
            ' set the vertex format that the vertex buffer uses
            .Device.VertexFormat = mobjRing.Description.VertexFormat
            ' set the stream source
            .Device.SetStreamSource(0, mobjRing, 0)
            ' draw the ring
            .Device.DrawPrimitives(DirectX.Direct3D.PrimitiveType.LineStrip, 0, 359)

            .Device.EndScene()
            .Present()

            ' set the next index for retrieving the camera position
            mintCamIndex += 1
            If mintCamIndex > mobjCamPositions.GetUpperBound(0) Then
                mintCamIndex = mobjCamPositions.GetLowerBound(0)
            End If
        End With
    End Sub

    Private Sub Form1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyDown
        Select Case e.KeyCode
            Case Keys.B
                mblnAlignRing = Not mblnAlignRing

            Case Keys.Escape
                Me.Close()
        End Select
    End Sub

    Protected Overrides Sub Finalize()
        MyBase.Finalize()
        RemoveHandler mobjRing.Created, AddressOf Me.OnCreateVertexBuffer
    End Sub
End Class
