'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: November 30, 2003
'=============================================


Public Interface IStandardMouseGUIEvents
    Event MouseUp(ByVal e As System.Windows.Forms.MouseEventArgs)
    Event MouseMove(ByVal e As System.Windows.Forms.MouseEventArgs)
    Event MouseDown(ByVal e As System.Windows.Forms.MouseEventArgs)
    Event Click()
    Event DoubleClick()
End Interface

Public Interface IStandardGUIEventHandler
    Sub EventHandler(ByVal E As InputEvent)
End Interface

Public Class CustomGUIButton
    Inherits DX9ToolsR4.GUI.GUIIndexed
    Implements IStandardMouseGUIEvents
    Implements IStandardGUIEventHandler

    Private mobjFont As Direct3D.Font
    Private mstrText As String
    Private mobjForeColor As Color = Color.White
    Private mobjBorderColor As Color = Color.Gray

    Public Event Click() Implements DXDrawnButton.IStandardMouseGUIEvents.Click
    Public Event DoubleClick() Implements DXDrawnButton.IStandardMouseGUIEvents.DoubleClick
    Public Event MouseDown(ByVal e As System.Windows.Forms.MouseEventArgs) Implements DXDrawnButton.IStandardMouseGUIEvents.MouseDown
    Public Event MouseMove(ByVal e As System.Windows.Forms.MouseEventArgs) Implements DXDrawnButton.IStandardMouseGUIEvents.MouseMove
    Public Event MouseUp(ByVal e As System.Windows.Forms.MouseEventArgs) Implements DXDrawnButton.IStandardMouseGUIEvents.MouseUp

#Region " New overloads ... "
    Public Sub New(ByVal Left As Single, ByVal Top As Single, ByVal Width As Single, ByVal Height As Single, _
                   ByVal Color As Color, ByVal RHW As Single)
        MyBase.New(Left, Top, Width, Height, Color, RHW)
    End Sub

    Public Sub New(ByVal Bounds As Rectangle, _
                   ByVal Color As Color, ByVal RHW As Single)
        Me.New(Bounds.Left, Bounds.Top, Bounds.Width, Bounds.Height, Color, RHW)
    End Sub

    Public Sub New(ByVal Bounds As RectangleF, _
                   ByVal Color As Color, ByVal RHW As Single)
        Me.New(Bounds.Left, Bounds.Top, Bounds.Width, Bounds.Height, Color, RHW)
    End Sub

    Public Sub New(ByVal Location As Point, ByVal Size As Size, _
                   ByVal Color As Color, ByVal RHW As Single)
        Me.New(Location.X, Location.Y, Size.Width, Size.Height, Color, RHW)
    End Sub

    Public Sub New(ByVal Location As PointF, ByVal Size As Size, _
                   ByVal Color As Color, ByVal RHW As Single)
        Me.New(Location.X, Location.Y, Size.Width, Size.Height, Color, RHW)
    End Sub

    Public Sub New(ByVal Location As Point, ByVal Size As SizeF, _
           ByVal Color As Color, ByVal RHW As Single)
        Me.New(Location.X, Location.Y, Size.Width, Size.Height, Color, RHW)
    End Sub

    Public Sub New(ByVal Location As PointF, ByVal Size As SizeF, _
           ByVal Color As Color, ByVal RHW As Single)
        Me.New(Location.X, Location.Y, Size.Width, Size.Height, Color, RHW)
    End Sub

    Public Sub New(ByVal Left As Single, ByVal Top As Single, ByVal Width As Single, ByVal Height As Single)
        Me.New(Left, Top, Width, Height, Color.White, 0)
    End Sub

    Public Sub New(ByVal R As RectangleF)
        Me.New(R.Left, R.Top, R.Width, R.Height, Color.White, 0)
    End Sub

    Public Sub New(ByVal R As Rectangle)
        Me.New(R.Left, R.Top, R.Width, R.Height, Color.White, 0)
    End Sub

    Public Sub New()
        Me.New(0, 0, 100, 25, Color.White, 0)
    End Sub

    Public Sub New(ByVal Left As Single, ByVal Top As Single, _
                   ByVal Width As Single, ByVal Height As Single, ByVal Color As Color)
        Me.New(Left, Top, Width, Height, Color, 0)
    End Sub

    Public Sub New(ByVal R As RectangleF, ByVal Color As Color)
        Me.New(R.Left, R.Top, R.Width, R.Height, Color, 0)
    End Sub

    Public Sub New(ByVal R As Rectangle, ByVal Color As Color)
        Me.New(R.Left, R.Top, R.Width, R.Height, Color, 0)
    End Sub

    Public Sub New(ByVal Color As Color)
        Me.New(0, 0, 100, 25, Color, 0)
    End Sub
#End Region


    Public Property Font() As Direct3D.Font
        Get
            Return mobjFont
        End Get
        Set(ByVal Value As Direct3D.Font)
            mobjFont = Value
        End Set
    End Property

    Public Property Text() As String
        Get
            Return mstrText
        End Get
        Set(ByVal Value As String)
            mstrText = Value
        End Set
    End Property

    Public Overrides Sub Render(ByVal Device As Microsoft.DirectX.Direct3D.Device, Optional ByVal RenderChildren As Boolean = True)
        Dim V(1) As Direct3D.CustomVertex.TransformedColoredTextured
        Dim OldColor As Color

        MyBase.Render(Device, RenderChildren)

        OldColor = Color.FromArgb(Me.Vertexes(DX9ToolsR4.GUI.VertexIndex.TopLeft).Color)
        Me.SetVertexData(mobjBorderColor)

        V(0) = Me.Vertexes(DX9ToolsR4.GUI.VertexIndex.TopLeft)
        V(1) = Me.Vertexes(DX9ToolsR4.GUI.VertexIndex.BottomLeft)
        Device.DrawUserPrimitives(Direct3D.PrimitiveType.LineList, 1, V)

        V(0) = Me.Vertexes(DX9ToolsR4.GUI.VertexIndex.TopRight)
        V(1) = Me.Vertexes(DX9ToolsR4.GUI.VertexIndex.BottomRight)
        Device.DrawUserPrimitives(Direct3D.PrimitiveType.LineList, 1, V)

        V(0) = Me.Vertexes(DX9ToolsR4.GUI.VertexIndex.TopLeft)
        V(1) = Me.Vertexes(DX9ToolsR4.GUI.VertexIndex.TopRight)
        Device.DrawUserPrimitives(Direct3D.PrimitiveType.LineList, 1, V)

        V(0) = Me.Vertexes(DX9ToolsR4.GUI.VertexIndex.BottomLeft)
        V(1) = Me.Vertexes(DX9ToolsR4.GUI.VertexIndex.BottomRight)
        Device.DrawUserPrimitives(Direct3D.PrimitiveType.LineList, 1, V)

        Me.SetVertexData(OldColor)

        If Not mobjFont Is Nothing Then
            Dim Rect As Rectangle
            Rect.X = CInt(Me.Left) + 1
            Rect.Y = CInt(Me.Top) + 1
            Rect.Width = CInt(Me.Left) + CInt(Me.Width) - 2
            Rect.Height = CInt(Me.Top) + CInt(Me.Height) - 2
            mobjFont.DrawText(mstrText, Rect, Direct3D.DrawTextFormat.VerticalCenter Or Direct3D.DrawTextFormat.Center, mobjForeColor)
        End If
    End Sub

    Public Property ForeColor() As Color
        Get
            Return mobjForeColor
        End Get
        Set(ByVal Value As Color)
            mobjForeColor = Value
        End Set
    End Property

    Public Property BorderColor() As Color
        Get
            Return mobjBorderColor
        End Get
        Set(ByVal Value As Color)
            mobjBorderColor = Value
        End Set
    End Property

    Public Sub EventHandler(ByVal E As InputEvent) Implements DXDrawnButton.IStandardGUIEventHandler.EventHandler
        Select Case E.Message
            Case EventMessage.Click
                RaiseEvent Click()

            Case EventMessage.MouseDown
                If PointOverControl(E.MouseData.X, E.MouseData.Y) Then
                    RaiseEvent MouseDown(New MouseEventArgs(E.MouseData.Button, E.MouseData.Clicks, _
                                         CInt(E.MouseData.X - Me.Left), CInt(E.MouseData.Y - Me.Top), E.MouseData.Delta))
                End If

            Case EventMessage.MouseMove
                If E.MouseData.Button = MouseButtons.None Then
                    If PointOverControl(E.MouseData.X, E.MouseData.Y) Then
                        RaiseEvent MouseMove(New MouseEventArgs(E.MouseData.Button, E.MouseData.Clicks, _
                                             CInt(E.MouseData.X - Me.Left), CInt(E.MouseData.Y - Me.Top), E.MouseData.Delta))
                    End If
                Else
                    RaiseEvent MouseMove(New MouseEventArgs(E.MouseData.Button, E.MouseData.Clicks, _
                         CInt(E.MouseData.X - Me.Left), CInt(E.MouseData.Y - Me.Top), E.MouseData.Delta))
                End If

            Case EventMessage.MouseUp
                If PointOverControl(E.MouseData.X, E.MouseData.Y) Then
                    RaiseEvent MouseUp(New MouseEventArgs(E.MouseData.Button, E.MouseData.Clicks, _
                                       CInt(E.MouseData.X - Me.Left), CInt(E.MouseData.Y - Me.Top), E.MouseData.Delta))
                End If

            Case EventMessage.None
                ' do nothing
        End Select
    End Sub

    Private Function PointOverControl(ByVal X As Integer, ByVal Y As Integer) As Boolean
        If X >= Me.Left And Y >= Me.Top Then
            If X <= Me.Left + Me.Width And Y <= Me.Top + Me.Height Then
                Return True
            End If
        End If

        Return False
    End Function
End Class

Public Enum EventMessage
    None = 0
    MouseUp = 1
    MouseMove = 2
    MouseDown = 3
    Click = 4
End Enum

Public Structure InputEvent
    Public Message As EventMessage
    Public MouseData As MouseEventArgs

    Public Sub New(ByVal Msg As EventMessage)
        Me.Message = Msg
    End Sub

    Public Sub New(ByVal MArgs As MouseEventArgs)
        Me.MouseData = MArgs
    End Sub

    Public Sub New(ByVal Msg As EventMessage, ByVal MArgs As MouseEventArgs)
        Me.Message = Msg
        Me.MouseData = MArgs
    End Sub

End Structure