'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: October 27, 2003
'=============================================

Public Class Form1
    Inherits System.Windows.Forms.Form

    Private mobjDD9 As DX9ToolsR4.DX9DDGraphicsFull
    Private mblnRunning As Boolean = False
    Private mobjLayers As DX9ToolsR4.Collections.DirectDrawLayerCollection

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(320, 278)
        Me.ControlBox = False
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.Name = "Form1"

    End Sub

#End Region


    Private Sub ResizeForm(ByVal S As Size)
        Me.Size = S
        Me.Size = New Size(S.Width + (Me.Width - Me.ClientSize.Width), _
                           S.Height + (Me.Height - Me.ClientSize.Height))
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim blnRestore As Boolean

        ResizeForm(New Size(640, 480))
        Me.Show()

        Try
            mobjDD9 = New DX9ToolsR4.DX9DDGraphicsFull(Me, DirectDraw.CreateFlags.Default, 640, 480, 32)
        Catch exd As DX9ToolsR4.Exceptions.DX9ToolsModeNotAvailible
            MsgBox("Display mode is not availible.")
            mobjDD9 = Nothing
            Me.Close()
        Catch ex As Exception
            MsgBox(ex.ToString)
        End Try
        mobjLayers = New DX9ToolsR4.Collections.DirectDrawLayerCollection()
        mobjLayers.Add(New DX9ToolsR4.DirectDrawLayer())
        mobjLayers.Add(New DX9ToolsR4.DirectDrawLayer())

        InitSurfaces()

        mblnRunning = True
        While Me.Created And mblnRunning

            blnRestore = False
            Do Until mobjDD9.Device.TestCooperativeLevel
                Application.DoEvents()
                blnRestore = True
            Loop


            If blnRestore Then
                blnRestore = False
                mobjDD9.Device.RestoreAllSurfaces() 'this just re-allocates memory back to us. we must
                'still reload all the surfaces.
                InitSurfaces() ' must init the surfaces again if they we're lost
            End If


            mobjDD9.Clear()

            With mobjLayers(0)
                Dim Dest, Source As Rectangle
                Dest = New Rectangle(320 - 64, 240 - 64, .SurfaceDescription.Width, .SurfaceDescription.Height)
                Source = New Rectangle(0, 0, .SurfaceDescription.Width, .SurfaceDescription.Height)
                mobjDD9.BackSurface.Draw(Dest, .Surface, Source, DirectX.DirectDraw.DrawFlags.Wait)
            End With

            With mobjLayers(1)
                Dim Dest, Source As Rectangle
                Dest = New Rectangle(0, 0, .SurfaceDescription.Width, .SurfaceDescription.Height)
                Source = New Rectangle(0, 0, .SurfaceDescription.Width, .SurfaceDescription.Height)
                mobjDD9.BackSurface.Draw(Dest, .Surface, Source, DirectX.DirectDraw.DrawFlags.Wait)
            End With


            mobjDD9.DestinationRectangle = New Rectangle(0, 0, 640, 480)

            mobjDD9.Present()

            Application.DoEvents()
        End While

        mobjLayers.Clear()
        mobjLayers = Nothing
        mobjDD9 = Nothing
        Me.Close()

    End Sub

    Private Sub Form1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Click
        mblnRunning = False
    End Sub

    Private Sub InitSurfaces()
        Dim info As Direct3D.ImageInformation

        DoneSurfaces()
        info = Direct3D.TextureLoader.ImageInformationFromFile("..\mymark.bmp")
        With mobjLayers(0)
            .SurfaceDescription.Clear()
            .SurfaceDescription.Width = info.Width
            .SurfaceDescription.Height = info.Height

            .SurfaceDescription.SurfaceCaps.Clear()
            .SurfaceDescription.SurfaceCaps.OffScreenPlain = True
            .Surface = New DirectDraw.Surface("..\mymark.bmp", .SurfaceDescription, mobjDD9.Device)
        End With

        info = Direct3D.TextureLoader.ImageInformationFromFile("..\cte.bmp")
        With mobjLayers(1)
            .SurfaceDescription.Clear()
            .SurfaceDescription.Width = info.Width
            .SurfaceDescription.Height = info.Height

            .SurfaceDescription.SurfaceCaps.Clear()
            .SurfaceDescription.SurfaceCaps.OffScreenPlain = True
            .Surface = New DirectDraw.Surface("..\cte.bmp", .SurfaceDescription, mobjDD9.Device)
        End With
    End Sub

    Private Sub DoneSurfaces()
        If mobjLayers.Count = 0 Then Exit Sub
        If Not mobjLayers(0).Surface Is Nothing Then mobjLayers(0).Surface.Dispose()
        If Not mobjLayers(1).Surface Is Nothing Then mobjLayers(1).Surface.Dispose()

        mobjLayers(0).Surface = Nothing
        mobjLayers(1).Surface = Nothing
    End Sub

    Private Sub Form1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyDown
        Select Case e.KeyCode
            Case Keys.Escape
                mblnRunning = False
        End Select
    End Sub
End Class
