'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: November 29, 2003
'=============================================

Imports Microsoft.DirectX.Direct3D.Geometry

Public Class Form1
    Inherits System.Windows.Forms.Form

    Private mobjGraphics As DX9ToolsR4.DX9Graphics
    Private mobjMesh As DX9ToolsR4.MeshEx
    Private mobjTextures As DX9ToolsR4.Collections.SimpleTextureCollection
    Private DeviceLost As Boolean
    Private mintRotation As Single = 0
    Private mobjFont As Direct3D.Font
    Private Cam As DX9ToolsR4.Camera

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents tmrRender As System.Windows.Forms.Timer
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Me.tmrRender = New System.Windows.Forms.Timer(Me.components)
        '
        'tmrRender
        '
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(504, 374)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.Name = "Form1"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "MeshEx - Created by: X"

    End Sub

#End Region

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.Show()
        Me.Focus()
        Application.DoEvents()

        InitGraphics()

        With cam
            ' set camera position
            .SetPosition(DX9ToolsR4.SetVector.Z, -15)
            ' set correct aspect ratio
            .AspectRatio = CSng(Me.ClientSize.Width / Me.ClientSize.Height)
        End With

        mobjTextures = New DX9ToolsR4.Collections.SimpleTextureCollection()
        mobjMesh = DX9ToolsR4.MeshEx.LoadMesh("..\Cube3.x", mobjGraphics.Device, mobjTextures)

        tmrRender.Start()
    End Sub

    Private Sub Cleanup()
        mobjTextures = Nothing
        mobjFont = Nothing
        mobjGraphics = Nothing
    End Sub

    Private Sub InitLights()
        Dim Light0 As Direct3D.Light = mobjGraphics.Device.Lights(0)
        Dim Light1 As Direct3D.Light = mobjGraphics.Device.Lights(1)
        Dim Light2 As Direct3D.Light = mobjGraphics.Device.Lights(2)
        Dim Light3 As Direct3D.Light = mobjGraphics.Device.Lights(3)

        Light0.Type = Direct3D.LightType.Directional
        Light0.Direction = New Vector3(0, -1, 1)
        Light0.Diffuse = Color.FromArgb(255, 255, 255)
        Light0.Ambient = Color.FromArgb(0, 30, 30, 200)
        Light0.Enabled = True
        Light0.Commit()

        Light1.Type = Direct3D.LightType.Directional
        Light1.Direction = New Vector3(0, 1, 1)
        Light1.Diffuse = Color.FromArgb(255, 255, 255)
        Light1.Ambient = Color.FromArgb(0, 30, 30, 200)
        Light1.Enabled = True
        Light1.Commit()

        Light2.Type = Direct3D.LightType.Directional
        Light2.Direction = New Vector3(0, 0, -1)
        Light2.Diffuse = Color.FromArgb(255, 255, 255)
        Light2.Ambient = Color.FromArgb(0, 30, 30, 200)
        Light2.Enabled = True
        Light2.Commit()

        Light3.Type = Direct3D.LightType.Directional
        Light3.Direction = New Vector3(0, 0, 1)
        Light3.Diffuse = Color.FromArgb(255, 255, 255)
        Light3.Ambient = Color.FromArgb(0, 30, 30, 200)
        Light3.Enabled = True
        Light3.Commit()
    End Sub

    Private Sub Render()
        Dim idx As Integer
        Dim Mat As Matrix = Matrix.Identity

        mobjGraphics.Clear(Color.Beige)
        mobjGraphics.Device.BeginScene()

        InitLights()

        mintRotation += 2
        If mintRotation >= 360 Then mintRotation = 0

        Mat.RotateYawPitchRoll(DegreeToRadian(mintRotation), DegreeToRadian(mintRotation), DegreeToRadian(mintRotation))

        mobjGraphics.Device.SetTransform(Direct3D.TransformType.World, Mat)

        ' render mesh
        mobjGraphics.Device.VertexFormat = mobjMesh.Mesh.VertexFormat
        DX9ToolsR4.GeneralHelpers.RenderMeshBruteForce(mobjMesh, mobjTextures)

        ' draw info
        RenderInfo()

        mobjGraphics.Device.EndScene()

        If DeviceLost Then
            Try
                ' Test the cooperative level to see if it's okay to render
                mobjGraphics.Device.TestCooperativeLevel()
            Catch e As Direct3D.DeviceLostException
                ' If the device was lost, do not render until we get it back
                Exit Sub
            Catch e As Direct3D.DeviceNotResetException
                ' Reset the device and resize it
                mobjGraphics.Device.Reset(mobjGraphics.Device.PresentationParameters)
            End Try

            DeviceLost = False
        End If

        Try
            mobjGraphics.Present()
        Catch e As Direct3D.DeviceLostException
            DeviceLost = True
        End Try
    End Sub

    Private Sub RenderInfo()
        Dim Msg As String = ""

        Msg &= "&Lighting: " & mobjGraphics.Device.RenderState.Lighting.ToString & vbCrLf
        Msg &= "&FillMode: " & mobjGraphics.Device.RenderState.FillMode.ToString & vbCrLf
        Msg &= "&ShadeMode: " & mobjGraphics.Device.RenderState.ShadeMode.ToString & vbCrLf
        Msg &= "&CullMode: " & mobjGraphics.Device.RenderState.CullMode.ToString & vbCrLf & vbCrLf

        Msg &= "Left / Right = Pan camera left and right" & vbCrLf
        Msg &= "Up / Down = Pan camera up and down" & vbCrLf
        Msg &= "Z / X = Pan camera in and out" & vbCrLf
        Msg &= "R = Reset camera" & vbCrLf

        mobjFont.DrawText(Msg, New Rectangle(10, 10, Me.ClientSize.Width - 10, Me.ClientSize.Height - 10), _
                          Direct3D.DrawTextFormat.Left Or Direct3D.DrawTextFormat.Top, _
                          Color.Red)
    End Sub


    Private Function InitGraphics() As Boolean
        Try
            mobjGraphics = New DX9ToolsR4.DX9Graphics(Me)
            Cam = New DX9ToolsR4.Camera(mobjGraphics)
            With mobjGraphics.Device
                .RenderState.CullMode = Direct3D.Cull.None
                .RenderState.FillMode = Direct3D.FillMode.Solid
                .RenderState.ShadeMode = Direct3D.ShadeMode.Gouraud
                .RenderState.Lighting = True


                ' Blend a Texture with Vertex Color
                .TextureState(0).ColorOperation = Direct3D.TextureOperation.Modulate
                .TextureState(0).ColorArgument1 = Direct3D.TextureArgument.TextureColor
                .TextureState(0).ColorArgument2 = Direct3D.TextureArgument.Diffuse
                .TextureState(0).AlphaOperation = Direct3D.TextureOperation.Disable

                mobjFont = New Direct3D.Font(mobjGraphics.Device, Me.Font)
            End With

        Catch ex As Exception
            Return False
        End Try

        Return True
    End Function

    Private Sub tmrRender_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles tmrRender.Tick
        Render()
    End Sub

    Private Sub Form1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyDown
        Select Case e.KeyCode
            Case Keys.L
                mobjGraphics.Device.RenderState.Lighting = Not mobjGraphics.Device.RenderState.Lighting

            Case Keys.F
                Select Case mobjGraphics.Device.RenderState.FillMode
                    Case Direct3D.FillMode.Point
                        mobjGraphics.Device.RenderState.FillMode = Direct3D.FillMode.Solid
                    Case Direct3D.FillMode.Solid
                        mobjGraphics.Device.RenderState.FillMode = Direct3D.FillMode.WireFrame
                    Case Direct3D.FillMode.WireFrame
                        mobjGraphics.Device.RenderState.FillMode = Direct3D.FillMode.Point
                End Select

            Case Keys.S
                Select Case mobjGraphics.Device.RenderState.ShadeMode
                    Case Direct3D.ShadeMode.Flat
                        mobjGraphics.Device.RenderState.ShadeMode = Direct3D.ShadeMode.Gouraud
                    Case Direct3D.ShadeMode.Gouraud
                        mobjGraphics.Device.RenderState.ShadeMode = Direct3D.ShadeMode.Phong
                    Case Direct3D.ShadeMode.Phong
                        mobjGraphics.Device.RenderState.ShadeMode = Direct3D.ShadeMode.Flat
                End Select

            Case Keys.C
                Select Case mobjGraphics.Device.RenderState.CullMode
                    Case Direct3D.Cull.Clockwise
                        mobjGraphics.Device.RenderState.CullMode = Direct3D.Cull.CounterClockwise
                    Case Direct3D.Cull.CounterClockwise
                        mobjGraphics.Device.RenderState.CullMode = Direct3D.Cull.None
                    Case Direct3D.Cull.None
                        mobjGraphics.Device.RenderState.CullMode = Direct3D.Cull.Clockwise
                End Select

            Case Keys.Left
                With Cam
                    .SetPosition(DX9ToolsR4.SetVector.X, .Position.X + 2)
                    .SetLookAt(DX9ToolsR4.SetVector.X, .LookAt.X + 2)
                End With

            Case Keys.Right
                With Cam
                    .SetPosition(DX9ToolsR4.SetVector.X, .Position.X + -2)
                    .SetLookAt(DX9ToolsR4.SetVector.X, .LookAt.X + -2)
                End With

            Case Keys.Up
                With Cam
                    .SetPosition(DX9ToolsR4.SetVector.Y, .Position.Y + -2)
                    .SetLookAt(DX9ToolsR4.SetVector.Y, .LookAt.Y + -2)
                End With

            Case Keys.Down
                With Cam
                    .SetPosition(DX9ToolsR4.SetVector.Y, .Position.Y + 2)
                    .SetLookAt(DX9ToolsR4.SetVector.Y, .LookAt.Y + 2)
                End With

            Case Keys.Z
                With Cam
                    .SetPosition(DX9ToolsR4.SetVector.Z, .Position.Z + 2)
                    .SetLookAt(DX9ToolsR4.SetVector.Z, .LookAt.Z + 2)
                End With

            Case Keys.X
                With Cam
                    .SetPosition(DX9ToolsR4.SetVector.Z, .Position.Z + -2)
                    .SetLookAt(DX9ToolsR4.SetVector.Z, .LookAt.Z + -2)
                End With

            Case Keys.R
                With Cam
                    .Reset()
                    .SetPosition(DX9ToolsR4.SetVector.Z, -15)
                    ' set correct aspect ratio
                    .AspectRatio = CSng(Me.ClientSize.Width / Me.ClientSize.Height)
                End With

            Case Keys.Escape
                Me.Close()
        End Select
    End Sub

    Private Sub Form1_Closed(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        Cleanup()
    End Sub
End Class
