'Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: March 30, 2003
'=============================================
Public Class Form1
    Inherits System.Windows.Forms.Form

    Private mobjGraphics As DX9ToolsR4.DX9Graphics
    Private mobjTextures As DX9ToolsR4.Collections.SimpleTextureCollection
    Private mobjVerts(3) As Direct3D.CustomVertex.PositionColoredTextured
    Private mIntRotationSpeed As Integer = 3
    Private msngZoomSpeed As Single = 10
    Private Cam As DX9ToolsR4.Camera

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents tmrRender As System.Windows.Forms.Timer
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Me.tmrRender = New System.Windows.Forms.Timer(Me.components)
        '
        'tmrRender
        '
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(10, 19)
        Me.ClientSize = New System.Drawing.Size(624, 438)
        Me.Font = New System.Drawing.Font("Courier New", 12.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.Name = "Form1"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "Parallax - Created by: X"

    End Sub

#End Region

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.Show()
        Me.Focus()
        Application.DoEvents()

        mobjGraphics = New DX9ToolsR4.DX9Graphics(Me)
        Cam = New DX9ToolsR4.Camera(mobjGraphics)

        mobjTextures = New DX9ToolsR4.Collections.SimpleTextureCollection()
        mobjTextures.Add(Direct3D.TextureLoader.FromFile(mobjGraphics.Device, "../BlueSun.png"))

        mobjGraphics.Device.RenderState.Lighting = False
        mobjGraphics.Device.RenderState.CullMode = Direct3D.Cull.None
        mobjGraphics.Device.VertexFormat = mobjVerts(0).Format


        cam.SetPosition(0, 0, -100)
        cam.FarPlane = 10000

        SetupVerts()

        tmrRender.Start()
    End Sub

    Private Sub SetupVerts()
        Dim V() As Vector3
        Dim Tuv() As Vector2
        Dim idx As Integer

        V = GeoHelpers.Vector3FromRectangle(New RectangleF(-2500, -2500, 5000, 5000))
        Tuv = GeneralHelpers.UVFromRectangle(256, 256, 0, 0, 25600, 25600)

        For idx = 0 To 3
            mobjVerts(idx) = New Direct3D.CustomVertex.PositionColoredTextured(V(idx), Color.White.ToArgb, Tuv(idx).X, Tuv(idx).Y)
        Next
    End Sub

    Private Sub tmrRender_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles tmrRender.Tick
        Dim sngZoom As Single
        Dim M As Matrix = Matrix.Identity
        Dim objGameTimer As GameTimer
        Dim intRotation As Integer = 0
        Dim blnZoomingOut As Boolean = True
        Dim objFont As Direct3D.Font

        tmrRender.Stop()
        objFont = New Direct3D.Font(mobjGraphics.Device, Me.Font)
        objGameTimer = New GameTimer()
        objGameTimer.CaptureTime()

        While Me.Created
            With mobjGraphics
                .Clear()
                .Device.BeginScene()


                ' restrict animation to 30 moves per second
                If objGameTimer.GetCurrentTime > objGameTimer.LastCapturedTime + objGameTimer.MilliToTicks(33) Then

                    With cam
                        If blnZoomingOut Then sngZoom = .Position.Z - msngZoomSpeed Else sngZoom = .Position.Z + msngZoomSpeed
                        .SetPosition(DX9ToolsR4.SetVector.Z, sngZoom)

                        If blnZoomingOut = True And .Position.Z < -1000 Then blnZoomingOut = False
                        If blnZoomingOut = False And .Position.Z > -msngZoomSpeed Then blnZoomingOut = True

                    End With

                    intRotation += mIntRotationSpeed
                    If intRotation > 360 Then intRotation = 360 - intRotation

                    M = Matrix.Identity
                    M.RotateZ(Direct3D.Geometry.DegreeToRadian(intRotation))

                    objGameTimer.CaptureTime()
                End If

                .Device.Transform.World = M
                .Device.SetTexture(0, mobjTextures(0))
                .Device.DrawUserPrimitives(Direct3D.PrimitiveType.TriangleStrip, 2, mobjVerts)

                objFont.DrawText("Left/Right    Rotation Speed" & vbCrLf & _
                                 "Up/Down       Zoom Speed" & vbCrLf & vbCrLf & _
                                 "Rotation Speed:" & mIntRotationSpeed.ToString & vbCrLf & _
                                 "Zoom Speed:" & msngZoomSpeed.ToString & vbCrLf, _
                                 Me.ClientRectangle, _
                                 Direct3D.DrawTextFormat.Top Or Direct3D.DrawTextFormat.Left, _
                                 Color.Red)


                .Device.EndScene()
                .Device.Present()

                Application.DoEvents()
            End With
        End While
    End Sub

    Private Sub Form1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyDown
        Select Case e.KeyCode
            Case Keys.Escape
                Me.Close()

            Case Keys.Left
                mIntRotationSpeed -= 1

            Case Keys.Right
                mIntRotationSpeed += 1

            Case Keys.Up
                msngZoomSpeed += 1

            Case Keys.Down
                msngZoomSpeed -= 1
        End Select

        If msngZoomSpeed < 0 Then msngZoomSpeed = 0
        If msngZoomSpeed > 100 Then msngZoomSpeed = 100

        If mIntRotationSpeed < 0 Then mIntRotationSpeed = 0
        If mIntRotationSpeed > 359 Then mIntRotationSpeed = 359
    End Sub
End Class
