'Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: March 30, 2003
'=============================================

Public Class CustomGUI
    Inherits DX9ToolsR4.GUI.GUIIndexed

    Private mobjTextureStates(7) As Direct3D.TextureState
    Private mblnVisible As Boolean = True

    Event Click()
    Event MouseDown(ByVal e As DirectInput.MouseState)
    Event MouseMove(ByVal e As DirectInput.MouseState)
    Event MouseUp(ByVal e As DirectInput.MouseState)

    Public Function GetRectangle() As RectangleF
        Return New Rectanglef(Me.Left, Me.Top, Me.Width, Me.Height)
    End Function

    Protected Sub RaiseClickEvent()
        RaiseEvent Click()
    End Sub

    Protected Sub RaiseMouseDownEvent(ByVal e As DirectInput.MouseState)
        RaiseEvent MouseDown(e)
    End Sub

    Protected Sub RaiseMouseMoveEvent(ByVal e As DirectInput.MouseState)
        RaiseEvent MouseMove(e)
    End Sub

    Protected Sub RaiseMouseUpEvent(ByVal e As DirectInput.MouseState)
        RaiseEvent MouseUp(e)
    End Sub

#Region " New overloads ... "
    Public Sub New(ByVal Left As Single, ByVal Top As Single, ByVal Width As Single, ByVal Height As Single, _
                   ByVal Color As Color, ByVal RHW As Single)
        MyBase.New(Left, Top, Width, Height, Color, RHW)

        ' setup default texture states

    End Sub

    Public Sub New(ByVal Bounds As Rectangle, _
                   ByVal Color As Color, ByVal RHW As Single)
        Me.New(Bounds.Left, Bounds.Top, Bounds.Width, Bounds.Height, Color, RHW)
    End Sub

    Public Sub New(ByVal Bounds As RectangleF, _
                   ByVal Color As Color, ByVal RHW As Single)
        Me.New(Bounds.Left, Bounds.Top, Bounds.Width, Bounds.Height, Color, RHW)
    End Sub

    Public Sub New(ByVal Location As Point, ByVal Size As Size, _
                   ByVal Color As Color, ByVal RHW As Single)
        Me.New(Location.X, Location.Y, Size.Width, Size.Height, Color, RHW)
    End Sub

    Public Sub New(ByVal Location As PointF, ByVal Size As Size, _
                   ByVal Color As Color, ByVal RHW As Single)
        Me.New(Location.X, Location.Y, Size.Width, Size.Height, Color, RHW)
    End Sub

    Public Sub New(ByVal Location As Point, ByVal Size As SizeF, _
           ByVal Color As Color, ByVal RHW As Single)
        Me.New(Location.X, Location.Y, Size.Width, Size.Height, Color, RHW)
    End Sub

    Public Sub New(ByVal Location As PointF, ByVal Size As SizeF, _
           ByVal Color As Color, ByVal RHW As Single)
        Me.New(Location.X, Location.Y, Size.Width, Size.Height, Color, RHW)
    End Sub

    Public Sub New(ByVal Left As Single, ByVal Top As Single, ByVal Width As Single, ByVal Height As Single)
        Me.New(Left, Top, Width, Height, Color.White, 0)
    End Sub

    Public Sub New(ByVal R As RectangleF)
        Me.New(R.Left, R.Top, R.Width, R.Height, Color.White, 0)
    End Sub

    Public Sub New(ByVal R As Rectangle)
        Me.New(R.Left, R.Top, R.Width, R.Height, Color.White, 0)
    End Sub

    Public Sub New()
        Me.New(0, 0, 100, 25, Color.White, 0)
    End Sub

    Public Sub New(ByVal Left As Single, ByVal Top As Single, _
                   ByVal Width As Single, ByVal Height As Single, ByVal Color As Color)
        Me.New(Left, Top, Width, Height, Color, 0)
    End Sub

    Public Sub New(ByVal R As RectangleF, ByVal Color As Color)
        Me.New(R.Left, R.Top, R.Width, R.Height, Color, 0)
    End Sub

    Public Sub New(ByVal R As Rectangle, ByVal Color As Color)
        Me.New(R.Left, R.Top, R.Width, R.Height, Color, 0)
    End Sub

    Public Sub New(ByVal Color As Color)
        Me.New(0, 0, 100, 25, Color, 0)
    End Sub
#End Region


    Public Property TextureStates(ByVal Index As Integer) As Direct3D.TextureState
        Get
            Return mobjTextureStates(index)
        End Get
        Set(ByVal Value As Direct3D.TextureState)
            mobjTextureStates(index) = Value
        End Set
    End Property

    Public Property Visible() As Boolean
        Get
            Return mblnVisible
        End Get
        Set(Byval Value As Boolean)
            mblnVisible = Value
        End Set
    End Property
End Class
