'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: November 4, 2003
'=============================================
Imports Microsoft.DirectX.Direct3D.DrawTextFormat
Imports Microsoft.DirectX.Direct3D.Geometry

Module modDoMainMenu
    Private CurrentAnimationIndex, mintFont, mintStars, mintDodads, mintPlay, mintQuit As Integer
    Private mobjSprite As DXEliminator.Sprite
    Private MousePosition As Vector2

    Public Enum MMReturns
        None = 0
        Play = 1
        Quit = 2
    End Enum

    Private TextAnimations(5) As SourceRectAnimationKey

    Public Function DoMainMenu() As MMReturns
        Dim Ret As MMReturns


        InitMM()

        gobjTimer.CaptureTime()
        CurrentAnimationIndex = 0
        While True

            ' allow for a 2 sec delay before player can do anything
            Ret = HandleInput()
            If Ret <> MMReturns.None Then Return Ret

            BeginScene(Color.Black)

            DrawStars()
            DrawMenuText()
            DrawMouse()

            EndScene(True)

            gobjTimer.CaptureTime()

            Application.DoEvents()
        End While

        DoneMM()
        Return Ret
    End Function

    Private Sub DrawMouse()
        Dim P As Vector3

        ' draw mouse
        P = GetMousePosition()
        MousePosition.X += P.X
        MousePosition.Y += P.Y

        MousePosition = DX9ToolsR4.GeneralHelpers.RestrictVector2(MousePosition, New Point(0, 0), ScreenSize)
        With mobjSprite
            .Translation = MousePosition
            .TextureIndex = mintDodads
            .SourceRectangle = New Rectangle(0, 16, 32, 47)
            .Scaling = New Vector2(1, 1)
        End With
        DrawSprite(mobjSprite)
    End Sub

    Private Sub DrawMenuText()
        Static LastTextAniTime As Long

        ' setup next text ani
        If gobjTimer.TicksToMilli(gobjTimer.LastCapturedTime - LastTextAniTime) > TextAnimations(CurrentAnimationIndex).Display Then    ' 1/16sec delay
            CurrentAnimationIndex += 1
            If CurrentAnimationIndex > 5 Then CurrentAnimationIndex = 0
            LastTextAniTime = gobjTimer.LastCapturedTime
        End If


        ' draw play text
        With mobjSprite
            .Scaling = New Vector2(2, 2)
            .Translation = New Vector2(192, 144 - 64)
            .TextureIndex = mintPlay
            .SourceRectangle = TextAnimations(CurrentAnimationIndex).SourceRectangle
        End With
        DrawSprite(mobjSprite)

        ' draw quit text
        With mobjSprite
            .Scaling = New Vector2(2, 2)
            .Translation = New Vector2(192, 336 - 64)
            .TextureIndex = mintQuit
            .SourceRectangle = TextAnimations(CurrentAnimationIndex).SourceRectangle
        End With
        DrawSprite(mobjSprite)
    End Sub

    Private Sub DrawStars()
        Static LastStarTime As Long
        Static Star As Vector2
        Dim idx, idy As Integer


        ' setup stars
        If gobjTimer.TicksToMilli(gobjTimer.LastCapturedTime - LastStarTime) > 20 Then   ' 1/50sec delay
            Star.X += 1
            Star.Y += 3
            If Star.X > 256 Then Star.X = Star.X - 256
            If Star.Y > 256 Then Star.Y = Star.Y - 256

            LastStarTime = gobjTimer.LastCapturedTime
        End If

        ' draw stars
        For idy = -1 To (ScreenSize.Height \ 256) + 1
            For idx = -1 To (ScreenSize.Width \ 256) + 2
                With mobjSprite
                    .Translation = New Vector2(Star.X + (idx * 256), Star.Y + (idy * 256))
                    .TextureIndex = mintStars
                    .SourceRectangle = New Rectangle(0, 0, 256, 256)
                End With

                DrawSprite(mobjSprite)
            Next
        Next
    End Sub

    Private Function HandleInput() As MMReturns
        Static LastTime As Long

        GetKBState()
        GetMouseState()

        If gobjTimer.TicksToMilli(gobjTimer.LastCapturedTime - LastTime) > 62 Then   ' 1/16sec delay

            ' quit game
            If KBKey(DirectX.DirectInput.Key.Escape) Or KBKey(DirectX.DirectInput.Key.Q) Then

                Return MMReturns.Quit
            ElseIf GetMouseButton(0) Then
                If CommonCommandsR3.InBounds(MousePosition.X, MousePosition.Y, 192, 336 - 64, TextAnimations(CurrentAnimationIndex).SourceRectangle.Size) Then
                    Return MMReturns.Quit
                End If
            End If

            ' play game
            If KBKey(DirectX.DirectInput.Key.P) Then
                Return MMReturns.Play


            ElseIf GetMouseButton(0) Then
                If CommonCommandsR3.InBounds(MousePosition.X, MousePosition.Y, 192, 144 - 64, TextAnimations(CurrentAnimationIndex).SourceRectangle.Size) Then
                    Return MMReturns.Play
                End If
            End If

            LastTime = gobjTimer.LastCapturedTime
        End If

        Return MMReturns.None
    End Function

    Private Sub InitMM()
        Dim index, idx, idy As Integer

        SetViewport(0, 0, ScreenSize)

        mintFont = CreateNewFont(New Font("Ariel Black", 36, FontStyle.Bold, GraphicsUnit.Pixel))
        mobjSprite = New DXEliminator.Sprite(False)
        mintStars = LoadTexture("..\stars.png")
        mintDodads = LoadTexture("..\dodads.png", Color.Black)
        mintPlay = LoadTexture("..\play.png", Color.Black)
        mintQuit = LoadTexture("..\quit.png", Color.Black)
        mobjSprite.TextureIndex = mintDodads

        ' setup text animations
        index = 0
        For idy = 0 To 190 Step 64
            For idx = 0 To 200 Step 128
                TextAnimations(index) = New SourceRectAnimationKey()
                TextAnimations(index).Display = 150
                TextAnimations(index).SourceRectangle = New Rectangle(idx, idy, idx + 128, idy + 64)
                index += 1
            Next
        Next
    End Sub

    Private Sub DoneMM()
        Try
            DeleteFont(mintFont)
            DeleteTexture(mintDodads)
            DeleteTexture(mintStars)

            mobjSprite = Nothing
        Catch
        End Try
    End Sub
End Module