'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: November 4, 2003
'=============================================
Imports Microsoft.DirectX.Direct3D.DrawTextFormat
Imports Microsoft.DirectX.Direct3D.Geometry
Imports Microsoft.DirectX.Direct3D.TransformType

Module modDoPlay

    Private mintFont, mintDoodads, mintPlayBackground As Integer  'mintPlayer, mintEnimies
    Private mobjSprite As DXEliminator.Sprite
    Private mobjCharacters(0) As CharacterItem
    Private mobjParticles() As ParticleItem
    Private mobjWeaponFire() As WeaponFireItem
    Private mintPlayerIndex As Integer = 0
    Private mblnPlaying As Boolean = False
    Private mobjTextures As DX9ToolsR4.Collections.SimpleTextureCollection
    Private MinGamePlayArea, MaxGamePlayArea As Vector3
    Private Meshes() As DX9ToolsR4.MeshEx
    Private Const cintPlayerMesh As Integer = 0
    Private Const cintRockMesh As Integer = 1
    Private Const cintShotMesh As Integer = 2

    Public Sub DoPlay()

        InitPlay()
        mblnPlaying = True
        gobjTimer.CaptureTime()
        While mblnPlaying


            ' handle input
            HandleInput()
            If Not mblnPlaying Then Exit While

            BeginScene(Color.Black)


            'render characters
            SetViewport(160, 0, ScreenSize.Width - 160, ScreenSize.Height)
            ' MoveChars()
            RenderChars()

            MoveParticles()
            RenderParticles()

            ' render gui
            SetViewport(0, 0, ScreenSize)
            RenderGui()

            EndScene(True)

            gobjTimer.CaptureTime()
            Application.DoEvents()

        End While

        DonePlay()
    End Sub

    Private Sub MoveChars()
        Dim idx As Integer
        Dim Item As Action
        Dim M As Matrix

        For idx = 0 To mobjCharacters.GetUpperBound(0)
            With mobjCharacters(idx)
                While True
                    If .Actions.Count = 0 Then Exit While
                    If .Actions.Peek.TimeUp(gobjTimer.LastCapturedTime) Then
                        .Actions.Pop()
                    Else
                        Exit While
                    End If
                End While

                If .Actions.Count > 0 Then
                    Item = .Actions.Peek
                    Item.Update(gobjTimer.LastCapturedTime)

                    Select Case Item.ActionType
                        Case ActionType.Move
                            .Location = DirectCast(Item, ActionMove).Value

                        Case ActionType.Rotate
                            '.Location = DirectCast(Item, ActionRotate).Value

                        Case ActionType.Scale
                            '.Location = DirectCast(Item, ActionScale).Value
                    End Select

                    If .Location.X < MinGamePlayArea.X Then .Location.X = MinGamePlayArea.X
                    If .Location.Y < MinGamePlayArea.Y Then .Location.Y = MinGamePlayArea.Y
                    If .Location.X > MaxGamePlayArea.X Then .Location.X = MaxGamePlayArea.X
                    If .Location.Y > MaxGamePlayArea.Y Then .Location.Y = MaxGamePlayArea.Y

                    M = Matrix.Identity
                    M.Scale(1, 1, 1)
                    M.M41 = .Location.X
                    M.M42 = .Location.Y
                    M.M43 = .Location.Z
                    .Matrix = M
                End If
            End With
        Next
    End Sub

    Private Sub MoveParticles()
        Dim idx As Integer
        Dim M As Matrix


        For idx = 0 To mobjParticles.GetUpperBound(0)
            With mobjParticles(idx)
                .Location.Add(.Speed)

                M = Matrix.Identity
                M.Multiply(.Animations(.CurrentAnimationIndex).Matrix)
                M.M41 = .Location.X
                M.M42 = .Location.Y
                M.M43 = .Location.Z
                .Matrix = M
            End With
        Next

        DoCharacterParticleCollisionCheck()
    End Sub

    Private Sub DoCharacterParticleCollisionCheck()
        Dim idx, idy As Integer
        Dim MoveTo As Vector3

        For idx = 0 To mobjParticles.GetUpperBound(0)
            For idy = 0 To mobjCharacters.GetUpperBound(0)
                With mobjParticles(idx)
                    MoveTo = Vector3.Add(.Location, .Speed)

                    SetTransform(World, mobjCharacters(mintPlayerIndex).Matrix)
                    If Meshes(cintPlayerMesh).Mesh.Intersect(.Location, MoveTo) Then
                        ' collision?
                        mblnPlaying = False
                        Exit Sub
                    End If
                End With
            Next
        Next
    End Sub

    Private Sub RenderParticles()
        Dim idx As Integer

        For idx = 0 To mobjParticles.GetUpperBound(0)
            SetTransform(World, mobjParticles(idx).Matrix)
            DX9ToolsR4.GeneralHelpers.RenderMeshBruteForce(mobjParticles(idx).Mesh, mobjTextures)
        Next
    End Sub

    Private Sub RenderChars()
        Dim idx As Integer

        For idx = 0 To mobjCharacters.GetUpperBound(0)
            SetTransform(World, mobjCharacters(idx).Matrix)
            DX9ToolsR4.GeneralHelpers.RenderMeshBruteForce(mobjCharacters(idx).Mesh, mobjTextures)
        Next
    End Sub

    Private Sub FireWeapon()
        ' setup character
        If mobjWeaponFire Is Nothing Then
            ReDim mobjWeaponFire(0)
        Else
            ReDim Preserve mobjWeaponFire(mobjWeaponFire.Length)
        End If
        Randomize(Now.Ticks)
        mobjWeaponFire(mobjWeaponFire.Length - 1) = New WeaponFireItem()
        With mobjWeaponFire(mobjWeaponFire.Length - 1)
            .Mesh = Meshes(cintShotMesh)

            '.Location = GetVector3FromXY(ScreenSize.height \ 2, ScreenSize.Height - 100)
            .Location = New Vector3(-100 + (Rnd() * 200), -175 + (Rnd() * 50), 0)
            .MaxHealth = 0
            .Health = 0

            .Speed = New Vector3(0, Rnd() * 3, 0)
            .CurrentAnimationIndex = 0
            .LastTime = gobjTimer.LastCapturedTime

            ReDim .Animations(0)
            .Animations(0) = New SourceRectAnimationKeyMatrix()
            .Animations(0).Display = gobjTimer.MilliToTicks(100)
            .Animations(0).Matrix = Matrix.Identity
            .Animations(0).Matrix.Scale(New Vector3(1, 1, 1))

        End With
    End Sub

    Private Sub HandleInput()
        Dim P As Vector3
        Dim M As Matrix

        GetKBState()
        GetMouseState()

        ' get kb
        If KBKey(DirectX.DirectInput.Key.Escape) Then mblnPlaying = False

        ' get mouse
        P = GetMousePosition()
        'If GetMouseButton(0) <> 0 Then FireWeapon()


        With mobjCharacters(mintPlayerIndex)
            P.Y = -P.Y
            mobjCharacters(mintPlayerIndex).Location.Add(P)

            '.Location.Add(.Speed)

            If .Location.X < MinGamePlayArea.X Then .Location.X = MinGamePlayArea.X
            If .Location.Y < MinGamePlayArea.Y Then .Location.Y = MinGamePlayArea.Y
            If .Location.X > MaxGamePlayArea.X Then .Location.X = MaxGamePlayArea.X
            If .Location.Y > MaxGamePlayArea.Y Then .Location.Y = MaxGamePlayArea.Y

            M = Matrix.Identity
            M.Multiply(.Animations(.CurrentAnimationIndex).Matrix)
            M.M41 = .Location.X
            M.M42 = .Location.Y
            M.M43 = .Location.Z
            .Matrix = M

            '' check if move moved
            'If P.X <> 0 Or P.Y <> 0 Or P.Z <> 0 Then
            '    If .Actions.Count < 10 Then
            '        Dim MA As ActionMove
            '        MA = New ActionMove()
            '        MA.MoveFrom = .Location
            '        MA.MoveTo = Vector3.Add(.Location, New Vector3(P.X * .Speed.X, P.Y * .Speed.Y, 0 * .Speed.Z))
            '        MA.ActionTime = gobjTimer.MilliToTicks(1000)
            '        MA.LastActionTime = gobjTimer.LastCapturedTime

            '        .Actions.Push(MA)
            '    End If
            'End If
        End With
    End Sub

    Private Sub RenderGui()
        Dim C As CharacterItem
        Dim idx As Integer


        ' draw stats
        For idx = 0 To 1
            With mobjSprite
                .SourceRectangle = New Rectangle(0, 0, 256, 256)
                .Translation = New Vector2(-96, idx * 256)
                .TextureIndex = mintPlayBackground
            End With

            DrawSprite(mobjSprite)
        Next

        ' draw player power
        C = mobjCharacters(mintPlayerIndex)
        With mobjSprite
            .SourceRectangle = New Rectangle(0, 0, (C.Health \ C.MaxHealth) * C.MaxHealth, 16)
            .Translation = New Vector2(16.5, 10)
            .TextureIndex = mintDoodads
        End With
        DrawSprite(mobjSprite)

        ' draw steel bar
        For idx = 0 To 159
            With mobjSprite
                .SourceRectangle = New Rectangle(100, 0, 127, 3)
                .Translation = New Vector2(133, idx * 3)
                .TextureIndex = mintDoodads
            End With

            DrawSprite(mobjSprite)
        Next
    End Sub

    Private Sub InitPlay()

        mobjTextures = New DX9ToolsR4.Collections.SimpleTextureCollection()
        SetLightingState(False)

        GetDevice.VertexFormat = Direct3D.CustomVertex.PositionTextured.Format

        mintFont = CreateNewFont(New Font("Ariel Black", 16, FontStyle.Bold, GraphicsUnit.Pixel))
        mobjSprite = New DXEliminator.Sprite(False)
        mintDoodads = LoadTexture("..\dodads.png")
        'mintPlayer = LoadTexture("..\ship.tga")
        'mintEnimies = LoadTexture("..\enemies.tga")
        mintPlayBackground = LoadTexture("..\playback.png")

        SetViewport(160, 0, ScreenSize.Width - 160, ScreenSize.Height)
        MinGamePlayArea = New Vector3(-100, -100, 0)
        MaxGamePlayArea = New Vector3(100, 100, 0)

        ReDim Meshes(2)
        Meshes(cintPlayerMesh) = DX9ToolsR4.MeshEx.LoadMesh("..\Ship.x", GetDevice, mobjTextures)
        Meshes(cintRockMesh) = DX9ToolsR4.MeshEx.LoadMesh("..\Rock.x", GetDevice, mobjTextures)
        Meshes(cintShotMesh) = DX9ToolsR4.MeshEx.LoadMesh("..\Shot1.x", GetDevice, mobjTextures)

        ' create 3 rocks
        CreateRock()
        CreateRock()
        CreateRock()

        ' setup character
        mintPlayerIndex = 0
        ReDim mobjCharacters(0)
        mobjCharacters(mintPlayerIndex) = New CharacterItem()
        With mobjCharacters(mintPlayerIndex)
            .Mesh = Meshes(cintPlayerMesh)

            '.Location = GetVector3FromXY(ScreenSize.height \ 2, ScreenSize.Height - 100)
            .Location = New Vector3(0, 99, 0)
            .MaxHealth = 100
            .Health = 100

            .Speed = New Vector3(1, 1, 1)
            .CurrentAnimationIndex = 0
            .LastTime = gobjTimer.LastCapturedTime

            ReDim .Animations(0)
            .Animations(0) = New SourceRectAnimationKeyMatrix()
            .Animations(0).Display = gobjTimer.MilliToTicks(100)
            .Animations(0).Matrix = Matrix.Identity
            .Animations(0).Matrix.Scale(1, 1, 1)
            .Matrix = .Animations(0).Matrix
        End With


        ApplyCamera()

    End Sub

    Private Sub CreateRock()
        ' setup character
        If mobjParticles Is Nothing Then
            ReDim mobjParticles(0)
        Else
            ReDim Preserve mobjParticles(mobjParticles.Length)
        End If
        Randomize(Now.Ticks)
        mobjParticles(mobjParticles.Length - 1) = New ParticleItem()
        With mobjParticles(mobjParticles.Length - 1)
            .Mesh = Meshes(cintRockMesh)

            '.Location = GetVector3FromXY(ScreenSize.height \ 2, ScreenSize.Height - 100)
            .Location = New Vector3(-100 + (Rnd() * 200), -175 + (Rnd() * 50), 0)
            .MaxHealth = 100
            .Health = 100

            .Speed = New Vector3(0, Rnd() * 3, 0)
            .CurrentAnimationIndex = 0
            .LastTime = gobjTimer.LastCapturedTime

            ReDim .Animations(0)
            .Animations(0) = New SourceRectAnimationKeyMatrix()
            .Animations(0).Display = gobjTimer.MilliToTicks(100)
            .Animations(0).Matrix = Matrix.Identity
            .Animations(0).Matrix.Scale(New Vector3(1, 1, 1))

        End With
    End Sub

    Private Sub DonePlay()
        Try
            DeleteFont(mintFont)
            DeleteTexture(mintDoodads)
            DeleteTexture(mintPlayBackground)
            'DeleteTexture(mintEnimies)
            'DeleteTexture(mintPlayer)
            mobjSprite = Nothing
            Erase mobjCharacters
            mobjCharacters = Nothing

            mobjTextures.Remove(0, mobjTextures.Count)
            mobjTextures = Nothing
        Catch
        End Try
    End Sub
End Module