'Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: March 22, 2003
'=============================================
' Instructions 
'       R               Reset mouse sprite
'       Left Arrow      Rotate left
'       Right Arrow     Rotate right
'       Up Arrow        Scale Up
'       Down Arrow      Scale Down
'
'       With Shift pressed
'           Left Arrow      Move rotatation center left
'           Right Arrow     Move rotatation center right
'           Up Arrow        Move rotatation center up
'           Down Arrow      Move rotatation center down
'=============================================
Imports Microsoft.DirectX.Direct3D.Geometry

Public Class Form1
    Inherits System.Windows.Forms.Form

    Private mobjGraphics As DX9ToolsR4.DX9Graphics
    Private mobjSprite As DX9ToolsR4.Sprites.SpriteBlt
    Private mobjMouseSprite As DX9ToolsR4.Sprites.SpriteTransformTextured
    Private mobjTextures As DX9ToolsR4.Collections.SimpleTextureCollection
    Private mintMouseTexture As Integer

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(440, 294)
        Me.Name = "Form1"
        Me.Text = "Sprite Blt - Created by: X"

    End Sub

#End Region


    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim TexInfo As Direct3D.ImageInformation

        mobjGraphics = New DX9ToolsR4.DX9Graphics(Me)
        mobjSprite = New DX9ToolsR4.Sprites.SpriteBlt(mobjGraphics.Device)
        mobjTextures = New DX9ToolsR4.Collections.SimpleTextureCollection()
        mintMouseTexture = mobjTextures.Add(Direct3D.TextureLoader.FromFile(mobjGraphics.Device, "..\Mouse.tga", 0, 0, 1, 0, Direct3D.Format.Unknown, Direct3D.Pool.Managed, Direct3D.Filter.None, Direct3D.Filter.None, Color.Black.ToArgb))
        TexInfo = Direct3D.TextureLoader.ImageInformationFromFile("..\Mouse.tga")
        Me.Cursor = New Cursor("..\empty.cur")

        mobjMouseSprite = New DX9ToolsR4.Sprites.SpriteTransformTextured(True, False)
        With mobjMouseSprite
            .Color = Color.White
            .SourceRectangle = New Rectangle(0, 0, TexInfo.Width - 1, TexInfo.Height - 1)
            .TextureIndex = mintMouseTexture
            .TransformMatrix = Matrix.Identity
            .UseTextureIndex = True
            .UseTransformMatrix = False
        End With
        ResetMouseSprite()

        Me.Show()
        While Me.Created
            Render()
            Application.DoEvents()
        End While
    End Sub

    Private Sub ResetMouseSprite()
        With mobjMouseSprite
            .Rotation = DegreeToRadian(0)
            .RotationCenter = New Vector2(0, 0)
            .Scaling = New Vector2(1, 1)
        End With
    End Sub

    Private Sub Render()
        mobjGraphics.Clear(Color.Beige)
        mobjGraphics.Device.BeginScene()


        ' render mouse
        mobjSprite.Draw(mobjMouseSprite, mobjTextures)


        mobjGraphics.Device.EndScene()
        mobjGraphics.Present()
    End Sub

    Private Sub Form1_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseMove
        mobjMouseSprite.Translation = New Vector2(e.X, e.Y)
    End Sub

    Private Sub Form1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyDown
        Select Case e.Shift
            Case True
                Select Case e.KeyCode
                    Case Keys.Left
                        With mobjMouseSprite
                            .RotationCenter = New Vector2(.RotationCenter.X - 1, .RotationCenter.Y)
                        End With

                    Case Keys.Right
                        With mobjMouseSprite
                            .RotationCenter = New Vector2(.RotationCenter.X - 1, .RotationCenter.Y)
                        End With

                    Case Keys.Up
                        With mobjMouseSprite
                            .RotationCenter = New Vector2(.RotationCenter.Y, .RotationCenter.Y - 1)
                        End With

                    Case Keys.Down
                        With mobjMouseSprite
                            .RotationCenter = New Vector2(.RotationCenter.X, .RotationCenter.Y + 1)
                        End With

                End Select

            Case False
                Select Case e.KeyCode
                    Case Keys.Left
                        mobjMouseSprite.Rotation -= DegreeToRadian(5)

                    Case Keys.Right
                        mobjMouseSprite.Rotation += DegreeToRadian(5)

                    Case Keys.Up
                        With mobjMouseSprite
                            .Scaling = New Vector2(.Scaling.X + 1, .Scaling.Y + 1)
                        End With

                    Case Keys.Down
                        With mobjMouseSprite
                            .Scaling = New Vector2(.Scaling.X - 1, .Scaling.Y - 1)
                        End With

                    Case Keys.R
                        ResetMouseSprite()
                End Select
        End Select
    End Sub
End Class
