'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: August 6, 2003
'=============================================

Imports Microsoft.DirectX.Direct3D.Geometry

''' <summary>
''' Contains a methods to assist in geometry related functionality.
''' </summary>
Public Class GeoHelpers

#Region " LoadMesh overloads ... "
    'Public Shared Function LoadMesh(ByVal Filename As String, ByVal Dev As Direct3D.Device, _
    '                         ByVal Textures As DX9ToolsR4.TextureCollection, _
    '                         Optional ByVal MeshFlags As Direct3D.MeshFlags = Direct3D.MeshFlags.Managed) As MeshEx
    '    Dim idx As Integer
    '    Dim Mats() As Direct3D.ExtendedMaterial
    '    Dim Mesh As MeshEx
    '    Dim Tex As Direct3D.Texture
    '    Dim TmpMat As MaterialTextureCombo

    '    Mesh = New DX9ToolsR4.MeshEx()
    '    Mesh.Mesh = Direct3D.Mesh.FromFile(Filename, MeshFlags, Dev, Mats)
    '    With Mesh
    '        If Not Mats Is Nothing Then
    '            .SetMaterialCount(Mats.Length - 1, False)

    '            For idx = 0 To .MaterialCount - 1
    '                Tex = Direct3D.TextureLoader.FromFile(Dev, Mats(idx).TextureFilename)

    '                TmpMat = New MaterialTextureCombo()
    '                TmpMat.Material = Mats(idx).Material3D
    '                TmpMat.Textures(TextureStage.Base) = Textures.Add(Tex)
    '                .SetMaterial(idx, TmpMat)
    '            Next ' idx loop
    '        End If ' mats is not nothing
    '    End With ' with mesh

    '    Return Mesh
    'End Function

       ''' <summary>
    ''' Loads a mesh from a file.
    ''' </summary>
    ''' <param name="Filename">The mesh file to load.</param>
    ''' <param name="Dev">A reference to a Direct3D.Device type.</param>
    ''' <param name="Textures">A reference to a DX9ToolsR4.SimpleTextureCollection type that any textures will be added to.</param>
    ''' <param name="MeshFlags">Defines flags used to specify creation options for a mesh.</param>
    ''' <returns>Returns a reference to a new MeshEx type.</returns>
    Public Shared Function LoadMesh(ByVal Filename As String, ByVal Dev As Direct3D.Device, _
                            ByVal Textures As DX9ToolsR4.Collections.SimpleTextureCollection, _
                            Optional ByVal MeshFlags As Direct3D.MeshFlags = Direct3D.MeshFlags.Managed) As MeshEx
        Dim idx As Integer
        Dim Mats() As Direct3D.ExtendedMaterial
        Dim Mesh As MeshEx
        Dim TmpMat As MaterialTextureCombo

        Mesh = New DX9ToolsR4.MeshEx()
        Mesh.Mesh = Direct3D.Mesh.FromFile(Filename, MeshFlags, Dev, Mats)
        With Mesh
            If Not Mats Is Nothing Then
                .SetMaterialCount(Mats.Length, False)

                For idx = 0 To .MaterialCount - 1
                    TmpMat = New MaterialTextureCombo()
                    TmpMat.Material = Mats(idx).Material3D
                    If Not Mats(idx).TextureFilename Is Nothing Then
                        If Mats(idx).TextureFilename.Length > 0 Then
                            TmpMat.Textures(TextureStage.Base) = Textures.Add(Direct3D.TextureLoader.FromFile(Dev, Mats(idx).TextureFilename))
                        End If
                    End If
                    .SetMaterial(idx, TmpMat)
                Next ' idx loop
            End If ' mats is not nothing
        End With ' with mesh

        Return Mesh
    End Function
#End Region

#Region " GenerateEllipsePoints overloads ... "
    ''' <summary>
    ''' Generates an array of Point types that represent an ellipse.
    ''' </summary>
    ''' <param name="R">The rectangle that specifies the bounnds of the ellipse.</param>
    ''' <param name="Pts">The varible that will be used to store the array of Point types that represent the ellipse.</param>
    Public Shared Sub GenerateEllipsePoints(ByVal R As RectangleF, ByRef Pts() As Point)
        Dim TmpPts() As Vector2
        Dim idx As Integer

        GenerateEllipsePoints(R, 359, DegreeToRadian(1), DegreeToRadian(0), TmpPts)

        ReDim Pts(359)
        For idx = 0 To 359
            Pts(idx) = New Point(CInt(TmpPts(idx).X), CInt(TmpPts(idx).Y))
        Next
    End Sub

    ''' <summary>
    ''' Generates an array of Point types that represent an ellipse.
    ''' </summary>
    ''' <param name="R">The rectangle that specifies the bounnds of the ellipse.</param>
    ''' <param name="Pts">The varible that will be used to store the array of PointF types that represent the ellipse.</param>
    Public Shared Sub GenerateEllipsePoints(ByVal R As RectangleF, ByRef Pts() As PointF)
        Dim TmpPts() As Vector2
        Dim idx As Integer

        GenerateEllipsePoints(R, 359, DegreeToRadian(1), DegreeToRadian(0), TmpPts)

        ReDim Pts(359)
        For idx = 0 To 359
            Pts(idx) = New PointF(TmpPts(idx).X, TmpPts(idx).Y)
        Next
    End Sub

    ''' <summary>
    ''' Generates an array of Point types that represent an ellipse.
    ''' </summary>
    ''' <param name="R">The rectangle that specifies the bounnds of the ellipse.</param>
    ''' <param name="Pts">The varible that will be used to store the array of Vector2 types that represent the ellipse.</param>
    Public Shared Sub GenerateEllipsePoints(ByVal R As RectangleF, ByRef Pts() As Vector2)
        GenerateEllipsePoints(R, 359, DegreeToRadian(1), DegreeToRadian(0), Pts)
    End Sub

    ''' <summary>
    ''' Generates an array of Point types that represent an ellipse.
    ''' </summary>
    ''' <param name="R">The rectangle that specifies the bounnds of the ellipse.</param>
    ''' <param name="NumPoints">The number of points in the ellipse.</param>
    ''' <param name="DegPerPoint">The number of degress to use between each point.</param>
    ''' <param name="StartDeg">The start degree.</param>
    ''' <param name="Pts">The varible that will be used to store the array of Vector2 types that represent the ellipse.</param>
    Public Shared Sub GenerateEllipsePoints(ByVal R As RectangleF, ByVal NumPoints As Integer, _
                                            ByVal DegPerPoint As Single, ByVal StartDeg As Single, _
                                            ByRef Pts() As Vector2)
        Dim idx As Integer
        Dim X, Y, Radian As Single

        ReDim Pts(NumPoints)

        Radian = StartDeg
        For idx = 0 To NumPoints
            Pts(idx) = New Vector2(CSng(R.Left + System.Math.Cos(Radian) * R.Right), _
                                   CSng(R.Top + System.Math.Sin(Radian) * R.Bottom))
            Radian += DegPerPoint
        Next
    End Sub

    ''' <summary>
    ''' Generates an array of Point types that represent an ellipse.
    ''' </summary>
    ''' <param name="R">The rectangle that specifies the bounnds of the ellipse.</param>
    ''' <param name="Pts">The varible that will be used to store the array of Vector3 types that represent the ellipse.</param>
    Public Shared Sub GenerateEllipsePoints(ByVal R As RectangleF, ByRef Pts() As Vector3)
        GenerateEllipsePoints(R, Orientation.XY, 359, DegreeToRadian(1), DegreeToRadian(0), Pts)
    End Sub

    ''' <summary>
    ''' Generates an array of Point types that represent an ellipse.
    ''' </summary>
    ''' <param name="R">The rectangle that specifies the bounnds of the ellipse.</param>
    ''' <param name="Orient">Specifies the orientation axis.</param>
    ''' <param name="Pts">The varible that will be used to store the array of Vector3 types that represent the ellipse.</param>
    Public Shared Sub GenerateEllipsePoints(ByVal R As RectangleF, ByVal Orient As Orientation, ByRef Pts() As Vector3)
        GenerateEllipsePoints(R, Orient, 359, DegreeToRadian(1), DegreeToRadian(0), Pts)
    End Sub

    ''' <summary>
    ''' Generates an array of Point types that represent an ellipse.
    ''' </summary>
    ''' <param name="R">The rectangle that specifies the bounnds of the ellipse.</param>
    ''' <param name="Orient">Specifies the orientation axis.</param>
    ''' <param name="NumPoints">The number of points in the ellipse.</param>
    ''' <param name="DegPerPoint">The number of degress to use between each point.</param>
    ''' <param name="StartDeg">The start degree.</param>
    ''' <param name="Pts">The varible that will be used to store the array of Vector3 types that represent the ellipse.</param>
    Public Shared Sub GenerateEllipsePoints(ByVal R As RectangleF, ByVal Orient As Orientation, _
                                            ByVal NumPoints As Integer, _
                                            ByVal DegPerPoint As Single, ByVal StartDeg As Single, _
                                            ByRef Pts() As Vector3)
        Dim idx As Integer
        Dim X, Y, Radian As Single

        ReDim Pts(NumPoints)

        Radian = StartDeg
        For idx = 0 To NumPoints
            Select Case Orient
                Case Orientation.XY
                    Pts(idx) = New Vector3(CSng(R.Left + System.Math.Cos(Radian) * R.Right), _
                                           CSng(R.Top + System.Math.Sin(Radian) * R.Bottom), _
                                           0)
                Case Orientation.XZ
                    Pts(idx) = New Vector3(CSng(R.Left + System.Math.Cos(Radian) * R.Right), _
                                           0, _
                                           CSng(R.Top + System.Math.Sin(Radian) * R.Bottom))
                Case Orientation.ZY
                    Pts(idx) = New Vector3(0, _
                                           CSng(R.Top + System.Math.Sin(Radian) * R.Bottom), _
                                           CSng(R.Left + System.Math.Cos(Radian) * R.Right))
            End Select

            Radian += DegPerPoint
        Next
    End Sub
#End Region

    'TODO: add more Vector3FromRectangle overloads 
    ''' <summary>
    ''' Generates an array of 4 vector3 types using a rectanglef type as the source.
    ''' </summary>
    ''' <param name="R">The source rectangle from which the vectors wil be built from.</param>
    ''' <returns>Returns an array of 4 Vector3 types.</returns>
    Public Shared Function Vector3FromRectangle(ByVal R As RectangleF) As Vector3()
        Dim V(3) As Vector3

        ' TopLeft
        V(0) = New Vector3(R.Left, R.Bottom, 0)
        ' Topright
        V(1) = New Vector3(R.Right, R.Bottom, 0)
        ' bottomleft
        V(2) = New Vector3(R.Left, R.Top, 0)
        ' bottomright
        V(3) = New Vector3(R.Right, R.Top, 0)

        Return V
    End Function
End Class
