'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: August 6, 2003
'=============================================

Imports Microsoft.DirectX.Direct3D.Geometry

''' <summary>
''' Contains a methods to assist in lighting related functionality.
''' </summary>
Public Class LightHelpers
    'TODO: add more light creation overloads

    ''' <summary>
    ''' Creates a directional light.
    ''' </summary>
    ''' <param name="Color">The color of the light.</param>
    ''' <param name="Orient">The lights orientation.</param>
    ''' <returns>Returns a reference to a Direct3D.Light type.</returns>
    Public Shared Function CreateDirectionalLight(ByVal Color As Color, ByVal Orient As Direction) As Direct3D.Light
        Dim L As Direct3D.Light

        L = New Direct3D.Light()
        L.Type = Direct3D.LightType.Directional
        L.Position = New Vector3(0, 0, -1)

        If Orient = Direction.None Then
            ' do notihing
        ElseIf CBool(Orient And Direction.X) Then
            L.Position = New Vector3(-1, 0, 0)

        ElseIf CBool(Orient And Direction.Y) Then
            L.Position = New Vector3(0, -1, 0)

        ElseIf CBool(Orient And Direction.Z) Then
            L.Position = New Vector3(0, 0, -1)

        End If

        L.Direction = New Vector3(0, 0, 0)
        L.Ambient = Color
        L.Diffuse = L.Ambient

        Return L
    End Function
End Class
