'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: August 6, 2003
'=============================================

Imports Microsoft.DirectX.Direct3D.Geometry

''' <summary>
''' Contains a methods to assist with math related functionality.
''' </summary>
Public Class MathHelpers
    '''' <summary>
    '''' Calculates the length of a right triangles side.
    '''' </summary>
    '''' <param name="Length">The length of the triangles opposite side.</param>
    '''' <param name="Angle">The angle specifing the hypotenuse.</param>
    '''' <returns>Returns the length of the right triangles side.</returns>
    'Public Shared Function TriangleSideLength(ByVal Length As Single, ByVal Angle As Single) As Single
    '    Return CSng((Length / 2) / System.Math.Tan(Angle))
    'End Function

#Region " Displacement overloads ... "
    ''' <summary>
    ''' Moves a position using an angle and speed value.
    ''' </summary>
    ''' <param name="P">The start position.</param>
    ''' <param name="Speed">The speed (distance) to move the position.</param>
    ''' <param name="Angle">The angle that the position will be moved along.</param>
    ''' <param name="Displacement">Will be set to the move position.</param>
    Public Shared Sub Displacement(ByVal P As PointF, ByVal Speed As Single, ByVal Angle As Single, ByRef Displacement As PointF)
        Displacement.X = CSng(P.X + (System.Math.Cos(Angle) * Speed))
        Displacement.Y = CSng(P.Y + (System.Math.Sin(Angle) * Speed))
    End Sub

    ''' <summary>
    ''' Moves a position using an angle and speed value.
    ''' </summary>
    ''' <param name="V">The start position.</param>
    ''' <param name="Speed">The speed (distance) to move the position.</param>
    ''' <param name="Angle">The angle that the position will be moved along.</param>
    ''' <param name="Displacement">Will be set to the move position.</param>
    Public Shared Sub Displacement(ByVal V As Vector2, ByVal Speed As Single, ByVal Angle As Single, ByRef Displacement As PointF)
        Displacement.X = CSng(V.X + (System.Math.Cos(Angle) * Speed))
        Displacement.Y = CSng(V.Y + (System.Math.Sin(Angle) * Speed))
    End Sub

    ''' <summary>
    ''' Moves a position using an angle and speed value.
    ''' </summary>
    ''' <param name="P">The start position.</param>
    ''' <param name="Speed">The speed (distance) to move the position.</param>
    ''' <param name="Angle">The angle that the position will be moved along.</param>
    ''' <param name="Displacement">Will be set to the move position.</param>
    Public Shared Sub Displacement(ByVal P As PointF, ByVal Speed As Single, ByVal Angle As Single, ByRef Displacement As Vector2)
        Displacement.X = CSng(P.X + (System.Math.Cos(Angle) * Speed))
        Displacement.Y = CSng(P.Y + (System.Math.Sin(Angle) * Speed))
    End Sub

    ''' <summary>
    ''' Moves a position using an angle and speed value.
    ''' </summary>
    ''' <param name="V">The start position.</param>
    ''' <param name="Speed">The speed (distance) to move the position.</param>
    ''' <param name="Angle">The angle that the position will be moved along.</param>
    ''' <param name="Displacement">Will be set to the move position.</param>
    Public Shared Sub Displacement(ByVal V As Vector2, ByVal Speed As Single, ByVal Angle As Single, ByRef Displacement As Vector2)
        Displacement.X = CSng(V.X + (System.Math.Cos(Angle) * Speed))
        Displacement.Y = CSng(V.Y + (System.Math.Sin(Angle) * Speed))
    End Sub

    ''' <summary>
    ''' Moves a position using an angle and speed value.
    ''' </summary>
    ''' <param name="X">The start X position.</param>
    ''' <param name="Y">The start Y position.</param>
    ''' <param name="Speed">The speed (distance) to move the position.</param>
    ''' <param name="Angle">The angle that the position will be moved along.</param>
    ''' <param name="NewX">Will be set to the move position.</param>
    ''' <param name="NewY">Will be set to the move position.</param>
    Public Sub Displacement(ByVal X As Single, ByVal Y As Single, ByVal Speed As Single, ByVal Angle As Single, _
                                   ByRef NewX As Single, ByRef NewY As Single)
        NewX = CSng(X + (System.Math.Cos(Angle) * Speed))
        NewY = CSng(Y + (System.Math.Sin(Angle) * Speed))
        'Dim M As Matrix
        'M.Translate(1, 0, 0)
        'M.Multiply(Matrix.RotationZ(Angle))
        'M.Multiply(Matrix.Translation(X, Y, 0))
        'NewX = M.M41
        'NewX = M.M42
    End Sub

    ''' <summary>
    ''' Moves a position using an angle and speed value.
    ''' </summary>
    ''' <param name="What">Specifies what axis to move.</param>
    ''' <param name="Speed">The speed (distance) to move the position.</param>
    ''' <param name="Angle">The angle that the position will be moved along.</param>
    ''' <returns>Returns the moved position.</returns>
    Public Shared Function Displacement(ByVal What As Displacement, ByVal Speed As Single, ByVal Angle As Single) As Single
        Select Case What
            Case CBX.Libs.DX9ToolsR4.Displacement.X
                Return CSng(System.Math.Cos(Angle) * Speed)

            Case CBX.Libs.DX9ToolsR4.Displacement.Y
                Return CSng(System.Math.Sin(Angle) * Speed)

            Case Else
                'ERR: handle error
        End Select
    End Function
#End Region

End Class
