'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: October 22, 2003
'=============================================

''' <summary>
''' The Sprites namespace contains types that are specific to working with sprites.
''' </summary>
Namespace Sprites
    ''' <summary>
    ''' The ISpriteTransform interface. 
    ''' </summary>
    Public Interface ISpriteTransform
        ''' <summary>
        ''' Gets/Sets the value of the Scaling property for the sprite.
        ''' </summary>
        ''' <returns>Returns a Vector2 structure.</returns>
        Property Scaling() As Vector2
        ''' <summary>
        ''' Gets/Sets the value of the RotationCenter property for the sprite.
        ''' </summary>
        ''' <returns>Returns a Vector2 structure.</returns>
        Property RotationCenter() As Vector2
        ''' <summary>
        ''' Gets/Sets the sprites rotation value in radians.
        ''' </summary>
        ''' <returns>Returns a single.</returns>
        Property Rotation() As Single
        ''' <summary>
        ''' Gets/Sets the value of the Translation property for the sprite.
        ''' </summary>
        ''' <returns>Returns a Vector2 structure.</returns>
        Property Translation() As Vector2
        ''' <summary>
        ''' Gets/Sets the color value of the sprite.
        ''' </summary>
        ''' <returns>Returns a Color.</returns>
        Property Color() As Color
        ''' <summary>
        ''' Gets/Sets the value of the TransformMatrix property for the sprite.
        ''' </summary>
        ''' <returns>Returns a Matrix structure.</returns>
        Property TransformMatrix() As Matrix
        ''' <summary>
        ''' Gets/Sets weather or not to use the TransformMatrix to render the sprite.
        ''' </summary>
        ''' <returns>If True the object should use the TransformMatrix property to render the sprite.</returns>
        Property UseTransformMatrix() As Boolean
    End Interface

    ''' <summary>
    ''' The ISpriteTransformTextured interface. 
    ''' </summary>
    ''' <Remarks>
    ''' This interface inherits ISpriteTransform.
    ''' </Remarks>
    Public Interface ISpriteTransformTextured
        Inherits ISpriteTransform

        ''' <summary>
        ''' Gets/Sets the SourceRectangle to use for the sprite when rendering.
        ''' </summary>
        ''' <returns>Returns a Rectangle structure.</returns>
        Property SourceRectangle() As Rectangle
        ''' <summary>
        ''' Gets/Sets the TextureIndex. The TextureIndex represents a index into a collection.
        ''' </summary>
        ''' <returns>Returns a integer as an index.</returns>
        Property TextureIndex() As Integer
        ''' <summary>
        ''' Gets/Sets a reference to an actual Direct3D.Texture texture.
        ''' </summary>
        ''' <returns>Returns a reference to a Direct3D.Texture.</returns>
        Property Texture() As Direct3D.Texture
        ''' <summary>
        ''' Gets/Sets a a boolean value to determin weather or not to use the TextureIndex property and a .
        ''' </summary>
        ''' <returns>If True the object should use the TextureIndex property to retrieve a texture reference from a collection for the sprite.</returns>
        Property UseTextureIndex() As Boolean
    End Interface
End Namespace