'Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: March 22, 2003
'=============================================

''' <summary>
''' The Sprites namespace contains types that are specific to working with sprites.
''' </summary>
Namespace Sprites

    ''' <summary>
    ''' This class is a base class that implements the ISpriteTransform interface.
    ''' </summary>
    Public Class SpriteTransform
        Implements DX9ToolsR4.Sprites.ISpriteTransform

        ''' <summary>
        ''' Gets/Sets the value of the Scaling property for the sprite.
        ''' </summary>
        Protected mobjScaling As Vector2
        ''' <summary>
        ''' Gets/Sets the value of the RotationCenter property for the sprite.
        ''' </summary>
        Protected mobjRotationCenter As Vector2
        ''' <summary>
        ''' Gets/Sets the sprites rotation value in radians.
        ''' </summary>
        Protected msngRotation As Single
        ''' <summary>
        ''' Gets/Sets the value of the Translation property for the sprite.
        ''' </summary>
        Protected mobjTranslation As Vector2
        ''' <summary>
        ''' Gets/Sets the color value of the sprite.
        ''' </summary>
        Protected mobjColor As Color
        ''' <summary>
        ''' Gets/Sets the value of the TransformMatrix property for the sprite.
        ''' </summary>
        Protected mobjTransformMatrix As Matrix
        ''' <summary>
        ''' Gets/Sets weather or not to use the TransformMatrix to render the sprite.
        '''  </summary>
        Protected mblnUseTransformMatrix As Boolean = False

        ''' <summary>
        ''' Creates a new instance of this class.
        ''' </summary>
        Public Sub New()
            MyBase.new()
        End Sub

        ''' <summary>
        ''' Creates a new instance of this class.
        ''' </summary>
        ''' <param name="UseMatrix">Sets the initial value of the UseTransformMatrix property.</param>
        Public Sub New(ByVal UseMatrix As Boolean)
            Me.new()
            UseTransformMatrix = UseMatrix
        End Sub

        ''' <summary>
        ''' Gets/Sets the color value of the sprite.
        ''' </summary>
        ''' <returns>Returns a Color.</returns>
        Public Property Color() As System.Drawing.Color Implements CBX.Libs.DX9ToolsR4.Sprites.ISpriteTransform.Color
            Get
                Return mobjColor
            End Get
            Set(ByVal Value As System.Drawing.Color)
                mobjColor = Value
            End Set
        End Property

        ''' <summary>
        ''' Gets/Sets the sprites rotation value in radians.
        ''' </summary>
        ''' <returns>Returns a single.</returns>
        Public Property Rotation() As Single Implements CBX.Libs.DX9ToolsR4.Sprites.ISpriteTransform.Rotation
            Get
                Return msngRotation
            End Get
            Set(ByVal Value As Single)
                msngRotation = Value
            End Set
        End Property

        ''' <summary>
        ''' Gets/Sets the value of the RotationCenter property for the sprite.
        ''' </summary>
        ''' <returns>Returns a Vector2 structure.</returns>
        Public Property RotationCenter() As Microsoft.DirectX.Vector2 Implements CBX.Libs.DX9ToolsR4.Sprites.ISpriteTransform.RotationCenter
            Get
                Return mobjRotationCenter
            End Get
            Set(ByVal Value As Microsoft.DirectX.Vector2)
                mobjRotationCenter = Value
            End Set
        End Property

        ''' <summary>
        ''' Gets/Sets the value of the Scaling property for the sprite.
        ''' </summary>
        ''' <returns>Returns a Vector2 structure.</returns>
        Public Property Scaling() As Microsoft.DirectX.Vector2 Implements CBX.Libs.DX9ToolsR4.Sprites.ISpriteTransform.Scaling
            Get
                Return mobjScaling
            End Get
            Set(ByVal Value As Microsoft.DirectX.Vector2)
                mobjScaling = Value
            End Set
        End Property

        ''' <summary>
        ''' Gets/Sets the value of the TransformMatrix property for the sprite.
        ''' </summary>
        ''' <returns>Returns a Matrix structure.</returns>
        Public Property TransformMatrix() As Microsoft.DirectX.Matrix Implements CBX.Libs.DX9ToolsR4.Sprites.ISpriteTransform.TransformMatrix
            Get
                Return mobjTransformMatrix
            End Get
            Set(ByVal Value As Microsoft.DirectX.Matrix)
                mobjTransformMatrix = Value
            End Set
        End Property

        ''' <summary>
        ''' Gets/Sets the value of the Translation property for the sprite.
        ''' </summary>
        ''' <returns>Returns a Vector2 structure.</returns>
        Public Property Translation() As Microsoft.DirectX.Vector2 Implements CBX.Libs.DX9ToolsR4.Sprites.ISpriteTransform.Translation
            Get
                Return mobjTranslation
            End Get
            Set(ByVal Value As Microsoft.DirectX.Vector2)
                mobjTranslation = Value
            End Set
        End Property

        ''' <summary>
        ''' Gets/Sets weather or not to use the TransformMatrix to render the sprite.
        ''' </summary>
        ''' <returns>If True the object should use the TransformMatrix property to render the sprite.</returns>
        Public Property UseTransformMatrix() As Boolean Implements CBX.Libs.DX9ToolsR4.Sprites.ISpriteTransform.UseTransformMatrix
            Get
                Return mblnUseTransformMatrix
            End Get
            Set(ByVal Value As Boolean)
                mblnUseTransformMatrix = Value
            End Set
        End Property
    End Class
End Namespace







