'Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: March 22, 2003
'=============================================

''' <summary>
''' The Sprites namespace contains types that are specific to working with sprites.
''' </summary>
Namespace Sprites

    ''' <summary>
    ''' This class inherits from SpriteTransform and implements the ISpriteTransformTextured interface.
    ''' </summary>
    Public Class SpriteTransformTextured
        Inherits SpriteTransform
        Implements DX9ToolsR4.Sprites.ISpriteTransformTextured

               ''' <summary>
        ''' Gets/Sets the SourceRectangle to use for the sprite when rendering.
        ''' </summary>
        Protected mobjSourceRectangle As Rectangle
        ''' <summary>
        ''' Gets/Sets the TextureIndex. The TextureIndex represents a index into a collection.
        ''' </summary>
        Protected mintTextureIndex As Integer
              ''' <summary>
        ''' Gets/Sets a reference to an actual Direct3D.Texture texture.
        ''' </summary>
        Protected mobjTexture As Direct3D.Texture
        ''' <summary>
        ''' Gets/Sets a a boolean value to determin weather or not to use the TextureIndex property.
        ''' </summary>
        Protected mblnUseTextureIndex As Boolean = False


        ''' <summary>
        ''' Creates a new instance of this class.
        ''' </summary>
        Public Sub New()
            MyBase.new()
        End Sub

        ''' <summary>
        ''' Creates a new instance of this class.
        ''' </summary>
        ''' <param name="UseTexIndex">Sets the initial value of the UseTextureIndex property.</param>
        Public Sub New(ByVal UseTexIndex As Boolean)
            MyBase.new(UseTexIndex)
        End Sub

        ''' <summary>
        ''' Creates a new instance of this class.
        ''' </summary>
        ''' <param name="UseTexIndex">Sets the initial value of the UseTextureIndex property.</param>
        ''' <param name="UseTransformMatrix">Sets the initial value of the UseTransformMatrix property.</param>
        Public Sub New(ByVal UseTexIndex As Boolean, ByVal UseTransformMatrix As Boolean)
            MyBase.new(UseTransformMatrix)

            UseTextureIndex = UseTexIndex
            Me.UseTransformMatrix = UseTransformMatrix
        End Sub

               ''' <summary>
        ''' Gets/Sets the SourceRectangle to use for the sprite when rendering.
        ''' </summary>
        ''' <returns>Returns a Rectangle structure.</returns>
        Public Property SourceRectangle() As System.Drawing.Rectangle Implements CBX.Libs.DX9ToolsR4.Sprites.ISpriteTransformTextured.SourceRectangle
            Get
                Return mobjSourceRectangle
            End Get
            Set(ByVal Value As System.Drawing.Rectangle)
                mobjSourceRectangle = Value
            End Set
        End Property

               ''' <summary>
        ''' Gets/Sets a reference to an actual Direct3D.Texture texture.
        ''' </summary>
        ''' <returns>Returns a reference to a Direct3D.Texture.</returns>
        Public Property Texture() As Microsoft.DirectX.Direct3D.Texture Implements CBX.Libs.DX9ToolsR4.Sprites.ISpriteTransformTextured.Texture
            Get
                Return mobjTexture
            End Get
            Set(ByVal Value As Microsoft.DirectX.Direct3D.Texture)
                mobjTexture = Value
            End Set
        End Property

        ''' <summary>
        ''' Gets/Sets the TextureIndex. The TextureIndex represents a index into a collection.
        ''' </summary>
        ''' <returns>Returns a integer as an index.</returns>
        Public Property TextureIndex() As Integer Implements CBX.Libs.DX9ToolsR4.Sprites.ISpriteTransformTextured.TextureIndex
            Get
                Return mintTextureIndex
            End Get
            Set(ByVal Value As Integer)
                mintTextureIndex = Value
            End Set
        End Property

               ''' <summary>
        ''' Gets/Sets a a boolean value to determin weather or not to use the TextureIndex property.
        ''' </summary>
        ''' <returns>If True the object should use the TextureIndex property to retrieve a texture reference from a collection for the sprite.</returns>
        Public Property UseTextureIndex() As Boolean Implements CBX.Libs.DX9ToolsR4.Sprites.ISpriteTransformTextured.UseTextureIndex
            Get
                Return mblnUseTextureIndex
            End Get
            Set(ByVal Value As Boolean)
                mblnUseTextureIndex = Value
            End Set
        End Property
    End Class
End Namespace