'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: August 4, 2003
'=============================================

#If TRACE = True Then
Friend Module TraceModule
    Private mobjTL As DebugLogFileWriterTraceListener
    Private Const cmstrFile As String = "DX9ToolsDebugLog.xml"
    Private Const cmstrName As String = "DebugLogger"
    Private glngSetupTracerCount As Long = 0

    Public Sub SetupTracers()
        Try
            Dim strFile As String

            glngSetupTracerCount += 1
            If Not mobjTL Is Nothing Then Exit Sub

            Try
                strFile = IO.Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.Personal), cmstrFile)
                mobjTL = New DebugLogFileWriterTraceListener(strFile)
                Trace.Listeners.Add(mobjTL)
                Trace.IndentSize = 4

            Catch ex As Exception
                'ERR: handle error?
            End Try

        Catch ex As Exception
            'ERR: handle error?
        End Try
    End Sub

    Public Sub ShutdownTracers()
        Try
            glngSetupTracerCount -= 1
            If glngSetupTracerCount <= 0 Then


                Try
                    If Not mobjTL Is Nothing Then
                        Trace.Listeners.Remove(mobjTL)
                        'mobjTL.Flush()
                        'Application.DoEvents()

                        mobjTL.Close()
                        mobjTL.Dispose()
                        mobjTL = Nothing
                    End If
                Catch ex As Exception
                    'ERR: handle error?
                End Try
            End If

        Catch ex As Exception
            'ERR: handle error?
        End Try
    End Sub

    Public Sub TCompleted(ByVal Msg As String, Optional ByVal Writeline As Boolean = True)
        Try
            mobjTL.WriteEntry(DebugLogFileWriterTraceListener.EntryType.Compleated, Msg)

        Catch ex As Exception
            'ERR: handle error?
        End Try
    End Sub

    Public Sub TInfo(ByVal Msg As String)
        Try
            mobjTL.WriteEntry(DebugLogFileWriterTraceListener.EntryType.Information, Msg)

        Catch ex As Exception
            'ERR: handle error?
        End Try
    End Sub

    Public Sub TInfo(ByVal Msg As String, ByVal Source As String)
        Try
            mobjTL.WriteEntry(DebugLogFileWriterTraceListener.EntryType.Information, Msg, Source)

        Catch ex As Exception
            'ERR: handle error?
        End Try
    End Sub

    Public Sub TWrite(ByVal Msg As String, Optional ByVal Writeline As Boolean = True)
        Try
            If Writeline Then
                Trace.WriteLine(Msg)
            Else
                Trace.Write(Msg)
            End If

        Catch ex As Exception
            'ERR: handle error?
        End Try
    End Sub

    Public Sub TEnter(ByVal Msg As String, Optional ByVal Writeline As Boolean = True)
        Try
            mobjTL.WriteEntry(DebugLogFileWriterTraceListener.EntryType.Entering, Msg)
            Trace.Indent()

        Catch ex As Exception
            'ERR: handle error?
        End Try
    End Sub

    Public Sub TExit(ByVal Msg As String, Optional ByVal Writeline As Boolean = True)
        Try
            Trace.Unindent()
            mobjTL.WriteEntry(DebugLogFileWriterTraceListener.EntryType.Exiting, Msg)

        Catch ex As Exception
            'ERR: handle error?
        End Try
    End Sub

    Public Sub TDataDump(ByVal Data As String, ByVal VaribleName As String, ByVal Source As String)
        Try
            mobjTL.WriteEntry(DebugLogFileWriterTraceListener.EntryType.DataDump, Data, VaribleName, Source)

        Catch ex As Exception
            'ERR: handle error?
        End Try
    End Sub

    Public Sub TDataDump(ByVal Data As String, ByVal Source As String)
        Try
            mobjTL.WriteEntry(DebugLogFileWriterTraceListener.EntryType.DataDump, Data, Source)

        Catch ex As Exception
            'ERR: handle error?
        End Try
    End Sub

    Public Sub TDataDump(ByVal Data As String)
        Try
            mobjTL.WriteEntry(DebugLogFileWriterTraceListener.EntryType.DataDump, Data)

        Catch ex As Exception
            'ERR: handle error?
        End Try
    End Sub
End Module
#End If