'Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: April 11, 2003
'=============================================

Public Class Engine
    Private mobjMap As Map
    Private mobjTextures As DX9ToolsR4.SimpleTextureCollection
    Private mobjGraphics As DX9ToolsR4.DX9Graphics
    Private mblnGameLoaded As Boolean = False
    Private mblnRunning As Boolean = False
    Private mstrGameFile As String
    Private mintPanOffset As Vector2

    Public ReadOnly Property Map() As Map
        Get
            Return mobjMap
        End Get
    End Property

    Public Sub New()
        mobjMap = New Map()
        mobjTextures = New DX9ToolsR4.SimpleTextureCollection()
    End Sub

    Public Sub LoadGameFile(ByVal GameFile As String)
        mstrGameFile = GameFile
        mblnGameLoaded = True
    End Sub

    Public Sub UnloadLoadGameFile()
        mstrGameFile = ""
        mblnGameLoaded = False
    End Sub

    Public Sub Run(ByVal CTRL As Control, ByVal FullScreen As Boolean)
        InitGraphics(CTRL, FullScreen)
        mblnRunning = True
    End Sub

    Public Sub Update()
        With mobjGraphics
            .Clear()
            .Device.BeginScene()

            ' render scene

            .Device.EndScene()
            .Present()
        End With
    End Sub

    Private Sub InitGraphics(ByVal CTRL As Control, ByVal FullScreen As Boolean)
        Dim Fmt As Direct3D.Format

        ' init graphics
        If FullScreen Then
            If Not mobjGraphics.ModeAvailible(0, 640, 480, DirectX.Direct3D.Format.X8R8G8B8) Then
                If Not mobjGraphics.ModeAvailible(0, 640, 480, DirectX.Direct3D.Format.A8R8G8B8) Then
                    If Not mobjGraphics.ModeAvailible(0, 640, 480, DirectX.Direct3D.Format.R8G8B8) Then
                        Throw New Exception()
                    Else
                        Fmt = DirectX.Direct3D.Format.R8G8B8
                    End If
                Else
                    Fmt = DirectX.Direct3D.Format.A8B8G8R8
                End If
            Else
                Fmt = DirectX.Direct3D.Format.X8R8G8B8
            End If

            mobjGraphics = New DX9ToolsR4.DX9Graphics(CTRL, 640, 480, Fmt, 0)
        Else
            mobjGraphics = New DX9ToolsR4.DX9Graphics(CTRL)
        End If
    End Sub

    Public ReadOnly Property IsRunning() As Boolean
        Get
            Return mblnRunning
        End Get
    End Property

    Protected Overrides Sub Finalize()
        MyBase.Finalize()
        If mblnGameLoaded Then Me.UnloadLoadGameFile()
    End Sub
End Class